c to fix: interpolation in rcirc does not seem to work well. after 
c that, hope that things come together!

! fip: changed central sig0 to be equal (except for a factor sigroz) to
! central z dispersion

      program diskdf
      parameter(nrmax=1000)
      parameter (pi=3.1415926535)
      dimension drat(0:nrmax),
     +          dz2rat(0:nrmax),
     +          fzrat(0:nrmax)
      dimension d0rat(0:nrmax),d1rat(0:nrmax),d2rat(0:nrmax),d3rat(0:nrmax),
     +          d4rat(0:nrmax)
      dimension fplot(0:10*nrmax),rplot(0:10*nrmax)
      dimension ibuf(100)
      character*60 filename

      common /fileroot/ filename
      common /potconstants/ apot(20,0:20000), frad(20,0:20000), 
     +     dr, nr, lmax, potcor
      common /legendre/ plcon(0:40)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      common /diskpars/ sigr0, disksr, nrdisk
      common /splines/ rr(0:nrmax),fdrat(0:nrmax),drat2(0:nrmax),
     +                 fszrat(0:nrmax),szrat2(0:nrmax), nrspl

c      write(0,*) 'Root name for potential?'
c      read(*,'(a60)') filename
      write(0,*) 'Central velocity dispersion, scale length of sigR**2?'
      read(*,*) sigroz,disksr
      write(0,*) 'number of radial steps for correction fns (min. 6)?'
      read(*,*) nrspl
      write(0,*) 'number of iterations?'
      read(*,*) niter


      filename='dbh.dat'
      call readharmfile(filename,ibuf)

      psi00=pot(0.0,0.0)
      rmax = nrdisk*dr

      sigr0=sigroz*sqrt(3.1415*zdisk*diskdensf(0.,0.)*2.0*zdisk)

      drspl = (outdisk + 2*drtrunc)/nrspl
      do ir=0,nrspl
        rr(ir)=drspl*ir
        fdrat(ir)=1
        fszrat(ir)=1
      enddo
c      drspl=(outdisk-2*drtrunc)/(nrspl-4)
c      do ir=0,nrspl-4
c        rr(ir)=drspl*ir
c        fdrat(ir)=1
c        fszrat(ir)=1
c        enddo
c      do ir=3,0,-1
c        rr(nrspl-ir)=outdisk+(2-ir)*drtrunc
c        fdrat(nrspl-ir)=1
c        fszrat(nrspl-ir)=1
c     enddo
      call splined(rr(0),fdrat(0),nrspl+1,1.e32,1.e32,drat2(0))
      call splined(rr(0),fszrat(0),nrspl+1,1.e32,1.e32,szrat2(0))

      open(12,file='cordbh.dat',status='unknown')

c Make niter iterations on the correction functions for midplane density
c and vertical velocity dispersion.
      do icor=1,niter
       do ir=0,nrspl
        r=rr(ir)
        call omekap(r,fom,fka)
        sigr=sqrt(sigr2(r))
        sigz=sqrt(sigz2(r))
        vc=r*fom
        d0=0
        dz=0
        dz2=0
        dz3=0
        dsz=0
c integrate analytically over vr and vz, numerically over vphi
        dvr=0.1*sigr
        do ivt=1,101
           vt=vc+(ivt-51)*dvr
           df=diskdf5intez(vt,r,0.0)
           c=0.333333333333*(mod(ivt,2)*2+2)
           d0=d0+c*dvr*df
           df=diskdf5intez(vt,r,zdisk)
           dz2=dz2+c*dvr*df
           enddo
        drat(ir)=d0/diskdensf(r,0.)
        dz2rat(ir)=dz2/diskdensf(r,zdisk)
        fzrat(ir)=log(diskdensf(r,0.)/diskdensf(r,zdisk))/log(d0/dz2)
c        write(*,*) 'density=',d0
        enddo
       write(0,*)
       nrd=max(1,nrspl/10)
       write(0,'(''      r: '',11f6.3)') (rr(ir),ir=0,nrspl,nrd)
       write(0,'(f6.3,''  d'',11f6.3)') 0.,(drat(ir),ir=0,nrspl,nrd)
       write(0,'(f6.3,''  d'',11f6.3)') zdisk,(dz2rat(ir),ir=0,nrspl,nrd)
       do ir=0,nrspl
        fdrat(ir)=fdrat(ir)/drat(ir)
        fszrat(ir)=fszrat(ir)/fzrat(ir)
        enddo
       call splined(rr(0),fdrat(0),nrspl+1,1.e32,1.e32,drat2(0))
       call splined(rr(0),fszrat(0),nrspl+1,1.e32,1.e32,szrat2(0))
c       do ir=0,nrspl
c        r = rr(ir)
c        call splintd(rr(0),fdrat(0),drat2(0),nrspl+1,r,fd)
c        call splintd(rr(0),fszrat(0),szrat2(0),nrspl+1,r,fz)
c        write(11,'(x,5g12.5)') rr(ir),fdrat(ir), fd, fszrat(ir), fz
c        enddo
c       do ir=0,nrspl*10-1
c        r=rr(ir/10)+(rr(ir/10+1)-rr(ir/10))*0.1*mod(ir,10)
c        call splintd(rr(0),fdrat(0),drat2(0),nrspl+1,r,fd)
c        call splintd(rr(0),fszrat(0),szrat2(0),nrspl+1,r,fz)
c        write(11,'(x,3g12.5)') r,fd,fz
c        enddo
       print*,'sigr0,sigz0:', sigr0,sqrt(sigz2(0.))
       sigr0=sigroz*sqrt(sigz2(0.))
       enddo

      rfid = 2.5*rdisk
      call omekap(rfid,fom,fka)
      sigr = sqrt(sigr2(rfid))
      sigden = diskdensf(rfid,0.0)*2.0*zdisk
      print*,'central surfdens:',diskdensf(0.,0.0)*2.0*zdisk
c
c a close estimate of the disk surface density
c
      sigrcrit = 3.36*sigden/fka
      qtoomre = sigr/sigrcrit
      write(0,*) 'Toomre Q = ',qtoomre, ' at R = 2.5 R_d'
c first call initializes the spline fitting functions by the way
      call omekap(outdisk,fom,fka)

      write(0,'('' ==> Outer dispersion, truncation dispersion:'',2g10.3)')
     +  sqrt(sigr2(outdisk)),drtrunc*fka
      if (sqrt(sigr2(outdisk)).gt.drtrunc*fka) then
        write(0,*) '** WARNING **: you have asked for an outer velocity'
        write(0,*) '  dispersion which is larger than that used in the'
        write(0,*) '  disk truncation. Strange things may happen.'
        endif



c Finally, write out a more detailed table of residuals.
      do ir=0,nrspl
        r=rr(ir)
        call omekap(r,fom,fka)
        sigr=sqrt(sigr2(r))
        sigz=sqrt(sigz2(r))
        vc=r*fom
        d0=0
        d1=0
        d2=0
        d3=0
        d4=0
c integrate analytically over vr and vz, numerically over vphi
        dvr=0.1*sigr
        do ivt=1,101
           vt=vc+(ivt-51)*dvr
           df=diskdf5intez(vt,r,0.)
           c=0.333333333333*(mod(ivt,2)*2+2)
           d0=d0+c*dvr*df
           df=diskdf5intez(vt,r,0.5*zdisk)
           d1=d1+c*dvr*df
           df=diskdf5intez(vt,r,zdisk)
           d2=d2+c*dvr*df
           df=diskdf5intez(vt,r,1.5*zdisk)
           d3=d3+c*dvr*df
           df=diskdf5intez(vt,r,2*zdisk)
           d4=d4+c*dvr*df
           enddo
        d0rat(ir)=d0/diskdensf(r,0.)
        d1rat(ir)=d1/diskdensf(r,0.5*zdisk)
        d2rat(ir)=d2/diskdensf(r,zdisk)
        d3rat(ir)=d3/diskdensf(r,1.5*zdisk)
        d4rat(ir)=d4/diskdensf(r,2*zdisk)
        enddo
       write(0,*)
       nrd=max(1,(nrspl-1)/10+1)
       write(0,'(''      r: '',11f6.3)') (rr(ir),ir=0,nrspl,nrd)
       write(0,'(f6.3,''  d'',11f6.3)') 0.,(d0rat(ir),ir=0,nrspl,nrd)
       write(0,'(f6.3,''  d'',11f6.3)') 0.5*zdisk,(d1rat(ir),ir=0,nrspl,nrd)
       write(0,'(f6.3,''  d'',11f6.3)') zdisk,(d2rat(ir),ir=0,nrspl,nrd)
       write(0,'(f6.3,''  d'',11f6.3)') 1.5*zdisk,(d3rat(ir),ir=0,nrspl,nrd)
       write(0,'(f6.3,''  d'',11f6.3)') 2*zdisk,(d4rat(ir),ir=0,nrspl,nrd)
       write(12,'(''#'', 2g17.7,x,i4)') sigr0,disksr,nrspl
       do i=0,nrspl
          write(12,'(x,3g17.7)') rr(i),fdrat(i),fszrat(i)
       enddo
c       close(11)
       close(12)



c make plots of the correction functions.
       
       call pgbeg(0,'/ps',2,2)
       call pgsch(2.)
       write(*,*)

       do ir=0,nrspl*10-1
          rplot(ir)=rr(ir/10)+(rr(ir/10+1)-rr(ir/10))*0.1*mod(ir,10)
       enddo
       do ir=0,nrspl*10-1
          call splintd(rr(0),fdrat(0),drat2(0),nrspl+1,rplot(ir),fplot(ir))
       enddo
       
       call pgenv(0.,rplot(nrspl*10-1),0.,2.,0,0)
       call modstamp
       call pgline(nrspl*10,rplot(0),fplot(0))
       call pglabel('R',' ','Surfden Correction')
       
       do ir=0,nrspl*10-1
          call splintd(rr(0),fszrat(0),szrat2(0),nrspl+1,rplot(ir),fplot(ir))
       enddo
       
       call pgenv(0.,rplot(nrspl*10-1),0.,2.,0,0)
       call pgline(nrspl*10,rplot(0),fplot(0))
       call pglabel('R',' ','sigz**2 Correction')

       call modstamp

       call pgend
       

      end

      function densrpsi(r,psi)
      parameter (pi=3.1415926535, sq8=2.828427125)

      common /potconstants/ apot(20,0:20000), fr(20,0:20000), 
     +     dr, nr, lmax, potcor
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea

c Lowered Evans density      
      if (psi .ge. 0.0) then
         densrpsi=0
      else
         t2=sqrt(-2.*psi)
         r2 = r**2
         tpsiv02 = -2.0*psi/v02
         if( tpsiv02 .gt. 35 ) then
             e2psi = 0
         else
             e2psi = exp(-2.*psi/v02)
         endif
         densrpsi=2*pi*(
     +         (a*r2*v02*.03125 + 0.125*b)*v03
     +        *erfcen(2.0*t2/v0)*e2psi*e2psi
     +        +(c-a*r2*v02/2-b)*v03/sq8
     +        *erfcen(2.0*sqrt(-psi)/v0)*e2psi
     +        +a*v02*r2*(0.375*v02-psi/3.)*t2+b*0.5*v02*t2
     +        +c*(4./3.*psi-v02)*t2)
c         if (densrpsi.lt.0.) write(*,*) 'negative densrpsi at r,psi=',r,psi,densrpsi
         endif
      return
      end

      program getfreqs

      include 'commonblocks'

      real psi0mpsid

      real potmaj(0:nmax),
     +     potmajtot(0:nmax),potup(0:nmax),surden(0:nmax),
     +     potmin(0:nmax),vcmaj(0:nmax),vctot(0:nmax),
     +     vertfreq(0:nmax),vcbulge(0:nmax),
     +     vertfreqbulge(0:nmax),psi2(0:nmax)

c  constants for legendre polynomials
      do l=0,40
         plcon(l) = sqrt((2*l+1)/(4.0*pi))
      enddo
      open(14,file='dbh.dat',status='old')
      read(14,*)
      read(14,'(2x,7g15.5,i6,i4)') chalo,v0,a,nnn,v0bulge,abulge,
     +     dr,nr,lmax
      read(14,*)
      read(14,'(2x,3g15.8)') psi0, haloconst, bulgeconst
      read(14,*)
      read(14,'(2x,5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
      read(14,*)
      read(14,'(2x,3g15.5)') psic,psi0mpsid,bhmass
      psid = psi0 - psi0mpsid
      read(14,'(2x,4i5)') idiskflag, ibulgeflag, ihaloflag, ibhflag
      read(14,*)
      write(0,'(1x,''Harmonics up to l='',i4)') lmax
c
c READ HARMONICS IN FILE FILE INTO APOT ARRAY
c THESE CAN THEN BE USED BY POT(R,Z) TO GIVE THE CORRESPONDING FUNCTION
c
      do ir=0,nr
         read(14,*) rdummy,(adens(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)
c
c READ IN HARMONICS OF THE TOTAL POTENTIAL, TABULATE POT ON MAJ & MIN AXES
c
      do ir=0,nr
         read(14,*) rdummy,(apot(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)

      open(15,file='freqdbh.dat',status='unknown')
      do ir=0,nr
         r=ir*dr
         potmajtot(ir)=pot(r,0.)
         potmin(ir)=pot(0.,r)
      enddo
c
c READ IN HARMONICS OF RADIAL FORCE, TABULATE ROTATION CURVE
c
      do ir=0,nr
         read(14,*) rdummy,(apot(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)

      do ir=0,nr
         r=ir*dr
         vctot(ir)=sqrt(max(0.,r*pot(r,0.)))
      enddo
c
c READ IN HARMONICS OF 2ND DERIVATIVE OF PSI, TABULATE IN PSI2
c         
      do ir=0,nr
         read(14,*) rdummy,(apot(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)

      do ir=0,nr
         r=ir*dr
         psi2(ir)=pot(r,0.)
      enddo
c 
c READ IN SURFACE DENSITY OF THE DISK, TABULATE
c
      do ir=0,nr
         read(14,'(2g16.8)') rdummy,surden(ir)
         enddo
      close(14)


      drsave=dr
      nrsave=nr
c 
c NOW REPEAT FOR HALO-ONLY HARMONICS FILE
c

      open(14,file='h.dat',status='old')
      read(14,*)
      read(14,'(2x,7g15.5,i6,i4)') chalo,v0,a,nnn,v0bulge,abulge,
     +     dr,nr,lmax
      read(14,*)
      read(14,'(2x,3g15.8)') psi0, haloconst, bulgeconst
      read(14,*)
      read(14,'(2x,5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
      read(14,*)
      read(14,'(2x,3g15.5)') psic,psi0mpsid,bhmass
      psid = psi0 - psi0mpsid
      read(14,'(2x,4i5)') idiskflag, ibulgeflag, ihaloflag, ibhflag
      read(14,*)
      write(0,'(1x,''Harmonics up to l='',i4)') lmax
      if (nr.ne.nrsave .or. dr.ne.drsave) then
         write(0,*) 'radial bins do not match.'
         stop
      endif

      idiskflag=0

c
c READ HALO POTENTIAL, TABULATE IT ON MAJOR & INCLINED AXES
c

      do ir=0,nr
         read(14,*) rdummy,(adens(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)

      do ir=0,nr
         read(14,*) rdummy,(apot(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)

      do ir=0,nr
         r=ir*dr
         potmaj(ir)=pot(r,0.)
         potup(ir)=pot(r*cos(0.05),r*sin(0.05))
      enddo

c
c READ HALO RADIAL FORCE, TABULATE ITS ROTATION CURVE AND VERT FREQ
c
      do ir=0,nr
         read(14,*) rdummy,(apot(l/2+1,ir),l=0,lmax,2)
      enddo

      do ir=0,nr
         r=ir*dr
         if (ir.eq.0) then
            vcmaj(ir)=0
         else
            vcmaj(ir)=sqrt(max(0.,r*pot(r,0.)))
         endif
         if (ir.eq.0) then
            vertfreq(ir)=0
         else
            vertfreq(ir)=sqrt(max(0.,vcmaj(ir)**2+
     +           2.*(potup(ir)-potmaj(ir))/0.05**2))/r
         endif
      enddo

      close(14)

c REPEAT FOR BULGE

      if(ibulgeflag.eq.1) then

         open(14,file='b.dat',status='old')
         read(14,*)
         read(14,'(2x,7g15.5,i6,i4)') chalo,v0,a,nnn,v0bulge,abulge,
     +        dr,nr,lmax
         read(14,*)
         read(14,'(2x,3g15.8)') psi0, haloconst, bulgeconst
         read(14,*)
         read(14,'(2x,5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
         read(14,*)
         read(14,'(2x,3g15.5)') psic,psi0mpsid,bhmass
         psid = psi0 - psi0mpsid
         read(14,'(2x,4i5)') idiskflag, ibulgeflag, ihaloflag, ibhflag
         read(14,*)
         write(0,'(1x,''Harmonics up to l='',i4)') lmax         
         
         if (nr.ne.nrsave .or. dr.ne.drsave) then
            write(0,*) 'radial bins do not match.'
            stop
         endif

         idiskflag=0
c 
c READ BULGE POTENTIAL, TABULATE
c
         do ir=0,nr
            read(14,*) rdummy,(adens(l/2+1,ir),l=0,lmax,2)
         enddo
         read(14,*)
         read(14,*)
         do ir=0,nr
            read(14,*) rdummy,(apot(l/2+1,ir),l=0,lmax,2)
         enddo
         read(14,*)
         read(14,*)
         do ir=0,nr
            r=ir*dr
            potmaj(ir)=pot(r,0.)
            potup(ir)=pot(r*cos(0.05),r*sin(0.05))
         enddo
C
C READ BULGE RADIAL FORCE, MAKE ROT CURVE AND VERT FREQS.
C     
         do ir=0,nr
            read(14,*) rdummy,(apot(l/2+1,ir),l=0,lmax,2)
         enddo

         do ir=0,nr
            r=ir*dr
            if (ir.eq.0) then
               vcbulge(ir)=0
            else
               vcbulge(ir)=sqrt(max(0.,r*pot(r,0.)))
            endif
            if (ir.eq.0) then
               vertfreqbulge(ir)=0
            else
               vertfreqbulge(ir)=sqrt(vcbulge(ir)**2+
     *              2.*(potup(ir)-potmaj(ir))/0.05**2)/r
            endif
         enddo
         
         close(14)
      else
         do ir=0,nr
            vcbulge(ir) = 0.
         enddo
      endif

      write(15,'(''#'',16(3x,a10,3x))') 'RADIUS','OMEGA_H','NU_H',
     :     'SIGMA_D','VC_TOT','VC_B','NU_B','PSIMAJ_TOT','PSI'''''
      write(15,'(''#'')')

      ir=0
      write(15,'(9g16.8)') 
     +     0.,vcmaj(1)/dr,(4*vertfreq(1)-vertfreq(2))/3.,
     +     surden(ir),vctot(ir),vcbulge(ir),
     +     (4*vertfreqbulge(1)-vertfreqbulge(2))/3.,
     +     potmajtot(ir),
     +     psi2(ir)

      do ir=1,nr  
         r=ir*dr
         write(15,'(9g16.8)') r,vcmaj(ir)/r,vertfreq(ir),surden(ir),
     +           vctot(ir),vcbulge(ir),vertfreqbulge(ir),potmajtot(ir),
     +           psi2(ir)
         enddo
 99   close(15)
      end

      subroutine appdiskforce(s,z,fsad,fzad)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea

      parameter (pi=3.1415926535)

c      fsad = 0
c      fzad = 0
c      return
      r=sqrt(s*s + z*z)
      t=sqrt(0.5d0)*(r-outdisk)/drtrunc
      if (t.lt.-4.0) then
          eerfc=1.
          derfc=0.0
      elseif(t.gt.4.0) then
          eerfc = 0.0
          derfc = 0.0
      else
          eerfc=0.5*erfc(t)
          derfc = exp(-t**2)/(sqrt(2.0*pi)*drtrunc)
      endif

      r1 = r/rdisk
      if (r1.eq.0.) then
         fprime=0
         f=0
      else
          texp = diskconst*zdisk**2*exp(-r1)
          f = texp*eerfc
          fprime = -texp*(derfc + eerfc/rdisk)/r
      endif

      zz = abs(z/zdisk)
      if( zz .lt. 10 ) then
          ezz = exp(-2.0*zz)
      else
          e2zz = 0.0
      endif
      tlncoshz = zz + log(0.5*(1.0 + e2zz))

      fsad = -4.0*pi*fprime*s*tlncoshz
      fzad = -4.0*pi*(fprime*z*tlncoshz + f/zdisk*tanh(z/zdisk))

      return
      end

function rnd()
 integer dummmy
 real*4 rnd,ran1
 external ran1
 rnd=ran1(dummy)
end function

function nrnd()
 real,save :: x,r=-1    
 real :: nrnd,r1,y
 if(r.ge.0) then
  nrnd=x
  r=-1
 endif
 r=1
 do while(r.ge.1)
  x=2*rnd()-1
  y=2*rnd()-1
  r=sqrt(x*x+y*y)
 enddo
  if(r.ne.0) then
   r1=2*sqrt(-log(r))
   x=r1/r*x
   nrnd=r1/r*y
  else
   nrnd=0.
  endif
end function

function sech2rnd()
 real sech2rnd
 sech2rnd=atanh(1-2*rnd())
end function 
 
subroutine generate_gas(ngas,vdisp,iseed,m,x,y,z,vx,vy,vz,cs)
  use hydrostaticdiskMod
 real, parameter :: pi=3.141592654
 real, allocatable :: rad(:),crad(:),csigtab(:)
 real nrnd,mass,drs,vrot,fipart,rpart,rrpart,zpart,cm,dr
 integer ngas,nrs,bin,bin1,imax,i,j,jm,nfis,nr,ibuf(100)
 real m(ngas),x(ngas),y(ngas),z(ngas),vx(ngas),vy(ngas),vz(ngas),cs(ngas)
 real fr,fz,phi
 character*60 filename
 integer*8 iseed,itmp
 integer*8,parameter :: skip=100

 nrs=1000
 
 filename='dbh.dat'
 call readharmfile(filename,ibuf)
 
 call readgasdisk
 nr=nrQ()
 
 vdisp=0 
 vdispt=csQ()  
 allocate(rad(0:nr),csigtab(0:nr),crad(0:nrs))
 rad=radQ() 
 csigtab=csigtabQ()  

 imax=0
 do i=1,nr
  if(csigtab(i).GT.csigtab(imax)) imax=i
!  print*,rad(i),1-csigtab(i)/csigtab(nr)
 enddo
 mass=csigtab(imax)

 dr=rad(imax)/imax
 drs=rad(imax)/nrs
 crad(0)=0
 do i=1,nrs-1
  cm=i*mass/nrs
  do j=0,imax
   if(csigtab(j).lt.cm) jm=j
  enddo
  crad(i)=dr*jm+dr*(cm-csigtab(jm))/(csigtab(jm+1)-csigtab(jm))
 enddo
 crad(nrs)=rad(imax)

 write(0,*) 'cdisp:',vdispt
 write(0,*) 'total mass of gasdisk:',mass,nrs,drs
 write(0,*) 'rmax, mass:',rad(imax),mass/ngas

m=mass/ngas
cs=vdispt
 do i=1,ngas
   itmp=(iseed+i)*skip
   call ran_seed(itmp)
!  bin=(i-1)/nfis+1
!  rpart=sqrt(rnd()*(crad(bin)**2-crad(bin-1)**2)+crad(bin-1)**2)
  rpart=getrad(rnd())
!  fipart=2*pi*(mod(i-1,nfis)+rnd())/nfis
  fipart=2*pi*rnd()
  zpart=getz(rpart,rnd())

  x(i)=rpart*cos(fipart)
  y(i)=rpart*sin(fipart)
  z(i)=zpart
  if(rnd().GT.0.5) z(i)=-z(i)
  
  call force(rpart,zpart,fr,fz,phi)
  vrot=sqrt(max(0.,-rpart*fr))
!  vrot=sqrt(max(0.,rpart*fr))
! drift correction: checkcheck
!  print*,'zz',rpart,zpart,fr,phi
  vrot=sqrt(max(0.,vrot**2-driftcorfac(rpart)*vdispt**2))
  vx(i)=-vrot*sin(fipart)
  vy(i)=vrot*cos(fipart)
  vz(i)=0
 
  vx(i)=vx(i)+vdisp*nrnd()
  vy(i)=vy(i)+vdisp*nrnd()
  vz(i)=vz(i)+vdisp*nrnd()

 enddo
end subroutine

      program plotforce

      real rplot(0:200),zplot(0:200),vc(0:200),
     :     vd(0:200),vh(0:200),vb(0:200),fz(0:200)
      character*60 toplbl,filename
      integer*4 ibuf1(15)
      character ans

      open(20,file='scales',status='old',err=5)
      read(20,*) rscale
      write(*,*) 'Will normalize model so that vcirc(rsun)=200.'
      write(*,*) 'and will write this to "scales"'
      close(20)
      goto 6

 5    write(*,*) 'No files "scales" found.'
      write(*,*) 'Will use default length scale [4kpc] instead.'
      write(*,*) 'Will normalize forces so that vcirc(8kpc)=200.'
      rscale=4.

 6    continue

      write(*,*) 'Will plot rotation curve and Kz.'
      write(*,*) 'For rotation curve: radius bin [kpc], no. bins?'
      read(*,*) drplot,nrplot
      write(*,*) 'For Kz:  z-bin [kpc], no. bins?'
      read(*,*) dzplot,nzplot

c inititially store the radial forces in the velocity arrays

      filename='h.dat'
      call readharmfile(filename,ibuf1)

      write(*,*) 'Calculating halo rotation curve...'
      do ir=0,nrplot
         rp=ir*drplot/rscale
         rplot(ir)=rp*rscale
         call force(rp,0.,vh(ir),fz(0),p)
!	 print*,rp,vh(ir),fz(0),p
      enddo

      filename='b.dat'
      call readharmfile(filename,ibuf1)
      write(*,*) 'Calculating bulge rotation curve...'
      do ir=0,nrplot
         rp=rplot(ir)/rscale
         call force(rp,0.,vb(ir),fz,p)
      enddo

      filename='dbh.dat'
      call readharmfile(filename,ibuf1)
c      call readdiskdf(filename,ibuf1)      
c (this also reads in the dbh.dat file)
      write(*,*) 'Calculating total rotation curve...'
      do ir=0,nrplot
         rp=rplot(ir)/rscale
         call force(rp,0.,vc(ir),fz,p)
      enddo

      rsun=8.
      call force(rsun/rscale,0.,fr,fz,p)
      vcsun=sqrt(max(0.,-rsun/rscale*fr))
      vscale=200./vcsun
      emscale=rscale*vscale**2/4.3e-6

      write(*,*) 'Scales for mass, distance, speed:'
      write(*,*) emscale,' Msun, ',rscale,' kpc, ',vscale,' km/s.'
      densscale=emscale/rscale**3
      dfscale=densscale/vscale**3
      open(16,file='scales',status='unknown')
      write(16,*) rscale,'    radius scale [kpc]'
      write(16,*) vscale,'    speed scale [km/s]'
      write(16,*) emscale,'    mass scale [Msun]'
      close(16)
      vsun=vcsun*vscale
      write(*,*) 'Circular speed at R=',rsun,' kpc: ',vsun,' km/s.'

c now turn forces into circular speeds.
      vmax=-1e31
      write(*,*) 'Calculating disk rotation curve...'
      do ir=0,nrplot
         vd(ir)=vc(ir)-vh(ir)-vb(ir)
         rp=rplot(ir)/rscale
         vb(ir)=sqrt(max(0.,-rp*vb(ir)))*vscale
         vh(ir)=sqrt(max(0.,-rp*vh(ir)))*vscale
         vd(ir)=sqrt(max(0.,-rp*vd(ir)))*vscale
         vc(ir)=sqrt(max(0.,-rp*vc(ir)))*vscale
         vmax=max(vc(ir),vmax)
      enddo

      fmax=-1e31
      do iz=0,nzplot
         zp=iz*dzplot
         zplot(iz)=zp
         call force(rsun/rscale,zp/rscale,fr,fz(iz),p)
         fz(iz)=-fz(iz)*vscale**2/rscale/1000.
         fmax=max(fmax,fz(iz))
      enddo

 1    call pgbeg(0,'?',1,2)
      write(*,*)
      call pgsch(2.0)
      call pgenv(0.,rplot(nrplot),0.,vmax*1.15,0,0)
      call pgline(nrplot+1,rplot(0),vb(0))
      call pgline(nrplot+1,rplot(0),vd(0))
      call pgline(nrplot+1,rplot(0),vh(0))
      call pgline(nrplot+1,rplot(0),vc(0))
      call pgpt(1,8.,200.,12)
      call pglabel('R [kpc]','Vcirc [km/s]','ROTATION CURVES')
      
      call pgenv(0.,zplot(nzplot),0.,fmax*1.15,0,0)
      call pgline(nzplot+1,zplot(0),fz(0))
      write(toplbl,'(''z-FORCE AT R='',f6.3,'' kpc'')') rsun
      call pglabel('z [kpc]','Kz [(km/s)**2 /pc]',toplbl)
      call pgpt(1,1.1,1.9,12)
      call modstamp
      call pgend

      write(*,*) 'Same plot, different device?'
      read(*,'(a)') ans
      if (ans.ne.'n' .and. ans.ne.'N') goto 1
      end

      program getfreqs

      parameter(pi=3.1415926535)
      common /potconstants/ apot(20,0:20000), fr(20,0:20000), 
     +     dr, nr, lmax, potcor
      common/legendre/ plcon(0:40)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1

      real adens(20,0:20000),potmaj(0:20000),
     +     potmajtot(0:20000),potup(0:20000),surden(0:20000),
     +     potmin(0:20000),vcmaj(0:20000),vctot(0:20000),vertfreq(0:20000),vcbulge(0:20000),
     +     vertfreqbulge(0:20000),psi2(0:20000)

c  constants for legendre polynomials
      do l=0,40
         plcon(l) = sqrt((2*l+1)/(4.0*pi))
      enddo

      open(14,file='dbh.dat',status='old')
      read(14,*) 
      read(14,'(2x,7g15.5,i6,i4)') psi00,v0,q,a,b,c,dr,nr,lmax
      read(14,*)
      read(14,'(2x,3g15.5)') psiout,rho1,sigbulge
      read(14,*)
      read(14,'(2x,5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
      read(14,'(2x,3i5)') idiskflag, ibulgeflag, ihaloflag
      read(14,*)
      write(0,'(x,''Harmonics up to l='',i4)') lmax
c
c READ HARMONICS IN FILE FILE INTO APOT ARRAY
c THESE CAN THEN BE USED BY POT(R,Z) TO GIVE THE CORRESPONDING FUNCTION
c
      do ir=0,nr
         read(14,*) rr,(adens(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)
c
c READ IN HARMONICS OF THE TOTAL POTENTIAL, TABULATE POT ON MAJ & MIN AXES
c
      do ir=0,nr
         read(14,*) rr,(apot(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)

c      write(*,*) 'Start of total potential harmonics:'
c      do ir=0,5
c         write(*,*) ir*dr,(apot(l/2+1,ir),l=0,lmax,2)
c      enddo

      open(15,file='freqdbh.dat',status='unknown')
      do ir=0,nr
         r=ir*dr
         potmajtot(ir)=pot(r,0.)
         potmin(ir)=pot(0.,r)
      enddo
c
c READ IN HARMONICS OF RADIAL FORCE, TABULATE ROTATION CURVE
c
      do ir=0,nr
         read(14,*) rr,(apot(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)

c      write(*,*) 'Start of total radial force harmonics:'
c      do ir=0,5
c         write(*,*) ir*dr,(apot(l/2+1,ir),l=0,lmax,2)
c      enddo

      do ir=0,nr
         r=ir*dr
         vctot(ir)=sqrt(max(0.,r*pot(r,0.)))
      enddo
c
c READ IN HARMONICS OF 2ND DERIVATIVE OF PSI, TABULATE IN PSI2
c         
      do ir=0,nr
         read(14,*) rr,(apot(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)

c      write(*,*) 'Start of total potential 2nd deriv harmonics:'
c      do ir=0,5
c         write(*,*) ir*dr,(apot(l/2+1,ir),l=0,lmax,2)
c      enddo

      do ir=0,nr
         r=ir*dr
         psi2(ir)=pot(r,0.)
      enddo
c 
c READ IN SURFACE DENSITY OF THE DISK, TABULATE
c
      do ir=0,nr
         read(14,'(2g16.8)') rr,surden(ir)
         enddo
      close(14)


      drsave=dr
      nrsave=nr
c 
c NOW REPEAT FOR HALO-ONLY HARMONICS FILE
c

      open(14,file='h.dat',status='old')
      read(14,*) 
      read(14,'(2x,7g15.5,i6,i4)') psi00,v0,q,a,b,c,drsave,nrsave,lmax
      read(14,*)
      read(14,'(2x,3g15.5)') psiout,rho1,sigbulge
      read(14,*)
      read(14,'(2x,5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
      read(14,'(2x,3i5)') idiskflag, ibulgeflag, ihaloflag
      read(14,*)
      write(0,'(x,''Harmonics up to l='',i4)') lmax
      if (nr.ne.nrsave .or. dr.ne.drsave) then
         write(0,*) 'radial bins do not match.'
         stop
      endif

      idiskflag=0

c
c READ HALO POTENTIAL, TABULATE IT ON MAJOR & INCLINED AXES
c

      do ir=0,nr
         read(14,*) rr,(adens(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)

      do ir=0,nr
         read(14,*) rr,(apot(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)

c      write(*,*) 'Start of halo potential harmonics:'
c      do ir=0,5
c         write(*,*) ir*dr,(apot(l/2+1,ir),l=0,lmax,2)
c      enddo

      do ir=0,nr
         r=ir*dr
         potmaj(ir)=pot(r,0.)
         potup(ir)=pot(r*cos(0.05),r*sin(0.05))
      enddo

c
c READ HALO RADIAL FORCE, TABULATE ITS ROTATION CURVE AND VERT FREQ
c
      do ir=0,nr
         read(14,*) rr,(apot(l/2+1,ir),l=0,lmax,2)
      enddo

c      write(*,*) 'Start of halo radial force harmonics:'
c      do ir=0,5
c         write(*,*) ir*dr,(apot(l/2+1,ir),l=0,lmax,2)
c      enddo

      do ir=0,nr
         r=ir*dr
         if (ir.eq.0) then
            vcmaj(ir)=0
         else
            vcmaj(ir)=sqrt(max(0.,r*pot(r,0.)))
         endif
         if (ir.eq.0) then
            vertfreq(ir)=0
         else
            vertfreq(ir)=sqrt(max(0.,vcmaj(ir)**2+2.*(potup(ir)-potmaj(ir))/0.05**2))/r
         endif
      enddo

      close(14)

c REPEAT FOR BULGE


      open(14,file='b.dat',status='old')
      read(14,*) 
      read(14,'(2x,7g15.5,i6,i4)') psi00,v0,q,a,b,c,drsave,nrsave,lmax
      read(14,*)
      read(14,'(2x,3g15.5)') psiout,rho1,sigbulge
      read(14,*)
      read(14,'(2x,5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
      read(14,'(2x,3i5)') idiskflag, ibulgeflag, ihaloflag
      read(14,*)
      write(0,'(x,''Harmonics up to l='',i4)') lmax
      if (nr.ne.nrsave .or. dr.ne.drsave) then
         write(0,*) 'radial bins do not match.'
         stop
      endif

      idiskflag=0
c 
c READ BULGE POTENTIAL, TABULATE
c
      do ir=0,nr
         read(14,*) rr,(adens(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)
      do ir=0,nr
         read(14,*) rr,(apot(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)

c      write(*,*) 'Start of bulge potential harmonics:'
c      do ir=0,5
c         write(*,*) ir*dr,(apot(l/2+1,ir),l=0,lmax,2)
c      enddo

      do ir=0,nr
         r=ir*dr
         potmaj(ir)=pot(r,0.)
         potup(ir)=pot(r*cos(0.05),r*sin(0.05))
      enddo
C
C READ BULGE RADIAL FORCE, MAKE ROT CURVE AND VERT FREQS.
C

      do ir=0,nr
         read(14,*) rr,(apot(l/2+1,ir),l=0,lmax,2)
      enddo

c      write(*,*) 'Start of bulge radial force harmonics:'
c      do ir=0,5
c         write(*,*) ir*dr,(apot(l/2+1,ir),l=0,lmax,2)
c      enddo

      do ir=0,nr
         r=ir*dr
         if (ir.eq.0) then
            vcbulge(ir)=0
         else
            vcbulge(ir)=sqrt(max(0.,r*pot(r,0.)))
         endif
         if (ir.eq.0) then
            vertfreqbulge(ir)=0
         else
            vertfreqbulge(ir)=sqrt(vcbulge(ir)**2+2.*(potup(ir)-potmaj(ir))/0.05**2)/r
         endif
      enddo

      close(14)

      write(15,'(''#'',16(3x,a10,3x))') 'RADIUS','OMEGA_H','NU_H',
     :     'SIGMA_D','VC_TOT','VC_B','NU_B','PSIMAJ_TOT','PSI'''''
      write(15,'(''#'')')

      ir=0
      write(15,'(9g16.8)') 0.,vcmaj(1)/dr,(4*vertfreq(1)-vertfreq(2))/3.,
     +     surden(ir),
     +     vctot(ir),vcbulge(ir),(4*vertfreqbulge(1)-vertfreqbulge(2))/3.,
     +     potmajtot(ir),
     +     psi2(ir)

      do ir=1,nr  
         r=ir*dr
         write(15,'(9g16.8)') r,vcmaj(ir)/r,vertfreq(ir),surden(ir),
     +           vctot(ir),vcbulge(ir),vertfreqbulge(ir),potmajtot(ir),
     +           psi2(ir)
         enddo
 99   close(15)
      end

      subroutine gentableE

      include 'commonblocks'

      r = 0.
      rmin = dr/100.
      psi0 = gettotalpsi(r)
      psic = gettotalpsi(chalo + 5.*drtrunchalo)
      psid = gettotalpsi(rmin)
      tableE(1) = psid
      tableE(npsi) = psic
      do i=1,npsi
         xx = (psi0-psic)/(psi0-psid)
         yy = float(i-1)/float(npsi-1)
         tableE(i) = psi0 - (psi0-psid)*(xx**yy)
      enddo

      return
      end

      subroutine gendfnfw

      include 'commonblocks'

      open(file='dfnfw.dat',unit=50,status='replace')

      do i=1,npsi
         energy = tableE(i)
         dfnfw(i) = getdfnfw(energy)
         if(dfnfw(i).gt.0.) then 
            dfnfw(i) = log(dfnfw(i))
            dfnfwlast = dfnfw(i)
         else
            dfnfw(i) = dfnfwlast
         endif
         write(50,*) tableE(i),dfnfw(i)
      enddo
      close(50)

      return
     
      end

      function getdfnfw(energy)

      include 'commonblocks'
      real psi
      
      external gettotalpsi

      tmax = sqrt(energy-psic)
      dt = tmax/float(nint-1)
      psi = energy

      racc = 1e-8
      call findbrackets(gettotalpsi,psi,rmin,rmax)
      call rtbis(gettotalpsi,psi,rmin,rmax,racc,rpsi)
      d2rhodpsi2 =  getd2rhonfwdpsi2(rpsi)
      t = 0.
      sum = dt*d2rhodpsi2

      do i=1,nint-2
         t = dt*float(i)
         psi = energy - t*t
         call findbrackets(gettotalpsi,psi,rmin,rmax)
         call rtbis(gettotalpsi,psi,rmin,rmax,racc,rpsi)
         d2rhodpsi2 =  getd2rhonfwdpsi2(rpsi)
         sum = sum + 2.*dt*d2rhodpsi2
      enddo
      getdfnfw = sum/sqrt(8.)/pi/pi

      return
      end

      subroutine gendfsersic

      include 'commonblocks'

      open(file='dfsersic.dat',unit=50,status='replace')

      do i=1,npsi
         energy = tableE(i)
         dfsersic(i) = getdfsersic(energy)
         if(dfsersic(i).gt.0.) then
            dfsersic(i) = log(dfsersic(i))
            dfsersiclast = dfsersic(i)
         else
            dfsersic(i) = dfsersiclast
         endif
         write(50,*) tableE(i),dfsersic(i)
      enddo
      close(50)
      return
     
      end

      function getdfsersic(energy)

      include 'commonblocks'

      external gettotalpsi
      real psi

      tmax = sqrt(energy-psic)
      dt = tmax/float(nint-1)
      psi = energy

      racc = 1e-8
      call findbrackets(gettotalpsi,psi,rmin,rmax)
      call rtbis(gettotalpsi,psi,rmin,rmax,racc,rpsi)
      d2rhodpsi2 =  getd2rhosersicdpsi2(rpsi)
      sum = dt*d2rhodpsi2
      do i=1,nint-2
         t = dt*float(i)
         psi = energy - t*t
         call findbrackets(gettotalpsi,psi,rmin,rmax)
         call rtbis(gettotalpsi,psi,rmin,rmax,racc,rpsi)
         d2rhodpsi2 =  getd2rhosersicdpsi2(rpsi)
         sum = sum + 2.*dt*d2rhodpsi2
      enddo
      getdfsersic = sum/sqrt(8.)/pi/pi
      return
      end

      function getd2rhosersicdpsi2(rad)

      include 'commonblocks'

      real haloforce, halodens,L2

      external rtbiss,gammq,gammln

      Den = sersicdens(rad)
      Denp = sersicdensprime(rad)
      Denpp = sersicdens2prime(rad)
      Force = sersicforce(rad)

      totalden = Den
      if(ihaloflag.eq.1) then
         Force = Force + haloforce(rad)
         totalden = totalden + halodensity(rad)
      endif
      if(idiskflag.eq.1) then
         Force = Force + diskforce(rad)
         totalden = totalden + diskdensity(rad)
      endif

      bbb = 4.*pi*totalden*Denp/Force
      ccc = 2.*Denp/rad
      ddd = Denpp
      getd2rhosersicdpsi2 = (bbb + ccc + ddd)/(Force**2.)

      return
      END

      function getd2rhonfwdpsi2(rad)

      include 'commonblocks'

      real haloforce, halodensity, halodensprime, halodens2prime, L2
      
      external rtbiss,gammq,gammln

      s = rad/a

      Den = halodensity(rad)
      Denp = halodensprime(rad)
      Denpp = halodens2prime(rad)
      Force = haloforce(rad)

      totalden = Den

      if(ibulgeflag.eq.1) then

         Force = Force + sersicforce(rad)
         totalden = totalden + sersicdens(rad)

      endif

      if(idiskflag.eq.1) then
         Force = Force + diskforce(rad)
         totalden = totalden + diskdensity(rad)
      endif

      bbb = 4.*pi*totalden*Denp/Force
      ccc = 2.*Denp/rad
      ddd = Denpp
      getd2rhonfwdpsi2 = (bbb + ccc + ddd)/(Force**2.)

c      write(77,*) log10(rad),log10(Den),log10(-Denp),(Denpp),
c     +     getd2rhonfwdpsi2
         
      return
      END

      function sersicpot(rad)

      include 'commonblocks'

      real L1,L2
      external gammq,gammqm1,gammln

      if(rad.eq.0.) then
         sersicpot = v0bulge**2.
         return
      endif

      u = rad/Re
      un = u**(1./nnn)
      aaa = nnn*(3.-ppp)
      L1 = Rho0*Re*Re*nnn*butt**(nnn*(ppp-2.))*
     :     gammq(nnn*(2.-ppp),butt*un)*exp(gammln(nnn*(2.-ppp)))
      L2 = Rho0*(Re**3.)*nnn*(butt**(-aaa))*exp(gammln(aaa))
      if(aaa+1.gt.butt*un) then
         L2 = L2*gammqm1(aaa,butt*un)
      else
         L2 = L2*(1.-gammq(aaa,butt*un))
      endif
      sersicpot=4.*pi*(L2/rad + L1)

      return
      END

      subroutine setsersicparameters

      include 'commonblocks'
      common /MOUSE/ comnen
      EXTERNAL funcbutt
     
      comnen = nnn
      Re = abulge
      if (nnn.gt.0.50) then
         butt1=0.6*(2.0*nnn)
      elseif (nnn.le.0.50) then
         butt1=1.0E-4
      endif
      butt2=1.20*(2.0*nnn)
      buttacc=1.0E-4

      butt=RTBISS(funcbutt,butt1,butt2,buttacc)
c      ppp=1.0d0 - 0.6097d0/nnn + 0.05463d0/(nnn*nnn)

      Rho0 = (v0bulge**2.)/(4.*pi*Re*Re*nnn*butt**(nnn*(ppp-2.))*
     *     exp( gammln(nnn*(2.-ppp))))

      return
      end

      function sersicmass(rad)

      include 'commonblocks'

      u = rad/Re
      un = u**(1./nnn)
      aaa = nnn*(3.-ppp)
      if(aaa+1.gt.butt*un) then
         gm = gammqm1(aaa,butt*un)
      else
         gm = 1.-gammq(aaa,butt*un)
      endif
      sersicmass = 4.*pi*Rho0*(Re**3.)*nnn*(butt**(nnn*(ppp-3.)))*
     +     gm*exp(gammln(nnn*(3.-ppp)))
      
      return
      end

      function sersicdens(rad)

      include 'commonblocks'

      u = rad/Re
      un = u**(1./nnn)
      sersicdens = Rho0*(u**(-ppp))*exp(-butt*un)

      return
      end

      function sersicdensprime(rad)

      include 'commonblocks'

      u = rad/Re
      un = u**(1./nnn)
      sersicdensprime = -sersicdens(rad)/Re*(ppp*nnn+butt*un)/nnn/u

      return
      end

      function sersicdens2prime(rad)

      include 'commonblocks'

      u = rad/Re
      un = u**(1./nnn)
      sersicdens2prime = sersicdens(rad)/Re/Re*(
     :     (ppp*nnn)**2.+ppp*nnn*nnn+2.*ppp*butt*nnn*un
     :     +butt*un*(nnn-1)+(butt*un)**2.)/((nnn*u)**2.)

      return
      end

      function sersicforce(rad)

      include 'commonblocks'
      real L2

      u = rad/Re
      un = u**(1./nnn)
      aaa = nnn*(3.-ppp)

      L2 = Rho0*(Re**3.)*nnn*(butt**(-aaa))*exp(gammln(aaa))
      if(aaa+1.gt.butt*un) then
         L2 = L2*gammqm1(aaa,butt*un)
      else
         L2 = L2*(1.-gammq(aaa,butt*un))
      endif

      sersicforce = -4.*pi*(L2/rad/rad)

      return
      end
C     ------------------------------------------------------------------
       real function funcbutt(b)
       real b,abe,comnen
       external gammp
       common /MOUSE/ comnen
          abe=2.*comnen
          funcbutt=( gammp(abe,b)-0.5 )
       return
       end

       real FUNCTION rtbiss(funcbutt,x1,x2,xacc)
       INTEGER JMAX
       real x1,x2,xacc,lick
       EXTERNAL funcbutt
       common /MOUSE/ comnen
       PARAMETER (JMAX=100)
       INTEGER j
       real dx,f,fmid,xmid
       lick=comnen

c      write(6,*) 'b: ',2.*lick,x2

       fmid=gammp(2.*lick,x2)-0.5
       f=gammp(2.*lick,x1)-0.5

C      write(6,*) 'c:  F-s: ',fmid,f

       if(f*fmid.ge.0.) pause 'root must be bracketed in rtbiss'
       if(f.lt.0.)then
         rtbiss=x1
         dx=x2-x1
       else
         rtbiss=x2
         dx=x1-x2
       endif
       do 11 j=1,JMAX
         dx=dx*.5
         xmid=rtbiss+dx
         fmid=gammp(2.*lick,xmid)-0.5
         if(fmid.le.0.)rtbiss=xmid
         if(abs(dx).lt.xacc .or. fmid.eq.0.) return
11     continue
       pause 'too many bisections in rtbiss'
       END

      FUNCTION FACTLN (N)
C
      INTEGER  N
      REAL     A(100),FACTLN,GAMMLN
C
      DATA  A/100*-1.0/
C
      IF (N.LT.0) PAUSE 'negative factorial'
      IF (N.LE.99) THEN
        IF (A(N+1).LT.0.0) A(N+1)=GAMMLN(float(N)+1.0)
        FACTLN=A(N+1)
      ELSE
        FACTLN=GAMMLN(float(N)+1.0)
      ENDIF
      RETURN
      END
C
C ------------------------------------------------------------------------------
C
      FUNCTION FACTRL (N)
C
      INTEGER  N,NTOP,J
      REAL     A(33),FACTRL,GAMMLN
C
      DATA  NTOP,A(1)/0,1.0/
C
      IF (N.LT.0) THEN
        PAUSE 'negative factorial'
      ELSE IF (N.LE.NTOP) THEN
        FACTRL=A(N+1)
      ELSE IF (N.LE.32) THEN
        DO 11 J=NTOP+1,N
          A(J+1)=J*A(J)
11      CONTINUE
        NTOP=N
        FACTRL=A(N+1)
      ELSE
        FACTRL=EXP(GAMMLN(float(N)+1.0))
      ENDIF
      RETURN
      END
C
C ------------------------------------------------------------------------------
C
      FUNCTION GAMMLN (XX)
C
      INTEGER  J
      real GAMMLN
      real XX
      real   COF(6),STP,HALF,ONE,FPF,X,TMP,SER
C
      DATA  COF,STP/76.18009173D0,-86.50532033D0,24.01409822D0,
     *    -1.231739516D0,.120858003D-2,-.536382D-5,2.50662827465D0/
      DATA  HALF,ONE,FPF/0.5D0,1.0D0,5.5D0/
C
      X=XX-ONE
      TMP=X+FPF
      TMP=(X+HALF)*LOG(TMP)-TMP
      SER=ONE
      DO 11 J=1,6
        X=X+ONE
        SER=SER+COF(J)/X
11    CONTINUE
      GAMMLN=TMP+LOG(STP*SER)
      RETURN
      END
C
C ------------------------------------------------------------------------------
C
      FUNCTION GAMMP (A,X)
C
      real  GAMMP,A,X,GAMMCF,GLN
C
      IF (X.LT.0.0.OR.A.LE.0.0) PAUSE 'neg argument of gammp'
      IF (X.LT.A+1.0) THEN
        CALL GSER (GAMMP,A,X,GLN)
      ELSE
        CALL GCF (GAMMCF,A,X,GLN)
        GAMMP=1.0-GAMMCF
      ENDIF
      RETURN
      END
C
C ------------------------------------------------------------------------------
C
      FUNCTION GAMMQ (A,X)
C
      real GAMMQ,X,A,GAMSER,GLN
C

      IF (X.LT.0.0.OR.A.LE.0.0) PAUSE 'neg argument of gammq'
      IF (X.LT.A+1.0) THEN
        CALL GSER (GAMSER,A,X,GLN)
        GAMMQ=1.0-GAMSER
      ELSE
        CALL GCF (GAMMQ,A,X,GLN)
      ENDIF
      RETURN
      END
C

      FUNCTION GAMMQm1 (A,X)
C
      real  GAMMQm1,X,A,GAMSER,GLN
C
      IF (X.LT.0.0.OR.A.LE.0.0) PAUSE 'neg argument of gammqm1'
      CALL GSER (GAMSER,A,X,GLN)
      GAMMQm1=GAMSER
      RETURN
      END
C

C ------------------------------------------------------------------------------
C
      SUBROUTINE GCF (GAMMCF,A,X,GLN)
C
      INTEGER    ITMAX,N
      real GAMMCF,A,X,GLN,EPS,GOLD,A0,A1,B0,B1,FAC,AN
      real ANA,ANF,G,GAMMLN
      PARAMETER  (ITMAX=200,EPS=3.E-8)
C

      if(x.gt.100.) then
         gammcf = 0.
         return
      endif
      
      GLN=GAMMLN(A)
      GOLD=0.0
      A0=1.0
      A1=X
      B0=0.0
      B1=1.0
      FAC=1.0
      DO 11 N=1,ITMAX
        AN=FLOAT(N)
        ANA=AN-A
        A0=(A1+A0*ANA)*FAC
        B0=(B1+B0*ANA)*FAC
        ANF=AN*FAC
        A1=X*A0+ANF*A1
        B1=X*B0+ANF*B1
        IF (A1.NE.0.0) THEN
          FAC=1.0/A1
          G=B1*FAC
          IF (ABS((G-GOLD)/G).LT.EPS) GOTO 1
          GOLD=G
        ENDIF
11    CONTINUE
      gammcf = 0.
      return
1     GAMMCF=EXP(-X+A*log(X)-GLN)*G
      
      RETURN
      END
C
C ------------------------------------------------------------------------------
C
      SUBROUTINE GSER (GAMSER,A,X,GLN)
C
      INTEGER    ITMAX,N
      real       GAMSER,A,X,GLN,AP,SUM,DEL,EPS,GAMMLN
      PARAMETER  (ITMAX=100,EPS=3.E-30)
C
      GLN=GAMMLN(A)
      IF (X.LE.0.0) THEN
        IF (X.LT.0.0) PAUSE
        GAMSER=0.0
        RETURN
      ENDIF
      AP=A
      SUM=1.0/A
      DEL=SUM
      DO 11 N=1,ITMAX
        AP=AP+1.0
        DEL=DEL*X/AP
        SUM=SUM+DEL
        IF (ABS(DEL).LT.ABS(SUM)*EPS) GOTO 1
11    CONTINUE
      PAUSE 'A too large, ITMAX too small'
      stop
1     GAMSER=SUM*EXP(-X+A*log(X)-GLN)
      RETURN
      END
C
C ------------------------------------------------------------------------------
C
      FUNCTION PLGNDR (L,M,X)
C
      INTEGER  L,M,I,LL
      REAL     X,PMM,SOMX2,FACT,PLGNDR,PMMP1,PLL
C
      IF (M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.) PAUSE 'bad arguments'
      PMM=1.0
      IF (M.GT.0) THEN
        SOMX2=SQRT((1.0-X)*(1.0+X))
        FACT=1.0
        DO 11 I=1,M
          PMM=-PMM*FACT*SOMX2
          FACT=FACT+2.0
11      CONTINUE
      ENDIF
      IF (L.EQ.M) THEN
        PLGNDR=PMM
      ELSE
        PMMP1=X*(2*M+1)*PMM
        IF (L.EQ.M+1) THEN
          PLGNDR=PMMP1
        ELSE
          DO 12 LL=M+2,L
            PLL=(X*(2*LL-1)*PMMP1-(LL+M-1)*PMM)/(LL-M)
            PMM=PMMP1
            PMMP1=PLL
12        CONTINUE
          PLGNDR=PLL
        ENDIF
      ENDIF
      RETURN
      END

      subroutine findbrackets(func,psi,rmin,rmax)

      real rmin,rmax,psi,psirmin,psirmax

      rmin = 1.
      rmax = 1.

 77   psirmin = func(rmin)
      if(psirmin.le.psi) then
         rmin = rmin*0.1
         goto 77
      endif
 88   psirmax = func(rmax)
      if(psirmax.ge.psi) then
         rmax = rmax*10.
         goto 88
      endif
      return
      end


      subroutine RTBIS (func,psi,X1,X2,XACC,XBEST)
C
      INTEGER    JMAX,J
      PARAMETER  (JMAX=100)
      real X1,X2,XACC,FMID,F,DX,XMID,psi,XBEST
C
      external func

      fmid = func(x2)-psi
      f = func(x1)-psi
      if(f*fmid.ge.0.0) write(*,*) psi,x2,fmid,x1,f
      IF (F*FMID.GE.0.0) PAUSE 'Root must be bracketed for bisection.'      
      IF (F.LT.0.0) THEN
        XBEST=X1
        DX=X2-X1
      ELSE
        XBEST=X2
        DX=X1-X2
      ENDIF
      DO 11 J=1,JMAX
        DX=DX*0.5
        XMID=XBEST+DX
        fmid = func(xmid) - psi
        IF (FMID.LT.0.0) XBEST=XMID
        IF ((ABS(DX).LT.XACC).OR.(FMID.EQ.0.0)) RETURN
11    CONTINUE
      PAUSE 'too many bisections'
      END

c     this file contains the following subroutines:
c
c     readharmfile: reads a file with the harmonic expansion of the
c     potential and density.  all the relevant stuff ends up in a common
c     block that only needs to be seen by the routines in this file (I
c     think!). This routine must be called first.
c
c     dens(r,z): density at point (r,z)
c
c     densrpsi(r,psi): density as a function of r and potential psi.
c
c     pot(r,z): potential at point (r,z)
c
c     all the rest is (slightly nobbled in places) numerical recipes
c     routines.
c
      subroutine readharmfile(filename,ibuf1,jbuf1,kbuf1)

      include 'commonblocks'
      include 'equivalence'

      character*30 filename

      real psi0mpsid

      open(file='in.gendenspsi',unit=1,status='old')
      read(1,*) npsi
      close(1)


c  constants for legendre polynomials
      do l=0,40
         plcon(l) = sqrt((2*l+1)/(4.0*pi))
      enddo
c
      open(14,file=filename,status='old')
      read(14,*)
      read(14,'(2x,7g15.5,i6,i4)') chalo,v0,a,nnn,v0bulge,abulge,
     +     dr,nr,lmax
      read(14,*)
      read(14,'(2x,3g15.8)') psi0, haloconst, bulgeconst
      read(14,*)
      read(14,'(2x,5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
      read(14,*)
      read(14,'(2x,3g15.5)') psic,psi0mpsid,bhmass
      psid = psi0 - psi0mpsid
      read(14,'(2x,4i5)') idiskflag, ibulgeflag, ihaloflag, ibhflag
      read(14,*)
      do ir=0,nr
         read(14,'(8g16.8)') rdummy,(adens(l/2+1,ir),l=0,lmax,2)
         enddo
      read(14,*)
      read(14,*)
      do ir=0,nr
         read(14,'(8g16.8)') rdummy,(apot(l/2+1,ir),l=0,lmax,2)
         enddo
      read(14,*)
      read(14,*)
      do ir=0,nr
         read(14,'(8g16.8)') rdummy,(fr(l/2+1,ir),l=0,lmax,2)
         enddo
      close(14)

c
c these are needed for the bulgeconstants common block
c
      sigbulge2=sigbulge*sigbulge
c
c additional disk constants for efficiency - common diskconstants
c

      nrdisk= int((outdisk + 2.0*drtrunc)/dr) + 10
      rdisk2 = rdisk*rdisk
      diskconst = rmdisk/(4.0*pi*rdisk2*zdisk)
c
c and some more constants...
c
      v02=v0*v0
      v03=v0*v02
c
c calculate potential correction
c
      redge = nr*dr
      potcor = 0
      do l=0,lmax,2
          potcor = potcor + apot(l/2+1,nr) + fr(l/2+1,nr)*redge/(l+1)
      enddo
      potcor = potcor*plcon(0)
      potcor1 = potcor
c
c transfer gparams buffer for output
c

      do i=1,15
         ibuf1(i) = ibuf(i)
      enddo
      do j=1,3
         jbuf1(j) = jbuf(j)
      enddo
      do k=1,1
         kbuf1(k) = kbuf(k)
      enddo
      
      return
      end

c this file contains the following subroutines:
c
c readharmfile: reads a file with the harmonic expansion of the potential 
c               and density.
c all the relevant stuff ends up in a common block that only needs to be seen by
c the routines in this file (I think!). This routine must be called first.
c
c dens(r,z): density at point (r,z)
c
c densrpsi(r,psi): density as a function of r and potential psi.
c
c pot(r,z): potential at point (r,z)
c
c all the rest is (slightly nobbled in places) numerical recipes routines.
c

      subroutine readharmfile(filename,ibuf1)
      parameter(pi=3.1415926535)
      parameter(nrsize=20000)
      common /potconstants/ apot(20,0:nrsize), frad(20,0:nrsize), 
     +     dr, nr, lmax, potcor
      common /legendre/ plcon(0:40)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      common /diskpars/ sigr0, disksr, nrdisk
      common /flags/ idiskflag, ibulgeflag, ihaloflag

      real adens(20,0:nrsize)
      integer*4 ibuf(18),ibufb(3), ibuf1(18)
c this allows the gparameters to be passes as a C structure
      character filename*60
      equivalence (a, ibuf),(idiskflag,ibufb)
      external alldensnohalo,alldensnobulge,zerofunc

c  constants for legendre polynomials
      do l=0,40
         plcon(l) = sqrt((2*l+1)/(4.0*pi))
      enddo
c
      open(14,file=filename,status='old')
      read(14,*)
      read(14,'(2x,7g15.5,i6,i4)') psi00,v0,q,a,b,c,dr,nr,lmax
      read(14,*)
      read(14,'(2x,3g15.5)') psiout,rho1,sigbulge
      read(14,*)
      read(14,'(2x,5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
      read(14,'(2x,3i5)') idiskflag, ibulgeflag, ihaloflag
      read(14,*)
!      write(0,*) ' this model had psi00,v0,q,a,b,c,dr,nr,lmax='
!      write(0,'(x,7g15.5,i6,i4)') psi00,v0,q,a,b,c,dr,nr,lmax

c these are needed for the bulgeconstants common block
c       
      if(ibulgeflag.NE.3) then
      sigbulge2=sigbulge*sigbulge
      bulgea = rho1*exp((psi00 - psiout)/sigbulge2)
      endif
c
c additional disk constants for efficiency - common diskconstants
c
      nrdisk= int((outdisk + 2.0*drtrunc)/dr) + 10
      rdisk2 = rdisk*rdisk
      diskconst = rmdisk/(4.0*pi*rdisk2*zdisk)
c
c and some more constants...
c
      if(ihaloflag.NE.3) then
      v02=v0*v0
      v03=v0*v02
      endif
! in case ihaloflag=3: v0=rscl,q=rv,a=rhs ...
! in case ibulgeflag=3: psiout=bulgerscl, rho1=bulgerv,sigbulge=bulgerhs....

      if(ihaloflag.eq.3) call sethalodf(v0,q,a)
 !     print*,'##',v0,q,a,ihaloflag
      if(ibulgeflag.eq.3)
     &      call setbulgedf(psiout,rho1,sigbulge,halormin(),halormax())
! ugly
!      print*,psiout,rho1,sigbulge,halormax()
!      print*,v0,q,a

      if(ihaloflag.eq.3) then
        call inithalodf(alldensnohalo)
      endif

      if(ibulgeflag.eq.3) then
        call initbulgedf(alldensnobulge)
      endif
      
      write(0,*) 'Reading harmonics file '//trim(filename)
      do ir=0,nr
         read(14,'(8g16.8)') rr,(adens(l/2+1,ir),l=0,lmax,2)
         enddo
      read(14,*)
      read(14,*)
      do ir=0,nr
         read(14,'(8g16.8)') rr,(apot(l/2+1,ir),l=0,lmax,2)
         enddo
      read(14,*)
      read(14,*)
      do ir=0,nr
         read(14,'(8g16.8)') rr,(frad(l/2+1,ir),l=0,lmax,2)
         enddo
      close(14)
c      write(0,*) 'have read density and potential'
c      write(*,*) 'lmax =',lmax
c      write(*,*) 'apot starts as:'
c      do ll=1,3
c         write(*,*) (apot(ll,i),i=1,10)
c      enddo
c
c
c
c calculate potential correction
c
!!!!
      redge = nr*dr
      potcor = 0
      do l=0,lmax,2
          potcor = potcor + apot(l/2+1,nr) + frad(l/2+1,nr)*redge/(l+1)
      enddo
      potcor = potcor*plcon(0)
      potcor1 = potcor
!!!
c
c transfer gparams buffer for output
c

      do i=1,15
          ibuf1(i) = ibuf(i)
      enddo
      do i=1,3
          ibuf1(i+15) = ibufb(i)
      enddo
      
      return
      end

      program plothalo

      external halodens,diskdensf,bulgedens
      character*60 filename
      character ans

      integer*4 ibuf1(15)

      filename='dbh.dat'

c      call readdiskdf(filename,ibuf1)      
      call readharmfile(filename,ibuf1)      

      open(20,file='scales',status='old',err=5)
      read(20,*) rscale
      close(20)
      goto 6

 5    write(*,*) 'No files "scales" found.'
      write(*,*) 'Will use default length and speed scales instead.'
      rscale=1.
 6    continue
      write(*,*) 'Scale for distances: ',rscale,' kpc.'

      write(*,*) 'Will make panels for inner and outer halo density.'
      write(*,*) 'Inner panel: bin size [kpc], no. of bins (max 100)?'
      read(*,*) din,nin
      write(*,*) 'Outer panel: bin size [kpc], no. of bins (max 100)?'
      read(*,*) dout,nout
      write(*,*) 'Will also make a panel for bulge density.'
      write(*,*) 'Bulge panel: bin size [kpc], no. of bins (max 100)?'
      read(*,*) dbu,nbu

 1    call pgbeg(0,'?',1,1)
      write(*,*)
      call pgvport(0.05,0.32,0.6,0.93)
      call contourden(nin,din,halodens,1.,rscale)
      call pglabel('R [kpc]','z [kpc]','Inner Halo Density')
      call pgvport(0.37,0.64,0.6,0.93)
      call contourden(nbu,dbu,bulgedens,1.,rscale)
      call pglabel('R [kpc]','z [kpc]','Bulge Density')
      call pgvport(0.69,0.96,0.6,0.93)
      call contourden(nout,dout,halodens,1.,rscale)
      call pglabel('R [kpc]','z [kpc]','Outer Halo Density')
      call pgvport(0.05,0.96,0.1,0.42)
      call contourden(nin,din,diskdensf,0.3,rscale)
      call pglabel('R [kpc]','z [kpc]','Disk Density')
      call modstamp
      call pgend
      write(*,*) 'Density contour levels jump by factor 2.'
      write(*,*) 'Same plot, different device?'
      read(*,'(a)') ans
      if (ans.ne.'n' .and. ans.ne.'N') goto 1
      end

      function dpolardiskdens(r,ctheta)
      z=r*ctheta
      s=r*sqrt(1.0 - ctheta*ctheta)
      dpolardiskdens=diskdensestimate(s,z)
      return
      end

      function diskdensestimate(s,z)

      include 'commonblocks'
c
      r=sqrt(s*s+z*z)
      t=sqrt(0.5d0)*(r-outdisk)/drtrunc
      t2=t*t
      if (t.lt.-5.0) then
         eerfc=1.
      elseif (t.lt.5.0) then
         eerfc=0.5*erfc(t)
      else
         eerfc=0
      endif
      if (r.gt.0.) then
         f=diskconst*eerfc*exp(-r/rdisk)
      else
         f=diskconst*eerfc
      endif
      zz=abs(z/zdisk)
      ezz=exp(-zz)
      e2zz=ezz*ezz
      tsech2=(2*ezz/(1+e2zz))**2
      diskdensestimate=f*tsech2

      return
      end

      function halodensity(r)

      include 'commonblocks'
      real nfwdens

      halodensity = nfwdens(r)*eerfc(r)

      return
      end

      function halodensprime(r)

      include 'commonblocks'
      real nfwdens, nfwdensprime

      halodensprime = nfwdens(r)*eerfcprime(r)+nfwdensprime(r)*eerfc(r)
      
      return
      end

      function halodens2prime(r)

      include 'commonblocks'
      real nfwdens, nfwdensprime, nfwdens2prime

      t1 = nfwdens2prime(r)*eerfc(r)
      t2 = 2.*nfwdensprime(r)*eerfcprime(r)
      t3 = nfwdens(r)*eerfc2prime(r)
      halodens2prime = t1 + t2 + t3
      return
      end

      function eerfc(r)

      include 'commonblocks'

      t=sqrt(0.5)*(r-chalo)/drtrunchalo
      t2=t*t
      if (t.lt.-4.) then
         eerfc=1.
      elseif (t.lt.4.) then
         eerfc=0.5*erfc(t)
      else
         eerfc=0
      endif
      
      return
      end

      function eerfcprime(r)

      include 'commonblocks'

      t=sqrt(0.5)*(r-chalo)/drtrunchalo
      t2=t*t

      if(t2.gt.16.) then
         eerfcprime = 0.
      else
         eerfcprime = -0.5*sqrt(2./pi)/drtrunchalo*exp(-t2)
      endif
      return
      end

      function eerfc2prime(r)

      include 'commonblocks'

      t=sqrt(0.5)*(r-chalo)/drtrunchalo
      t2=t*t

      if(t2.gt.16.) then
         eerfc2prime = 0.
      else
         eerfc2prime = 1./sqrt(pi)/drtrunchalo/drtrunchalo*t*exp(-t2)
      endif
C      write(77,*) r,eerfc2prime
      return
      end

      include 'commonblocks'

      real xa(5),ya(5)

      character ans*1

      open(file='check.dat',unit=10,status='replace')

c  constants for legendre polynomials
      do l=0,40
         plcon(l) = sqrt((2*l+1)/(4.0*pi))
      enddo
c
c     Enter halo parameters
c
      write(*,*) 'Include halo?'
      read(*,'(a)') ans

      if(ans.eq.'y') then
         write(*,*) 'outer radius, v0, a, drtrunchalo?'
         read(*,*) chalo, v0, a, drtrunchalo, cusp, outerhaloslope
         ihaloflag = 1
         haloconst = (2.**(1.-cusp))*v0*v0/4./pi/a/a
      endif
      
c Enter disk parameters
      write(*,*) 'Include disk?'
      read(*,'(a)') ans
      if( ans .eq. 'y' ) then
         write(*,*)
     *        'Disk mass, scale length, rad, scale height,trunc width'
         read(*,*) rmdisk, rdisk, outdisk, zdisk, drtrunc
         idiskflag = 1
         rdisk2 = rdisk*rdisk
         diskconst = rmdisk/(4.0*pi*rdisk2*zdisk)
         do iref=1,4
           rref(iref)=iref*rdisk*2
           zref(iref)=0
           enddo
         do iref=5,7
           rref(iref)=(iref-5)*rdisk*4
           zref(iref)=zdisk/2.
           enddo
         do iref=8,10
           rref(iref)=rref(iref-3)
           zref(iref)=zdisk*2.
           enddo
         open(18,file='refpoints.dat',status='unknown')
      else
         rmdisk = 0.
      endif

c Enter bulge parameters

      write(*,*) 'Include bulge?'
      read(*,'(a)') ans
      if( ans .eq. 'y' ) then
         write(*,*) 'sersic, ppp, v0_bulge, a_bulge?'
         read(*,*) nnn, ppp, v0bulge, abulge
         if(ppp.lt.0) then
            ppp = 1. - 0.6097/nnn + 0.05463/(nnn*nnn)
         endif
         ibulgeflag = 1
         call setsersicparameters
      else
         v0bulge = 0.
         abulge = 0.
         ibulgeflag = 0
      endif

c     Enter blackhole parameters
      write(*,*) 'Include blackhole?'
      read(*,'(a)') ans
      if(ans.eq.'y') then
         write(*,*) 'blackhole mass?'
         read(*,*) bhmass
         ibhflag = 1
      else
         bhmass = 0.
         ibhflag = 0
      endif

c     Enter grid parameters
      write(*,*) 'radial step size, no. of bins?'
      read(*,*) dr,nr
      write(*,*) 'max. azimuthal harmonic l?'
      read(*,*) lmaxx

      open(file='in.gendenspsi',unit=40,status='old')
      read(40,*) npsi,nint
      close(40)

      if(ihaloflag.eq.1) call halopotentialestimate
      if(idiskflag.eq.1) call diskpotentialestimate
      call gentableE
      if(ibulgeflag.eq.1) call gendfsersic
      if(ihaloflag.eq.1) call gendfnfw
      if(ihaloflag.eq.1) call gendenspsihalo
      if(ibulgeflag.eq.1) call gendenspsibulge

      open(file='dfhalo.table',unit=41,status='replace')
      open(file='denspsihalo.dat',unit=42,status='old')
      do i=1,npsi
         read(42,*) energy
         dfhaloval = dfhalo(energy)
         write(41,*) energy, dfhaloval
      enddo

      apot(1,0)=psi0*sqrt(4.*pi)

c     initial potential is from our potential ansatz

      z = 0.0
      do ir=1,nr
         r=ir*dr
         apot(1,ir) = sqrt(4.*pi)*gettotalpsi(r)
         do l=2,lmaxx,2
            apot(l/2+1,ir)=0
         enddo
      enddo

      niter=(2+lmaxx/2)*10
      lmaxstep=2
      lmax=0
      ntheta=lmax*10+2
      ntheta=max(10,ntheta)

c     now iterate. number of iterations and change in lmax depends on
c     initial conditions.  iterate on first cycle until tidal radius is
c     stable, then once for every harmonic added, and until convergence
c     once l has reached the desired maximum lmax.
      
      drtidal = 2*dr
      rtidalold = 1e10
      tidalcheck = rtidalold
      lmaxold=-2
      iteroutside = 0
      frac=0.75

      do iter=0,100
         if( lmax .eq. 0 .or. lmax .eq. lmaxx ) then
            if(drtidal .lt. dr .and. iter.gt.10) then
               lmax=lmax+lmaxstep
               ntheta=lmax*4+2
            endif
         else
            lmax=lmax+lmaxstep
            ntheta=lmax*4+2
         endif
         if( lmax .eq. lmaxx+lmaxstep ) goto 199

c     Now get the harmonics of the density in this potential --> adens
c     NB that dens only gives the density without an approximate sech**2
c     component --- that part of the potential is not represented by the
c     harmonics.  The function dens(r,z) returns the density -
c     high-frequency cpt The full density is returned by totdens

         eps = 0.00001
         adens(1,0)=dens(eps,0.)*sqrt(4.*pi)

         do l=2,lmax,2
            adens(l/2+1,0)=0
         enddo
         do ir=1,nr
            adens(1,ir)=0
         enddo

c     nrmx will mark the outermost radial bin with non-zero density.
         nrmx=nr
         do l=0,lmax,2

c     integrate density * spherical harmonic function over quadrant use
c     cos(theta) as independent variable.

            do ir=1,nrmx
               r=ir*dr
               s=0
               dctheta=1.0/ntheta
               s=s+polardens(r,1.0,l)+polardens(r,0.0,l)
               do is=1,ntheta-1,2
                  ctheta=is*dctheta
                  s=s+4*polardens(r,ctheta,l)
               enddo
               do is=2,ntheta-2,2
                  ctheta=is*dctheta
                  s=s+2*polardens(r,ctheta,l)
               enddo
               s=s*dctheta/3.
               s=s*4*pi
               adens(l/2+1,ir)=s
c     mark the first even radial bin on which the density has fallen to
c     zero.
               if (l.eq.0 .and. s.eq.0.) then
                  nrmx=nr
                  nrmx=nrmx+mod(nrmx,2)
                  goto 77
               endif
            enddo
 77      enddo

c     now get the potential harmonics of this new density. (BT 2-208)
c     Simpson's rule integration.

         do l=0,lmax,2
            s1(0)=0
            r = 2*dr
            s1(2)=(r*dr/3.)*(4*adens(l/2+1,1)*(1.0-dr/r)**(l+2)
     +           +adens(l/2+1,2))
            rold = r 
            do ir=4,nr,2
               r=ir*dr
               s1a = (r*dr/3.)*(adens(l/2+1,ir-2)*(1.0-2*dr/r)**(l+2)+
     &              4*adens(l/2+1,ir-1)*(1.0-dr/r)**(l+2)+
     +              adens(l/2+1,ir))
               s1(ir) = s1a + s1(ir-2)*(rold/r)**(l+1)
               rold = r
            enddo
            s2(nr)=0
            rold = nr*dr
            do ir=nr-2,2,-2
               r=ir*dr
               s2a = (r*dr/3.)*(adens(l/2+1,ir+2)*(1.0+2*dr/r)**(1-l)+
     &              4*adens(l/2+1,ir+1)*(1.0+dr/r)**(1-l)+
     +              adens(l/2+1,ir))
               s2(ir) = s2a + s2(ir+2)*(r/rold)**l
               rold = r
            enddo

c     replace the potential harmonics with a mean of the previous
c     iteration (25%) and the current one (75%). This damps out
c     oscillations that otherwise occur.  if this is the first time this
c     harmonic is calculated, use the entire new value.

            do ir=2,nr,2
               if (l.le.lmaxold) then
                  apot(l/2+1,ir)=frac*apot(l/2+1,ir)+
     +                 (1.-frac)*4*pi/(2.*l+1.)*(s1(ir)+s2(ir))
               else
                  apot(l/2+1,ir)=4*pi/(2.*l+1.)*(s1(ir)+s2(ir))
               endif
            enddo

c     Calculate the 1st and 2nd-order radial gradients
  
            do ir=2,nr,2
               r = ir*dr
               fr(l/2+1,ir)=-4*pi/(2.*l+1.)*(-(l+1)*s1(ir) + l*s2(ir))/r
               fr2(l/2+1,ir)=-4*pi/(2.*l+1.)*
     +              ((l+1)*(l+2)*s1(ir)/r**2+ 
     +              l*(l-1)*s2(ir)/r**2 -(2*l+1)*adens(l/2+1,ir))
            enddo
         enddo

c     now interpolate the gaps first quadratically interpolate the
c     monopole back to the origin.  the remaining multipoles are zero
c     there.

c         npoly = 5
c         rzero = 0.
c         xa(1) = (2.)
c         xa(2) = (4.)
c         xa(3) = (6.)
c         xa(4) = (8.)
c         xa(5) = (10.)
c         ya(1) = apot(1,2)
c         ya(2) = apot(1,4)
c         ya(3) = apot(1,6)
c         ya(4) = apot(1,8)
c         ya(5) = apot(1,10)
c         call polint(xa,ya,npoly,rzero,apot(1,0),dy)
         apot(1,0)=3*(apot(1,2)-apot(1,4))+apot(1,6)

         fr2(1,0)=2*fr2(1,2)-fr2(1,4)
         do l=2,lmax,2
            apot(l/2+1,0)=0
            fr(l/2+1,0)=0
            fr2(l/2+1,0)=0
         enddo

c  then linearly interpolate other bins.

         do ir=1,nr-1,2
            do l=0,lmax,2
               apot(l/2+1,ir)=(apot(l/2+1,ir-1)+apot(l/2+1,ir+1))/2.
               fr(l/2+1,ir)=(fr(l/2+1,ir-1)+fr(l/2+1,ir+1))/2.
               fr2(l/2+1,ir)=(fr2(l/2+1,ir-1)+fr2(l/2+1,ir+1))/2.
            enddo
         enddo

c  finally reset the potential at the origin to psi0
c  Note that the fake disk potential is zero at the origin.

         if (ihaloflag.eq.0.and.ibulgeflag.eq.0) goto 199

         a00=apot(1,0)
         do ir=0,nr
            apot(1,ir)=apot(1,ir)+psi0*sqrt(4.*pi)-a00
         enddo

         if (a00/sqrt(4.*pi)-psi0.gt.psic) then
            write(*,'(''Iter'',i4,'': lmax='',i4,
     +           '', tidal radius is infinite'')') iter, lmax 
            iteroutside = iteroutside + 1
            if( iteroutside .gt. 40 ) then
                write(*,'(''nr='',i4,'' is too small'',
     +           '', try larger number of radial bins  
     +              - exiting program'')') nr
                goto 12345
            endif
            drtidal = 2.0*dr
         else
            potr=psi0
            do ir=1,nr
c     look for new tidal radius of the model defined as the radius at
c     the equator where the potential is equal to psic
               potrm1=potr
               potr=pot(ir*dr,0.)
               aa = potrm1 - psic
               bb = potr - psic
               if (aa*bb.le.0.) then
                  dpot = potr - potrm1
                  if( dpot .eq. 0.0 ) then
                     rtidal = (ir-1)*dr
                  else
                     rtidal=(ir-1-aa/dpot)*dr
                  endif
                  drtidal = abs(rtidal - rtidalold)
                  tidalcheck = abs(rtidal - rtidalold)/rtidal
                  write(*,'(''Iter'',i4,'': lmax='',i4,
     +                 '', tidal radius is '',g15.6)') iter,lmax,rtidal
                  rtidalold = rtidal
                  goto 9
               endif
            enddo
            write(*,'(''Iter'',i4,'': lmax='',i4,
     +           '', tidal radius is outside grid'')') iter,lmax
            drtidal = 2.0*dr
 9       endif
c write out the changes in the potential at the reference points 
c at this iteration.
         if( idiskflag .eq. 1 ) then 
            do iref=1,10
               oldpref(iref)=pref(iref)
               pref(iref)=pot(rref(iref),zref(iref))
            enddo
            write(18,'(2i3,10g12.4)') iter,lmax,
     +           (pref(iref)-oldpref(iref),iref=1,10)
         endif
c     now repeat with this new potential!
         lmaxold=lmax

      enddo
c     end of the main loop
 199  continue

      open(file='rtidal.dat',unit=20,status='replace')
      if( idiskflag .eq. 1 ) close(18)
      totalmass = fr(1,nr)/sqrt(4*pi)*(dr*nr)**2
      write(*,*) 'Total mass=', totalmass
      write(20,*) rtidal
c  
c  Calculate force and potential for halo only
c  
      lmax = lmaxx

      halomass = 0.0
      bulgemass = 0.0
      haloedge = 0
      bulgeedge = 0
      if( ihaloflag .eq. 1 ) call halopotential(halomass, haloedge)
      if( ibulgeflag .eq. 1 ) call bulgepotential(bulgemass, bulgeedge)
      if( ibhflag. eq. 1) call genblackhole(bhmass)
      if( idiskflag.eq.1) then
         diskmass = totalmass - halomass - bulgemass
         diskedge = outdisk + 2.0*drtrunc
      else
         diskmass = 0.
         diskedge = 0.
      endif

      open(20,file='mr.dat',status='unknown')
      write(20,*) diskmass, diskedge
      write(20,*) bulgemass, bulgeedge
      write(20,*) halomass, haloedge
      close(20)

      open(11,file='dbh.dat',status='unknown')
      write(11,'('' # chalo,v0,a,nnn,v0bulge,abulge,dr,nr,lmax='')')
      write(11,'('' #'',7g15.5,i6,i4)') chalo,v0,a,nnn,v0bulge,abulge,
     +     dr,nr,lmaxx
      write(11,'('' # psi0, haloconst, bulgeconst:'')')
      write(11,'('' #'',3g15.8)') psi0,haloconst,bulgeconst
      write(11,'('' # Mdisk, rdisk, zdisk, outdisk, drtrunc'')')
      write(11,'('' #'',5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
      write(11,'('' # psic, psi0-psid, bhmass'')')
      write(11,'('' #'',3g15.5)') psic,psi0-psid,bhmass
      write(11,'('' #'',4i5)') idiskflag, ibulgeflag, ihaloflag, ibhflag
      write(11,'('' #  OUTPUT FROM DBH8. TOTAL POTENTIAL.'')')

      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(adens(l/2+1,ir),l=0,lmaxx,2)
      enddo
      write(11,*)
      write(11,*)
      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(apot(l/2+1,ir),l=0,lmaxx,2)
      enddo
      write(11,*)
      write(11,*)
      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(fr(l/2+1,ir),l=0,lmaxx,2)
      enddo
      write(11,*)
      write(11,*)
      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(fr2(l/2+1,ir),l=0,lmaxx,2)
      enddo
      write(11,*)
      do ir=0,nr
         psi=pot(ir*dr,0.)
         write(11,'(2g16.8)') ir*dr,diskdens(ir*dr,0.,psi)
      enddo
      close(11)

      write(*,*) 'Final model written to file ''dbh.dat''.'

      write(*,*) haloedge

      call check

12345 continue

      open(file='tidalr.out',status='replace',unit=14)
      write(14,*) rtidal
      
      end

      subroutine check

      include 'commonblocks'
      
      real psi

      open(file='check.out',unit=66,status='replace')

      z = 0.
      do ir=1,nr
         r = ir*dr
         psi = pot(r,z)
         bdens = bulgedenspsi(psi)
         ebdens = sersicdens(r)
         hdens = halodenspsi(psi)
         ehdens = halodensity(r)
         ddens = diskdens(r,z,psi)
         eddens = rmdisk/4./pi/rdisk/rdisk/zdisk*exp(-r/rdisk)
         tdens = totdens(r,z)
         write(66,88) 
     +        log10(r),
     +        log10(ddens),log10(eddens),
     +        log10(bdens),log10(ebdens),
     +        log10(hdens),log10(ehdens),psi
      enddo
 88   format(10f12.3)
      close(10)
      return
      end

      subroutine checkhalo(haloedge)

      include 'commonblocks'
      
      real psi

      open(file='check.out',unit=66,status='replace')

      z = 0.
      rlogmin = log10(dr)
      rlogmax = log10(haloedge)
      drlog = (rlogmax-rlogmin)/float(nr)
      do ir=1,nr
         r = ir*dr
         psi = pot(r,z)
         hdens = halodenspsi(psi)
         ehdens = halodensity(r)
         write(66,88) log10(r),log10(hdens),ehdens,psi
c         write(66,88) log10(r),log10(ebdens),log10(ebpot),
c     +         log10(ebdens1),log10(ebdens2)
      enddo
 88   format(8f12.3)
      close(10)
      return
      end

      subroutine genblackhole(bhmass)

      open(file='blackhole',unit=20,status='replace')
      n = 1
      t = 0.
      write(20,*) n,t
      write(20,*) bhmass,t,t,t,t,t,t
      close(20)
      
      return
      end

c-----------------------
      subroutine splintd(xa,ya,y2a,n,x,y)
      integer n
      real*4 x,y,xa(n),y2a(n),ya(n)
      integer k,khi,klo
      real*4 a,b,h
      data klo,khi /1,1/
      save khi,klo
c check first of previous klo and khi are still ok.
      if (khi.le.n) then
        if (xa(khi).gt.x .and. xa(klo).lt.x .and. khi-klo.eq.1) goto 2
        endif
c if not, search by bisection
      klo=1
      khi=n
1     if (khi-klo.gt.1) then
        k=(khi+klo)/2
        if(xa(k).gt.x)then
          khi=k
        else
          klo=k
        endif
      goto 1
      endif
2     h=xa(khi)-xa(klo)
      if (h.le.0.) pause 'bad xa input in splint'
      a=(xa(khi)-x)/h
      b=(x-xa(klo))/h
      y=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**
     *2)/6.
      return
      END

      function dfbulge(energy)

      include 'commonblocks'
      
      if(energy.lt.psic) then
         dfbulge = 0.
         return
      endif
      if(energy.ge.psi0) then
         dfbulge = exp(dfsersic(1))
         return
      endif

      rj = 1. + float(npsi-1)*
     +     log((psi0-energy)/(psi0-psid))/log((psi0-psic)/(psi0-psid))
      j = int(rj)
      if(j.lt.1) j = 1
      if(j.ge.npsi) j = npsi-1

      frac = rj - float(j)
      dfbulge = exp(dfsersic(j) + frac*(dfsersic(j+1)-dfsersic(j)))

      return
      
      end

      function diskdf3intez(ep,am,ez)
      parameter (pi=3.1415926535,nrmax=1000)
      real psi00
      psi00 = pot(0.0,0.0)
      rc=rcirc(am)
      call omekap(rc,fomega,fkappa)
      vc=rc*fomega
      ec= -pot(rc,0.0)+0.5*vc*vc
      if (am.lt.0.) ec= -2*psi00-ec
      sr2=sigr2(rc)
      sz2=sigz2(rc)
      if (sz2.gt.0.) then
         fvert=fnamidden(rc)*exp(-ez/sz2)
         arg = (ep-ec)/sr2
         diskdf3intez=fomega/fkappa*sqrt(2/pi/sr2)*
     *        exp(-(arg))*fvert
      else
         diskdf3intez=0
      endif
      return
      end

      function appdiskpot(s,z)

      include 'commonblocks.h'

c  The potential is obtained by integrating the density of a sech**2
c  disk up vertically, ignoring radial potential gradients.  In the
c  resulting expression the cylindrical r is then replaced with
c  spherical radius, to make the potential zero at infinity (otherwise
c  the harmonics series do not have a simple asymptotic form at
c  infinity).
      r=sqrt(s*s+z*z)
c  erfc radial truncation factor
      t=sqrt(0.5d0)*(r-outdisk)/drtrunc
      if (t.lt.-4.0) then
         eerfc=1.
      elseif(t.gt.4.0) then
         appdiskpot=0.
         return
      else
         eerfc=0.5*erfc(t)
      endif

      f=diskconst*exp(-r/rdisk)
      zz=abs(z/zdisk)
      appdiskpot=-4*pi*f*zdisk**2*(zz+log(0.5*(1+exp(-2*zz))))*eerfc

      return
      end       

      subroutine modstamp
      character*60 string
      open(20,file='modname',err=23,status='old')
      read(20,'(a60)') string
      close(20)
cpg      call pgqvp(0,x1,x2,y1,y2)
cpg      call pgqwin(xw1,xw2,yw1,yw2)
cpg      call pgsvp(0.,1.,0.,1.)
cpg      call pgswin(0.,1.,0.,1.)
cpg      call pgtext(0.01,0.03,string)
cpg      call pgsvp(x1,x2,y1,y2)
cpg      call pgswin(xw1,xw2,yw1,yw2)
 23   return
      end

      program diskdf

      include 'commonblocks'

      dimension drat(0:nrmax),
     +          dz2rat(0:nrmax),
     +          fzrat(0:nrmax)
      dimension d0rat(0:nrmax),d1rat(0:nrmax),d2rat(0:nrmax)
     +     ,d3rat(0:nrmax),
     +          d4rat(0:nrmax)
      dimension fplot(0:10*nrmax),rplot(0:10*nrmax)
      include 'equivalence'
      character*60 filename

      common /fileroot/ filename

      write(0,*) 'Central velocity dispersion, scale length of sigR**2?'
      read(*,*) sigr0,disksr
      write(0,*) 'number of radial steps for correction fns (min. 6)?'
      read(*,*) nrspl
      write(0,*) 'number of iterations?'
      read(*,*) niter
      filename='dbh.dat'
      call readharmfile(filename,ibuf,jbuf,kbuf)
      psi00=pot(0.0,0.0)
      rfid = 2.5*rdisk

      call omekap(rfid,fom,fka)
      sigr = sqrt(sigr2(rfid))
      sigden = diskdensf(rfid,0.0)*2.0*zdisk
c
c a close estimate of the disk surface density
c
      sigrcrit = 3.36*sigden/fka
      qtoomre = sigr/sigrcrit
      write(0,*) 'Toomre Q = ',qtoomre, ' at R = 2.5 R_d'
      open(file='toomre2.5',status='replace',unit=11)
      write(11,*) qtoomre
      close(11)

c first call initializes the spline fitting functions by the way
      call omekap(outdisk,fom,fka)
      if (sqrt(sigr2(outdisk)).gt.drtrunc*fka) then
         write(0,*) '** WARNING **: you have asked for an outer vel'
         write(0,*) '  dispersion which is larger than that used in the'
         write(0,*) '  disk truncation. Strange things may happen.'
         write(0,*) sqrt(sigr2(outdisk))/(drtrunc*fka),fka
      endif
      drspl = (outdisk + 2*drtrunc)/nrspl
      do ir=0,nrspl
         rr(ir)=drspl*ir
         fdrat(ir)=1
         fszrat(ir)=1
      enddo
      call splined(rr(0),fdrat(0),nrspl+1,1.e32,1.e32,drat2(0))
      call splined(rr(0),fszrat(0),nrspl+1,1.e32,1.e32,szrat2(0))

      open(12,file='cordbh.dat',status='unknown')

c Make niter iterations on the correction functions for midplane density
c and vertical velocity dispersion.
      do icor=1,niter
         do ir=0,nrspl
            r=rr(ir)
            call omekap(r,fom,fka)
            sigr=sqrt(sigr2(r))
            sigz=sqrt(sigz2(r))
            vc=r*fom
            d0=0
            dz=0
            dz2=0
            dz3=0
            dsz=0
c     integrate analytically over vr and vz, numerically over vphi
            dvr=0.1*sigr
            do ivt=1,101
               vt=vc+(ivt-51)*dvr
               df=diskdf5intez(vt,r,0.0)
               c=0.333333333333*(mod(ivt,2)*2+2)
               d0=d0+c*dvr*df
               df=diskdf5intez(vt,r,zdisk)
               dz2=dz2+c*dvr*df
            enddo
            drat(ir)=d0/diskdensf(r,0.)
            dz2rat(ir)=dz2/diskdensf(r,zdisk)
            fzrat(ir)=
     +           log(diskdensf(r,0.)/diskdensf(r,zdisk))/log(d0/dz2)
         enddo
         write(0,*)
         nrd=max(1,nrspl/10)
         write(0,'(''      r: '',11f6.3)') (rr(ir),ir=0,nrspl,nrd)
         write(0,'(f6.3,''  d'',11f6.3)') 0.,(drat(ir),ir=0,nrspl,nrd)
         write(0,'(f6.3,''  d'',11f6.3)') zdisk,
     +        (dz2rat(ir),ir=0,nrspl,nrd)

         do ir=0,nrspl
            fdrat(ir)=fdrat(ir)/drat(ir)
            fszrat(ir)=fszrat(ir)/fzrat(ir)
         enddo
         call splined(rr(0),fdrat(0),nrspl+1,1.e32,1.e32,drat2(0))
         call splined(rr(0),fszrat(0),nrspl+1,1.e32,1.e32,szrat2(0))
      enddo
c Finally, write out a more detailed table of residuals.
      do ir=0,nrspl
         r=rr(ir)
         call omekap(r,fom,fka)
         sigr=sqrt(sigr2(r))
         sigz=sqrt(sigz2(r))
         vc=r*fom
         d0=0
         d1=0
         d2=0
         d3=0
         d4=0
c     integrate analytically over vr and vz, numerically over vphi
         dvr=0.1*sigr
         do ivt=1,101
            vt=vc+(ivt-51)*dvr
            df=diskdf5intez(vt,r,0.)
            c=0.333333333333*(mod(ivt,2)*2+2)
            d0=d0+c*dvr*df
            df=diskdf5intez(vt,r,0.5*zdisk)
            d1=d1+c*dvr*df
            df=diskdf5intez(vt,r,zdisk)
            d2=d2+c*dvr*df
            df=diskdf5intez(vt,r,1.5*zdisk)
            d3=d3+c*dvr*df
            df=diskdf5intez(vt,r,2*zdisk)
            d4=d4+c*dvr*df
         enddo
         d0rat(ir)=d0/diskdensf(r,0.)
         d1rat(ir)=d1/diskdensf(r,0.5*zdisk)
         d2rat(ir)=d2/diskdensf(r,zdisk)
         d3rat(ir)=d3/diskdensf(r,1.5*zdisk)
         d4rat(ir)=d4/diskdensf(r,2*zdisk)
      enddo
      write(0,*)
      nrd=max(1,(nrspl-1)/10+1)
      write(0,'(''      r: '',11f6.3)') (rr(ir),ir=0,nrspl,nrd)
      write(0,'(f6.3,''  d'',11f6.3)') 0.,(d0rat(ir),ir=0,nrspl,nrd)
      write(0,'(f6.3,''  d'',11f6.3)') 
     +     0.5*zdisk,(d1rat(ir),ir=0,nrspl,nrd)
      write(0,'(f6.3,''  d'',11f6.3)') zdisk,(d2rat(ir),ir=0,nrspl,nrd)
      write(0,'(f6.3,''  d'',11f6.3)') 
     +     1.5*zdisk,(d3rat(ir),ir=0,nrspl,nrd)
      write(0,'(f6.3,''  d'',11f6.3)') 
     +     2*zdisk,(d4rat(ir),ir=0,nrspl,nrd)
      write(12,'(''#'', 2g17.7,1x,i4)') sigr0,disksr,nrspl
      do i=0,nrspl
         write(12,'(1x,3g17.7)') rr(i),fdrat(i),fszrat(i)
      enddo
      close(12)
      
      end

      real function nfwdens(rad)

      include 'commonblocks'
 
      s = rad/a
      nfwdens = haloconst/(s**cusp)/((1.+s)**(outerhaloslope-cusp))
      return
      end
 
      real function nfwdensprime(rad)

      include 'commonblocks'
      real nfwdens

      s = rad/a
      nfwdensprime = -nfwdens(rad)/a*(outerhaloslope*s+cusp)/s/(1.+s)
      return
      end

      real function nfwdens2prime(rad)

      include 'commonblocks'
      real nfwdens

      s = rad/a
      nfwdens2prime = nfwdens(rad)/a/a*
     *     (cusp*(cusp+1.)+2.*(1.+outerhaloslope)*cusp*s+
     +     outerhaloslope*(1.+outerhaloslope)*s*s)/s/s/(1.+s)/(1.+s)
      return
      end

program testgas
       integer*4 ibuf(18),ibufb(3), ibuf1(18)
       character filename*60

      common /gparameters/  a, b, c, v0, q, psi00, & 
     &                      psiout, rho1, sigbulge2, &
     &                      rmdisk, rdisk, zdisk, outdisk, drtrunc, &
     &                      potcor1


   integer, parameter :: n=1000,m=50
   real :: dens(n),z(n)
   real :: r,cs,gamma,mz,norm,mz2,rs(m),zm(m),z2m(m)

   filename='dbh.dat'
   call readharmfile(filename,ibuf)

  print*,pot(0.,0.),zdisk

  do j=1,m
  r=j/(1.*m)*16
  cs=10./65.6
  gamma=5./3.
  gamma=1.
  psi0=pot(r,0.)
  norm=0.
  mz2=0.
  mz=0.
  do i=1,n
   z(i)=(i-1)/(1.*n)*20*zdisk
   dens(i)=exp(-gamma*(pot(r,z(i))-psi0)/cs**2)
   mz=mz+dens(i)*z(i)
   mz2=mz2+dens(i)*z(i)**2
   norm=norm+dens(i)
  enddo
  mz=mz/norm
  mz2=mz2/norm
  rs(j)=r
  zm(j)=mz
  z2m(j)=mz2
  enddo 
 
  open(unit=1,file='testgas.data',status='UNKNOWN')
  do i=1,m
   write(1,*) rs(i),zm(i),z2m(i)
  enddo
  close(1)
 

 end program

      subroutine readdiskdf(filename1,ibuf)

      include 'commonblocks'

      integer*4 ibuf(15),jbuf(15),kbuf(15)
      character*30 filename, filename1

      common /fileroot/ filename

      filename1 = 'dbh.dat'

      call readharmfile(filename1,ibuf,jbuf,kbuf)
      filename = filename1

c
c Read in the correction functions
c
      open(17,file='cordbh.dat',status='old')
      read(17,'(2x, 2g17.7,1x,i4)') sigr0,disksr,nrspl
      do i=0,nrspl
         read(17,*) rr(i),fdrat(i),fszrat(i)
      enddo
      close(17)
      call splined(rr(0),fdrat(0),nrspl+1,1.e32,1.e32,drat2(0))
      call splined(rr(0),fszrat(0),nrspl+1,1.e32,1.e32,szrat2(0))

      rfid = 2.5*rdisk
      call omekap(rfid,fom,fka)
      sigr = sqrt(sigr2(rfid))
      sigden = diskdensf(rfid,0.0)*2.0*zdisk

c
c a close estimate of the disk surface density
c
      sigrcrit = 3.36*sigden/fka
      qtoomre = sigr/sigrcrit

C      open(12,file='toomre.dat',status='unknown')
      ntoomre = int((outdisk + 2*drtrunc)/dr)
      xlindbladmax = 0.
      x50 = 0.
      do i=0, ntoomre
         rtoomre = float(i)*dr
         call omekap(rtoomre,fom,fka)
         sigr = sqrt(sigr2(rtoomre))
         sigden = diskdens(rtoomre,0.0)*2.0*zdisk
         sigrcrit = 3.36*sigden/fka
         qtoomre = sigr/sigrcrit
         xparam = fka*fka*rtoomre/6.283/sigden
         rcrise = fka*fka/2./fom/fom - 1.
         xlindblad = fom - fka/2.
         if(xlindblad.gt.xlindbladmax.and.i.gt.1) then
            xlindbladmax = xlindblad
            rxlindblad = rtoomre
         endif
C         write(12,666) rtoomre, qtoomre, xparam, fom,fka,rcrise
      enddo
C      close(12)
 666  format(6f16.3)
C      open(file='stability2.out',unit=10,status='replace')
C      write(10,*) xlindbladmax,rxlindblad,x50
C      close(10)

      return

      end

      function rcirc(am)

      include 'commonblocks'

      real om

      dimension rtab(nmax),amtab(nmax),rtab2(nmax)
     +     ,rtab2zero(nmax)
      data ifirst /0/

      save ifirst,rtab,amtab,rtab2,rtab2zero
      
c make a spline fit to [Rcirc/sqrt(Lcirc)] vs. Lcirc.
c this is ~ constant at the origin, and goes like Lcirc**1.5 
c at large radii (where the potential is Kepler).

      if (ifirst.eq.0) then

         do i=1,nr
            r=(i-1)*dr
            call omekap(r,om,t)
            amtab(i)=om*r*r
            rtab(i)=1./sqrt(om)
         enddo
         slopeinf=1.5*rtab(nrdisk)/amtab(nr)
         call splined(amtab,rtab,nr,1.e32,slopeinf,rtab2)
         do i=1,nr
            rtab2zero(i) = 0.
         enddo         
         ifirst=1
      endif
      aam=abs(am)
      if (aam.gt.amtab(nr)) then
         rcirc=rtab(nr)*(aam/amtab(nr))**2
      else
         call splintd(amtab,rtab,rtab2zero,nr,aam,rc)
         rcirc=rc*sqrt(aam)
         if(rc.lt.0.) then
            write(0,*) rc
            stop
         endif
      endif

      return
      end

c--------------------
      function diskdf5ez(vr,vt,vz,r,z)
      parameter (pi=3.1415926535)
      parameter(nrmax=1000)

      psir0=pot(r,0.0)
      if (z.eq.0.) then 
         psirz=psir0
      else
         psirz=pot(r,z)
         endif
      ep=0.5*(vr*vr+vt*vt)+psir0
      am=r*vt
      ez=0.5*vz*vz+psirz-psir0
      diskdf5ez=diskdf3ez(ep,am,ez)
      return
      end            

      subroutine contourden(n,d,dens,asp,rscale)
      external dens
c contour function dens(r,z) with nxn bins of size d, and aspect ratio asp.
c assumes that a PGPLOT viewport has been defined before the call; inside
c this space a plot with properly scaled axes is made.
      dimension tr(6),ddens(101,101),clev(25)
      dmax=-1e31
      do i=0,n
         r=d*i
         do j=0,n
            z=d*j*asp
            ddens(i+1,j+1)=dens(r/rscale,z/rscale)
            dmax=max(dmax,ddens(i+1,j+1))
         enddo
      enddo
      tr(1)=-d
      tr(2)=d
      tr(3)=0
      tr(4)=-d*asp
      tr(5)=0
      tr(6)=d*asp
      clev(1)=dmax/2.
      do ic=2,25
         clev(ic)=clev(ic-1)/2.
      enddo
      call pgwnad(0.,n*d,0.,n*d*asp)
      call pgbox('BCNST',0.,0,'BCNST',0.,0)
      call pgcons(ddens,101,101,1,n+1,1,n+1,clev,25,tr)
      return

      end

      function diskdf5ez(vr,vt,vz,r,z)

      real psirz,psir0

      psir0=pot(r,0.0)
      if (z.eq.0.) then 
         psirz=psir0
      else
         psirz=pot(r,z)
      endif
c
      ep=0.5*(vr*vr+vt*vt)-psir0
c
      am=r*vt
c
      ez=0.5*vz*vz-psirz+psir0
c
      diskdf5ez=diskdf3ez(ep,am,ez)
      return
      end            


 

      function totdens(r,z)
      common /flags/ idiskflag, ibulgeflag, ihaloflag
     
      totdens = 0
      psi=pot(r,z)
      psi0=pot(0.,0.)
!      print*,psi,diskdens(r,z,psi),bulgedenspsi(psi),densrpsi(r,psi)
      if( idiskflag .eq. 1 .or. idiskflag.eq.3) then
         totdens = totdens + diskdens(r,z,psi)
      endif
      if( ihaloflag .eq. 1 ) then
         totdens = totdens + densrpsi(r,psi)
      endif
      if( ihaloflag .eq. 3 ) then
         totdens = totdens + halodfdenspsi(psi,psi0)
      endif
      if( ibulgeflag .eq. 1 ) then
         totdens = totdens + bulgedenspsi(psi,psi0)
      endif
      if( ibulgeflag .eq. 3 ) then
         totdens = totdens + bulgedfdenspsi(psi,psi0)
      endif
      return
      end

      function dens(r,z)
      
      include 'commonblocks'

      if( idiskflag .eq. 1 ) then
         addens = appdiskdens(r,z)
         dens=totdens(r,z)
         dens = dens - addens
      else
         dens=totdens(r,z)
      endif
      return
      end

module sphericaldfMod

 private
 public :: initdf,maxE,distf,gasRfromq,rho,rhofromfi, &
  &         fifromr,totalmass,rmax,rmin,setparameters
 
 integer,parameter :: ngrid=1000
 real, parameter :: pi=3.1415926535897932385
 real :: r(0:ngrid),dens(0:ngrid),ddensdr(0:ngrid)
 real :: cmass(0:ngrid),fi(0:ngrid),df(0:ngrid) 
 real :: ddrhodfi2(0:ngrid)
 real :: extdens(0:ngrid),extmass(0:ngrid),tmass(0:ngrid)
 
 real, parameter :: F_ZERO_R_LIMIT=0.

 integer, parameter :: ntheta=50
 
! density parameters 
 real :: halfmassradius,mass,nindex  
 real :: dn,rho0,rmax,rmin,alpha,halfmassrho
   
 contains
 
 real function rho(r)
  real :: r
  rho=rho0*exp(-dn*(r/halfmassradius)**alpha)
 end function
 
 real function drhodr(r)
  real :: r
  drhodr=-rho(r)*(dn*alpha*(r/halfmassradius)**(alpha-1)/halfmassradius)
 end function

 real function ddrhodr2(r)
  real :: r
  ddrhodr2=-rho(r)*(dn*alpha*(r/halfmassradius)**(alpha-2)/halfmassradius**2) &
           *(alpha-1-dn*alpha*(r/halfmassradius)**alpha)
 end function

 function maxE()
  real maxE
  maxE=fi(0)
 end function 

 function totalmass()
  real totalmass
  totalmass=tmass(ngrid)
 end function
 
 function totalcmass()
  real totalcmass
  totalcmass=cmass(ngrid)
 end function

 
 function distf(e) result(f)
  real :: f,e
  f=invertcumul(ngrid+1,df,fi,e)
 end function
  
 function gasRfromq(q) result(gasr)
  real :: gasr,q,cm 
  cm=q*cmass(ngrid)
  gasr=invertcumul(ngrid+1,r,cmass,cm)
 end function 
 
 function fifromr(rad) result (lfi)
  real :: rad,lfi
  lfi=invertcumul(ngrid+1,fi,r,rad)  
 end function
 
 function rhofromfi(rad) result (lrho)
  real :: rad,lrho
  lrho=invertcumul(ngrid+1,dens,fi,rad)  
 end function

 function int_theta(densfunc,r) result(s)
 real,external :: densfunc
 real :: dctheta,s,r
 integer :: is
  s=0
  dctheta=1.0/ntheta
  s=s+densfunc(0.,r)+densfunc(r,0.)
  do is=1,ntheta-1,2
    ctheta=is*dctheta
    s=s+4*densfunc(r*sqrt(1-ctheta**2),r*ctheta)
  enddo
  do is=2,ntheta-2,2
    ctheta=is*dctheta
    s=s+2*densfunc(r*sqrt(1-ctheta**2),r*ctheta)
  enddo
  s=s*dctheta/3.
  s=s
 end function

 subroutine setparameters(halfmassr,nin,totalm)
  real, optional :: halfmassr,nin,totalm
  external gamma
  
  if(present(halfmassr)) then
   halfmassradius=halfmassr
  else
   print*,'Einasto halfmass radius?'
   read*,halfmassradius
  endif 
   
  if(present(nin)) then
   nindex=nin
  else
   print*,'Einasto n?'
   read*,nindex
  endif 

  if(present(totalm)) then
   mass=totalm
  else
   print*,'Einasto total mass?'
   read*,mass
  endif 
    
  alpha=1./nindex  
  dn=3*nindex-1./3+0.0079/nindex
  call gamma(3*nindex,ga)
  halfmassrho= &
    mass/(4*pi*nindex*halfmassradius**3*exp(dn)*dn**(-3*nindex)*ga)
  rho0=halfmassrho*exp(dn)
  rmin=1.e-4*halfmassradius
  rmax=1000*halfmassradius
   
 end subroutine

      
 subroutine initdf(densfunc)
  integer :: i,j
  real :: fac,int
  real, external :: densfunc
    
  fac=exp(log(rmax/rmin)/(1.*(ngrid-1)))  
!  fac=(rmax-rmin)/(ngrid-1.)

  r(1)=rmin
  dens(1)=rho(rmin)
  ddensdr(1)=drhodr(rmin)
  do i=2,ngrid-1
   r(i)=r(i-1)*fac
!   r(i)=r(i-1)+fac
   dens(i)=rho(r(i))
   ddensdr(i)=drhodr(r(i))
  enddo
  r(ngrid)=rmax  
  dens(ngrid)=rho(rmax)
  ddensdr(ngrid)=drhodr(rmax)
  r(0)=0.
  dens(0)=dens(1) ! assumption !
  ddensdr(0)=0.
!  dens(0)=(4*dens(1)-dens(2))/3.
!  ddensdr(0)=(dens(1)-dens(0))/r(1)

! external density  averaged over theta
  extdens(0)=1/3.*densfunc(0.,rmin)+2./3.*densfunc(rmin,0.)
  do i=1,ngrid
   extdens(i)=int_theta(densfunc,r(i))
  enddo

  cmass(0.)=0.
  cmass(1.)=4/3.*Pi*r(1)**3*dens(0)
  do i=2,ngrid
   cmass(i)=cmass(i-1)+4*Pi*(r(i)-r(i-1))*(r(i)**2*dens(i)+r(i-1)**2*dens(i-1))/2.
  enddo

  extmass(0)=0.
  extmass(1)=4/3.*Pi*r(1)**3*extdens(0)
  do i=2,ngrid
   extmass(i)=extmass(i-1)+4*Pi*(r(i)-r(i-1))*(r(i)**2*extdens(i)+r(i-1)**2*extdens(i-1))/2.
  enddo

  print*,'halo reports a mass of:', cmass(ngrid)
  print*,'and an external mass of:', extmass(ngrid)
  
  tmass=cmass+extmass
  
  fi(ngrid)=0 
  do i=ngrid-1,1,-1
   fi(i)=fi(i+1)+(r(i+1)-r(i))*(tmass(i)/r(i)**2+tmass(i+1)/r(i+1)**2)/2.
  enddo
  fi(0)=fi(1)+r(1)*(F_ZERO_R_LIMIT+tmass(1)/r(1)**2)/2.
 
  do i=1,ngrid
   ddrhodfi2(i)=(r(i)**2/tmass(i))**2* &
    ((2/r(i)-4*Pi*r(i)**2*(dens(i)+extdens(i))/tmass(i))*ddensdr(i)+ddrhodr2(r(i)))
  enddo
  ddrhodfi2(0)=ddrhodfi2(1)

  df(ngrid)=0.
  do i=ngrid-1,1,-1
   int=0
   do j=ngrid-1,i+1,-1
   int=int+(fi(j)-fi(j+1))* &
       (ddrhodfi2(j)/sqrt(fi(i)-fi(j))+ddrhodfi2(j+1)/sqrt(fi(i)-fi(j+1)))/2.
   enddo
   int=int+2./3.*Sqrt((fi(i)-fi(i+1)))*(2*ddrhodfi2(i)+ddrhodfi2(i+1))
   df(i)=1/sqrt(8.)/pi**2*(int-1/sqrt(fi(i))*ddensdr(ngrid)*r(ngrid)**2/cmass(ngrid))
  enddo
  df(0)=df(1)

  open(unit=1,file='halo.df',status='UNKNOWN')
  do i=1,ngrid
  write(1,*) fi(i),df(i)
  enddo
  close(1)
  
! print*,'rmax,fi0,cmass:', rmax,fi(0),cmass(ngrid)
 
 end subroutine
 
  function invertcumul(n,xlist,ylist,y) result(x)
  integer :: n,bin,up,low
  real :: xlist(n),ylist(n),x,y,u,s
  
  if(ylist(1).LT.ylist(n)) then
   s=1
  else
   s=-1
  endif  
  
  if(s*y.LE.s*ylist(1)) then
   x=xlist(1)
   return
  endif
  if(s*y.GE.s*ylist(n)) then
   x=xlist(n)
   return
  endif
  up=n
  low=1
  do while((up-low).GT.1)
   bin=(low+up)/2
   if(s*y.LT.s*ylist(bin)) then
    up=bin
   else
    low=bin
   endif   
  enddo 
  bin=up
  u=(y-ylist(bin-1))/(ylist(bin)-ylist(bin-1))
  x=(1-u)*xlist(bin-1)+u*xlist(bin)  
  return
  end function
 
end module sphericaldfMod

        SUBROUTINE GAMMA(X,GA)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION G(26)
!        PI=3.141592653589793D0
        IF (X.EQ.INT(X)) THEN
           IF (X.GT.0.0D0) THEN
              GA=1.0D0
              M1=X-1
              DO 10 K=2,M1
10               GA=GA*K
           ELSE
              GA=1.0D+300
           ENDIF
        ELSE
           IF (DABS(X).GT.1.0D0) THEN
              Z=DABS(X)
              M=INT(Z)
              R=1.0D0
              DO 15 K=1,M
15               R=R*(Z-K)
              Z=Z-M
           ELSE
              Z=X
           ENDIF
           DATA G/1.0D0,0.5772156649015329D0, &
     &          -0.6558780715202538D0, -0.420026350340952D-1, &
     &          0.1665386113822915D0,-.421977345555443D-1, &
     &          -.96219715278770D-2, .72189432466630D-2, &
     &          -.11651675918591D-2, -.2152416741149D-3, &
     &          .1280502823882D-3, -.201348547807D-4, &
     &          -.12504934821D-5, .11330272320D-5, &
     &          -.2056338417D-6, .61160950D-8, &
     &          .50020075D-8, -.11812746D-8, &
     &          .1043427D-9, .77823D-11, &
     &          -.36968D-11, .51D-12, &
     &          -.206D-13, -.54D-14, .14D-14, .1D-15/
           GR=G(26)
           DO 20 K=25,1,-1
20            GR=GR*Z+G(K)
           GA=1.0D0/(GR*Z)
           IF (DABS(X).GT.1.0D0) THEN
              GA=GA*R
              IF (X.LT.0.0D0) GA=-PI/(X*GA*DSIN(PI*X))
           ENDIF
        ENDIF
        RETURN
        END SUBROUTINE


 real function zerofunc(r,z)
  zerofunc=0.
 end function

subroutine sethalodf(halfmassr,nin,totalm)
 use sphericaldfMod
 real halfmassr,nin,totalm
 call setparameters(halfmassr,nin,totalm)
end subroutine

subroutine inithalodf(densfunc)
 use sphericaldfMod
 real, external :: zerofunc
 real, external, optional :: densfunc
 if(present(densfunc)) then
  call initdf(densfunc)
 else
  call initdf(zerofunc)
 endif
end subroutine

function halodfpsi00()
 use sphericaldfMod
 real halodfpsi00
 halodfpsi00=-maxE() 
end function

function halodffi(r)
 use sphericaldfMod
 real halodffi,r
! r>rmax??
 if(r.LT.rmax) then
  halodffi=-fifromr(r)
 else
  halodffi=totalmass()*(1/rmax-1/r)
 endif
end function

function Fhalo3(E)
 use sphericaldfMod
 real Fhalo3,E,nE
 Fhalo3=0
 if(E.LT.-maxE()) then
  print*, 'EEEEKS'
  print*, E, -maxE()
  stop
 endif 
 nE=-E ! note: E is expected always to be > psi0!!
 if(nE.LE.0) return
 Fhalo3=distf(nE)
end function 

function halodfdenspsi(psi,psi0)
 use sphericaldfMod
  real halodfdenspsi,psi,psi0,npsi
 halodfdenspsi=0
 npsi=-(psi-psi0+halodfpsi00())
 if(npsi.LE.0) return
 halodfdenspsi=rhofromfi(npsi)
end function

function halodfdens(r,z) result(x)
 use sphericaldfMod
  real r,z,x
  x=rho(sqrt(r*r+z*z))
end function 

function halormax()
 use sphericaldfMod
 real halormax
 halormax=rmax
end function 

function halormin()
 use sphericaldfMod
 real halormin
 halormin=rmin
end function 


 function sdens(r,z) 
  real r,z,sdens  
  real rmdisk,zdisk,outdisk,drtrunc,erfarg,truncfac,con,diskconst,rdisk
  zdisk=0.5
  rdisk=3
  rmdisk=50.
  diskconst=rmdisk/(4.0*3.1415*rdisk**2*zdisk)
  outdisk=12
  drtrunc=.5
  sdens = 0
  if( abs(z/zdisk) .gt. 30.) return
   erfarg=(r-outdisk)/1.4142136/drtrunc
  if (erfarg.gt.4.) return
  if (erfarg.lt.-4) then
   trunfac=1
  else
   trunfac=0.5*erfc(erfarg)
  endif
  if (z.eq.0.) then
   con=1
  else
   con = exp(-abs(z/zdisk))
   con = (2.0*con/(1.0 + con*con))**2
  endif
  sdens = diskconst*exp(-r/rdisk)*con*trunfac 
  end function

 program test
  use sphericaldfMod
  implicit none
    real :: r
    integer i,j,np,count
    real, external ::sdens,zerofunc
  
  call setparameters()
  call initdf(zerofunc)

  do i=0,100
    r=i/100.
    print*, r, rho(r), rhofromfi(fifromr(r))
  enddo
!  do i=0,ngrid-1
!   print*,r(i),dens(i),ddensdr(i)
!   print*,r(i),extdens(i),extmass(i)
!   print*,r(i),fi(i),df(i)
!  enddo  
 end program

      subroutine readdenspsibulge

      include 'commonblocks'

      open(file='denspsibulge.dat',unit=50,status='old')

      do i=1,npsi
         read(50,*) tableE(i),denspsibulge(i)
      enddo
      close(50)

      open(file='dfsersic.dat',unit=50,status='old')

      do i=1,npsi
         read(50,*) tableE(i),dfsersic(i)
      enddo

      close(50)
      return
      end

      subroutine readdenspsihalo

      include 'commonblocks'

      open(file='denspsihalo.dat',unit=50,status='old')

      do i=1,npsi
         read(50,*) tableE(i),denspsihalo(i)
      enddo
      close(50)

      open(file='dfnfw.dat',unit=50,status='old')

      do i=1,npsi
         read(50,*) tableE(i),dfnfw(i)
      enddo

      close(50)
      return
      end

      subroutine splintd(xa,ya,y2a,n,x,y)
      integer n
      real*4 x,y,xa(n),y2a(n),ya(n)
      integer k,khi,klo
      real*4 a,b,h
      data klo,khi /1,1/
      save khi,klo
c     check first of previous klo and khi are still ok.
      if (khi.le.n) then
         if (xa(khi).gt.x .and. xa(klo).lt.x .and. khi-klo.eq.1) goto 2
      endif
c     if not, search by bisection
      klo=1
      khi=n
 1    if (khi-klo.gt.1) then
         k=(khi+klo)/2
         if(xa(k).gt.x)then
            khi=k
         else
            klo=k
         endif
         goto 1
      endif
 2    h=xa(khi)-xa(klo)
      if (h.le.0.) pause 'bad xa input in splint'
      a=(xa(khi)-x)/h
      b=(x-xa(klo))/h
      y=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*
     *     (h**2)/6.
      return
      END

! density except halo df component
      function alldensnohalo(r,z) result(totaldens)      
       real totaldens
      common /flags/ idiskflag, ibulgeflag, ihaloflag
      totaldens=0
      if(idiskflag.EQ.2.OR.idiskflag.EQ.3)totaldens=totaldens+
     &  thickdiskdens(r,z)
      if(idiskflag.EQ.1.OR.idiskflag.EQ.3)totaldens=totaldens+
     &  tdskdens(r,z)   
      if(ibulgeflag.EQ.1) then
       print*,'dont know how to get bulge density!'        
       stop
      endif 

      if(ihaloflag.EQ.2) totaldens=totaldens+halofixeddens(r,z)     
      if(ibulgeflag.EQ.2) totaldens=totaldens+bulgefixeddens(r,z)
      if(ibulgeflag.EQ.3) totaldens=totaldens+bulgedfdens(r,z)
      end function

! density except bulge df component
      function alldensnobulge(r,z) result(totaldens)      
       real totaldens
      common /flags/ idiskflag, ibulgeflag, ihaloflag
      totaldens=0
      if(idiskflag.EQ.2.OR.idiskflag.EQ.3)totaldens=totaldens+
     &  thickdiskdens(r,z)
      if(idiskflag.EQ.1.OR.idiskflag.EQ.3)totaldens=totaldens+
     &  tdskdens(r,z)   
      if(ihaloflag.EQ.1) then
       print*,'dont know how to get halo density!'        
       stop
      endif 
      if(ihaloflag.EQ.2) totaldens=totaldens+halofixeddens(r,z)
      if(ihaloflag.EQ.3) totaldens=totaldens+halodfdens(r,z)
      if(ibulgeflag.EQ.2) totaldens=totaldens+bulgefixeddens(r,z)
      end function

      subroutine force(s,z,fs,fz,pot)

      parameter (pc0=0.282094792, pc2=0.630783131, pc4=0.846284375)
      parameter (pc6=1.017107236, pc8=1.163106623)
      real pc(20), p(20), dp(20)
      real pot

      include 'commonblocks.h'

      r=sqrt(s*s+z*z)
      ihi=int(r/dr)+1
      if (ihi.lt.1) ihi=1
      if (ihi.gt.nr) ihi=nr
      r1=dr*(ihi-1)
      r2=dr*ihi
      redge = nr*dr
      t=(r-r1)/(r2-r1)
      ihim1 = ihi - 1
      tm1 = 1.0 - t
      if (r.eq.0.) then
         fs = 0.0
         fz = 0.0
      else
         costheta=z/r
         ct2 = costheta*costheta
         sintheta=s/r
         
         do l=0,lmax,2
            pc(l/2+1) = sqrt((2.0*l + 1)/(4.0*pi))
            p(l/2+1) = plgndr1(l,costheta) 
            if( costheta .eq. 1.0 ) then
               dp(l/2+1) = 0.0
            else
               st2 = 1.0 - costheta*costheta
               dp(l/2+1) = l*(plgndr1(l-1, costheta) - 
     +              costheta*p(l/2+1))/st2
            endif
         enddo
         do i=1,lmax/2+1
            p(i) = p(i)*pc(i)
            dp(i) = dp(i)*pc(i)
         enddo

         if( r .le. redge ) then
             frr = 0.0
             do i=1,lmax/2+1
                frr = frr + p(i)*(t*fr(i,ihi) + tm1*fr(i,ihim1))
             enddo
             fth = 0.0
             do i=2,lmax/2+1
                fth = fth + sintheta*dp(i)*(t*apot(i,ihi) + 
     +               tm1*apot(i,ihim1))
             enddo
             pot = 0.0
             do i=1,lmax/2+1
                pot = pot + p(i)*(t*apot(i,ihi) + tm1*apot(i,ihim1))
             enddo
         else
             frr = 0.0
             do i=1,lmax/2+1
                 l = 2*(i-1)
                 frr = frr + (l+1)*p(i)*apot(i,nr) / 
     +                    redge*(redge/r)**(l+2)
             enddo
             fth = 0.0
             do i=2,lmax/2+1
                 l = 2*(i-1)
                 fth = fth + sintheta*dp(i)*apot(i,nr)*(redge/r)**(l+1)
             enddo
             pot = 0.0
             do i=1,lmax/2+1
                l = 2*(i-1)
                pot = pot + p(i)*apot(i,nr)*(redge/r)**(l+1)
             enddo
         endif
         if( idiskflag .eq. 1 ) then
             pot = pot + appdiskpot(s,z)
         endif

         fs = -(sintheta*frr + costheta/r*fth)
         fz = -(costheta*frr - sintheta/r*fth)
         if( idiskflag .eq. 1 ) then
            call appdiskforce(s,z,fsad,fzad)
            fs = fs + fsad
            fz = fz + fzad
         endif
      endif
      return
      end

      subroutine dbhplot(apot,lmax,nr,dr)
      parameter(ipmax=1000)
      real apot(20,0:20000),rp(1000),pplot(1000),iplot(ipmax)
      data ifirst /0/
      save rp,ifirst,nrp, iplot
      character*40 toplbl

      if (ifirst.eq.0) then
         ifirst=1
         nrp=1
         rp(nrp)=log10(dr)
         iplot(nrp)=1
         do ir=1,nr
            r=log10(ir*dr)
            if (r-rp(nrp).gt.0.01) then
               nrp=nrp+1
               rp(nrp)=r
               iplot(nrp)=ir
               if (nrp.ge.ipmax) then
                  write(*,*) 'Not able to plot all points in dbhplot.'
                  write(*,*) 'Increase ipmax parameter & recompile!'
                  goto 4
               endif
            endif
         enddo
      endif

 4    do l=0,lmax,2
         j=l/2+1
         pmax=-1e31
         pmin=1e31
         do irp=1,nrp
            pp=apot(j,iplot(irp))
            pmax=max(pmax,pp)
            pmin=min(pmin,pp)
            pplot(irp)=pp
         enddo
	 
         call pgenv(log10(dr),log10(nr*dr),pmin,pmax,0,1)
         call pgline(nrp,rp,pplot)
         write(toplbl,'(''l='',i3)') l
         call pglabel('log10(R)','POT',toplbl)
      enddo
      return
      end

      function halodens(r,z)
      common /flags/ idiskflag, ibulgeflag, ihaloflag

      halodens=0
      psi=pot(r,z)
      psi0=pot(0.,0.)
      if( ihaloflag .eq. 1 ) then
         halodens = halodens + densrpsi(r,psi)
      endif
      if( ihaloflag .eq. 3 ) then
         halodens = halodens + halodfdenspsi(psi,psi0)
      endif
      return
      end

      subroutine bulgepotential(bulgemass, bulgeedge)

      include 'commonblocks'

      real bulgepot(20,0:nmax), bulgefr(20,0:nmax)

      idiskflagint = 0
      ibulgeflagint = 1
      ihaloflagint = 0
      ibhflagint = 0
c Now get the harmonics of the density in this potential --> adens
      ntheta=lmax*4+2
      eps = 0.0001
      adens(1,0)=bulgedens(eps,0.0)*sqrt(4.*pi)
      do l=2,lmax,2
         adens(l/2+1,0)=0
         enddo
      do ir=1,nr
         adens(1,ir)=0
         enddo
c nrmax will mark the outermost radial bin with non-zero density.
      nrmx=nr
      do l=0,lmax,2
c integrate density * spherical harmonic function over quadrant
         do ir=1,nrmx
            r=ir*dr
            s=0
            dctheta=1.0/ntheta
            s=s+polarbulgedens(r,1.0,l)+polarbulgedens(r,0.0,l)
            do is=1,ntheta-1,2
               ctheta=is*dctheta
               s=s+4*polarbulgedens(r,ctheta,l)
            enddo
            do is=2,ntheta-2,2
               ctheta=is*dctheta
               s=s+2*polarbulgedens(r,ctheta,l)
            enddo
            s=s*dctheta/3.
            s=s*4*pi
            adens(l/2+1,ir)=s
            enddo
 77      enddo
c     now get the potential harmonics of this new density. Simpson's
c     rule integration. (BT 2-208)
      do l=0,lmax,2
         s1(0)=0
         do ir=2,nr,2
            r=ir*dr
            s1(ir)=s1(ir-2)+(dr/3.)*
     +           (adens(l/2+1,ir-2)*(r-2*dr)**(l+2)+
     +           4*adens(l/2+1,ir-1)*(r-dr)**(l+2)+
     +           adens(l/2+1,ir)*r**(l+2))
            enddo
         s2(nr)=0
         do ir=nr-2,2,-2
            r=ir*dr
            s2(ir)=s2(ir+2)+(dr/3.)*
     +           (adens(l/2+1,ir+2)*(r+2*dr)**(1-l)+
     +           4*adens(l/2+1,ir+1)*(r+dr)**(1-l)+
     +           adens(l/2+1,ir)*r**(1-l))
            enddo
         do ir=2,nr,2
            bulgepot(l/2+1,ir)=-4*pi/(2.*l+1.)*
     +              (s1(ir)/(ir*dr)**(l+1)+s2(ir)*(ir*dr)**l)
            enddo
c
c  Calculate the radial gradients
c
         do ir=2,nr,2
            bulgefr(l/2+1,ir)=-4*pi/(2.*l+1.)*
     +              (-(l+1)*s1(ir)/(ir*dr)**(l+2)+ 
     +           l*s2(ir)*(ir*dr)**(l-1))
            enddo
         enddo
c     now interpolate the gaps first quadratically interpolate the
c     monopole back to the origin.  the remaining multipoles are zero
c     there.
      bulgepot(1,0)=(4*bulgepot(1,2)-bulgepot(1,4))/3.
      fr(1,0)=0.0
      do l=2,lmax,2
         bulgepot(l/2+1,0)=0
         bulgefr(l/2+1,0)=0
         enddo
      do ir=1,nr-1,2
         do l=0,lmax,2
            bulgepot(l/2+1,ir)=(bulgepot(l/2+1,ir-1)+
     +           bulgepot(l/2+1,ir+1))/2.
            bulgefr(l/2+1,ir)=(bulgefr(l/2+1,ir-1)+
     +           bulgefr(l/2+1,ir+1))/2.
            enddo
         enddo
      a00=bulgepot(1,0)
      do ir=0,nr
         bulgepot(1,ir)=bulgepot(1,ir)-a00
         enddo
c write bulge final potential.
c
c Reset the potentials so that phi is 0 at infinity
c
      redge = nr*dr
      do l=0,lmax,2
          c0 = bulgepot(l/2+1,nr) + bulgefr(l/2+1,nr)*redge/(l+1)
          do i=0,nr
              bulgepot(l/2+1,i) = bulgepot(l/2+1,i) - c0
          enddo
      enddo

      open(11,file='b.dat',status='unknown')
      write(11,'('' # chalo,v0,a,nnn,v0bulge,abulge,dr,nr,lmax='')')
      write(11,'('' #'',7g15.5,i6,i4)') chalo,v0,a,nnn,v0bulge,abulge,
     +     dr,nr,lmax
      write(11,'('' # psi0, haloconst, bulgeconst:'')')
      write(11,'('' #'',3g15.5)') psi0,haloconst,bulgeconst
      write(11,'('' # Mdisk, rdisk, zdisk, outdisk, drtrunc'')')
      write(11,'('' #'',5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
      write(11,'('' # psic,psid,bhmass'')')
      write(11,'('' #'',3g15.5)') psic,psid,bhmass
      write(11,'('' #'',4i5)') idiskflagint, ibulgeflagint, 
     +     ihaloflagint, ibhflagint
      write(11,'('' #  OUTPUT FROM DBH8. TOTAL POTENTIAL.'')')

      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(adens(l/2+1,ir),l=0,lmax,2)
         enddo
      write(11,*)
      write(11,*)
      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(bulgepot(l/2+1,ir),l=0,lmax,2)
         enddo
      write(11,*)
      write(11,*)
      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(bulgefr(l/2+1,ir),l=0,lmax,2)
         enddo
      close(11)

      bulgemass = bulgefr(1,nr)/sqrt(4*pi)*(nr*dr)**2
      do ir=0, nr
          if( adens(1,ir) .eq. 0.0 ) then
              bulgeedge = ir*dr
              goto 999
          endif
      enddo
      bulgeedge = nr*dr
999   write(*,*) 'Bulge mass =', bulgemass
      write(*,*) 'Bulge edge radius =', bulgeedge
      write(*,*) 'Bulge harmonics written to file ''b.dat''.'
      return
      end

      function diskdf3ez(ep,am,ez)
      parameter (pi=3.1415926535)
      real psi00

      psi00 = pot(0.0,0.0)
      rc=rcirc(am)
      call omekap(rc,fomega,fkappa)
      vc=rc*fomega
c
      ec = - pot(rc,0.0)+0.5*vc**2
c
      if (am.lt.0.) ec = - 2.0*psi00 - ec
      sr2=sigr2(rc)
      sz2=sigz2(rc)

      if (sz2.gt.0.) then
         fvert=fnamidden(rc)*exp(-ez/sz2)/sqrt(2*pi*sz2)
         diskdf3ez=fomega/(pi*fkappa)/sr2*exp(-(ep - ec)/sr2)*fvert
      else
         diskdf3ez=0
      endif

      return
      end
      

      function diskdenspsi(r,z,psi) 

      include 'commonblocks'

      real psi
 
c the truncation factor is derived assuming that the azimuthal velocity dist
c is gaussian with dispersion sigma_R * 2 omega/kappa, as per epicycle theory.
      if( abs(z/zdisk) .gt. 10.) goto 99
      erfarg=(r-outdisk)/1.4142136/drtrunc
      if (erfarg.gt.4.) goto 99
      if (erfarg.lt.-4) then
         trunfac=1
      else
         trunfac=0.5*erfc(erfarg)
      endif
      if (z.eq.0.) then
         con=1
      else
        psizh= pot(r,zdisk)
        psi00 = pot(r,0.)
        con = 0.419974**((psi-psi00)/(psizh-psi00))
      endif
      diskdenspsi = diskconst*exp(-r/rdisk)*con*trunfac
      return
 99   diskdenspsi = 0.0
      return
      end

      function bulgedenspsi(psi,psi0)
      parameter (pi=3.1415926535, sq8=2.828427125)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea

!      print*,psi,psi0,psiout
      if (psi-psi0.gt.psiout) then
         bulgedenspsi=0
      else
         t1=-(psi-psi0-psiout)/sigbulge2
         if( t1 .gt. 80) then
            t1 = 80
         endif
         bulgedenspsi=bulgea*(exp(t1)*erf(sqrt(t1))-sqrt(4*t1/pi)*(1+0.6666667*t1))
         endif
      return
      end

      function diskdens(r,z,psi) 

      include 'commonblocks'
      real psi

c the truncation factor is derived assuming that the azimuthal velocity dist
c is gaussian with dispersion sigma_R * 2 omega/kappa, as per epicycle theory.

      if( idiskflag .eq. 0 ) then
         diskdens = 0
         return
      endif
      if( abs(z/zdisk) .gt. 30.) goto 99
      erfarg=(r-outdisk)/1.4142136/drtrunc
      if (erfarg.gt.4.) goto 99
      if (erfarg.lt.-4) then
         trunfac=1
      else
         trunfac=0.5*erfc(erfarg)
      endif

      if (z.eq.0.) then
         con=1
      elseif ( ihaloflag .eq. 0 .and. ibulgeflag .eq. 0 ) then
c only doing a disk potential
         con = exp(-abs(z/zdisk))
         con = (2.0*con/(1.0 + con*con))**2
      else
c     make disk vertically isothermal; normalize density so that
c     at height 3*zdisk the vertical density drop is that of a sech^2.
         psizh=pot(r,3*zdisk)
         psi00=pot(r,0.)
         dpsizh = psi00 - psizh
         dpsi   = psi00 - psi
         coeff = 0.0
         if( abs(dpsizh) .gt. 0.0) then
            coeff = dpsi/dpsizh
         endif
         if( coeff .gt. 16. .or. coeff .lt. 0.0 ) then
            con = 0.0
         else
            con = 0.009866**coeff
         endif
      endif
      diskdens = diskconst*exp(-r/rdisk)*con*trunfac
      return
 99   diskdens=0.0
      return
      end

c--------------------------------
      function sigz2(r)
      parameter(nrmax=1000)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      common /diskpars/ sigr0, disksr, nrdisk
      common /splines/ rr(0:nrmax),fdrat(0:nrmax),drat2(0:nrmax),
     +              fszrat(0:nrmax), szrat2(0:nrmax), nrspl

c velocity dispersion is fixed so that at a height of diskz the
c density of an isothermal component has fallen by sech(1)**2=0.419974
      psizh=pot(r,zdisk)
      psi0=pot(r,0.0)
      truesigz2=(psi0-psizh)/log(0.419974)	

      call splintd(rr(0),fszrat(0),szrat2(0),nrspl+1,r,fcor)
      if(fcor.lt.0) fcor=1
      sigz2=truesigz2*fcor
!      print*,'b',fcor,psi0,psizh,r	
      return
      end

      function tdskdens(r,z)
      parameter (pi=3.1415926535)

      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      common /flags/ idiskflag, ibulgeflag, ihaloflag
      tdskdens = 0
      if( idiskflag .eq. 0 .OR.idiskflag.EQ.2) return
      if( abs(z/zdisk) .gt. 30.) return
      erfarg=(r-outdisk)/1.4142136/drtrunc
      if (erfarg.gt.4.) return
      if (erfarg.lt.-4) then
         trunfac=1
      else
         trunfac=0.5*erfc(erfarg)
      endif
      if (z.eq.0.) then
        con=1
      else
         con = exp(-abs(z/zdisk))
         con = (2.0*con/(1.0 + con*con))**2
      endif
      tdskdens = diskconst*exp(-r/rdisk)*con*trunfac            
      
      end function

      function diskdens(r,z,psi) 
      parameter (pi=3.1415926535)

      common /potconstants/ apot(20,0:20000), fr(20,0:20000), 
     +     dr, nr, lmax, potcor
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      common /flags/ idiskflag, ibulgeflag, ihaloflag

c the truncation factor is derived assuming that the azimuthal velocity dist
c is gaussian with dispersion sigma_R * 2 omega/kappa, as per epicycle theory.
      if( idiskflag .eq. 0 .OR.idiskflag.EQ.2) then
         diskdens = 0
         return
      endif
      if( abs(z/zdisk) .gt. 30.) goto 99
      erfarg=(r-outdisk)/1.4142136/drtrunc
      if (erfarg.gt.4.) goto 99
      if (erfarg.lt.-4) then
         trunfac=1
      else
         trunfac=0.5*erfc(erfarg)
      endif
      if (z.eq.0.) then
        con=1
      elseif ( ihaloflag .eq. 0 .and. ibulgeflag .eq. 0 ) then
c only doing a disk potential
         con = exp(-abs(z/zdisk))
         con = (2.0*con/(1.0 + con*con))**2
      else
c make disk vertically isothermal; normalize density so that
c at height 3*zdisk the vertical density drop is that of a sech^2.
!        psizh=pot(r,2*zdisk)
        psizh=pot(r,3*zdisk)
!        psizh=pot(r,4*zdisk)
!        psizh=pot(r,5.*zdisk)
        psi0=pot(r,0.)
        dpsizh = psizh - psi0
        dpsi   = psi - psi0
        coeff = 0.0
        if( abs(dpsizh) .gt. 0.0) then
            coeff = dpsi/dpsizh
        endif
		if( coeff .gt. 16. .or. coeff .lt. 0.0 ) then
            con = 0.0
        else
!            con = 0.0706508**coeff
            con = 0.009866**coeff
!            con = 0.00134095**coeff
!	    con = 0.000181583**coeff
        endif
      endif
      diskdens = diskconst*exp(-r/rdisk)*con*trunfac
      return
 99   diskdens=0.0
      return
      end

      function tdskdens2(r,z,psi,psi1,psi2) 
      parameter (pi=3.1415926535)

      common /potconstants/ apot(20,0:20000), fr(20,0:20000), 
     +     dr, nr, lmax, potcor
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      common /flags/ idiskflag, ibulgeflag, ihaloflag

c the truncation factor is derived assuming that the azimuthal velocity dist
c is gaussian with dispersion sigma_R * 2 omega/kappa, as per epicycle theory.
      if( idiskflag .eq. 0 .OR.idiskflag.EQ.2) then
         tdskdens2 = 0
         return
      endif
      if( abs(z/zdisk) .gt. 30.) goto 99
      erfarg=(r-outdisk)/1.4142136/drtrunc
      if (erfarg.gt.4.) goto 99
      if (erfarg.lt.-4) then
         trunfac=1
      else
         trunfac=0.5*erfc(erfarg)
      endif
      if (z.eq.0.) then
        con=1
      elseif ( ihaloflag .eq. 0 .and. ibulgeflag .eq. 0 ) then
c only doing a disk potential
         con = exp(-abs(z/zdisk))
         con = (2.0*con/(1.0 + con*con))**2
      else
c make disk vertically isothermal; normalize density so that
c at height 3*zdisk the vertical density drop is that of a sech^2.
!        psizh=pot(r,2*zdisk)
!        psizh=pot(r,3*zdisk)
!        psizh=pot(r,4*zdisk)
        psizh=psi2
!        psizh=pot(r,5.*zdisk)
!        psi0=pot(r,0.)
        psi0=psi1
        dpsizh = psizh - psi0
        dpsi   = psi - psi0
        coeff = 0.0
        if( abs(dpsizh) .gt. 0.0) then
            coeff = dpsi/dpsizh
        endif
		if( coeff .gt. 16. .or. coeff .lt. 0.0 ) then
            con = 0.0
        else
!            con = 0.0706508**coeff
!            con = 0.009866**coeff
            con = 0.00134095**coeff
!	    con = 0.000181583**coeff
        endif
      endif
      tdskdens2 = diskconst*exp(-r/rdisk)*con*trunfac
      return
 99   tdskdens2=0.0
      return
      end

! nicked and adapted from IFEFFIT, the  Interactive XAFS Analysis Library
       SUBROUTINE PGVPORT (XLEFT, XRIGHT, YBOT, YTOP)
       REAL XLEFT, XRIGHT, YBOT, YTOP
       END

       SUBROUTINE PGWNAD (X1, X2, Y1, Y2)
       REAL X1, X2, Y1, Y2
       END
       
       SUBROUTINE PGCONS (A, IDIM, JDIM, I1, I2, J1, J2, C, NC, TR)
       INTEGER IDIM, JDIM, I1, I2, J1, J2, NC
       REAL    A(IDIM,JDIM), C(*), TR(6)
       END
       
       INTEGER FUNCTION PGBEGIN (UNIT, FILE, NXSUB, NYSUB)
       INTEGER       UNIT
       CHARACTER*(*) FILE
       INTEGER       NXSUB, NYSUB
       PGBEGIN=1
       END
       
       SUBROUTINE PGSVP (XLEFT, XRIGHT, YBOT, YTOP)
       REAL XLEFT, XRIGHT, YBOT, YTOP
       END
       
       SUBROUTINE PGQWIN (X1, X2, Y1, Y2)
       REAL X1, X2, Y1, Y2
       END
       
       SUBROUTINE PGQVP (UNITS, X1, X2, Y1, Y2)
       INTEGER UNITS
       REAL    X1, X2, Y1, Y2
       END

       SUBROUTINE PGLAB (XLBL, YLBL, TOPLBL)
       CHARACTER*(*) XLBL, YLBL, TOPLBL
       END

       SUBROUTINE PGLABEL (XLBL, YLBL, TOPLBL)
       CHARACTER*(*) XLBL, YLBL, TOPLBL
       END
       
       SUBROUTINE PGENV (XMIN, XMAX, YMIN, YMAX, JUST, AXIS)
       REAL XMIN, XMAX, YMIN, YMAX
       INTEGER JUST, AXIS
       END

       subroutine pgend 
       return
       end

       subroutine pgclos 
       return
       end

       integer function pgopen(i)
       integer i
       pgopen = 0
       return
       end

       subroutine  pgqid(i)
       integer i
       i = 0
       return
       end
c
       subroutine pgslct(i)
       integer i
       return
       end
c
       subroutine  pgbeg(i, file, j, k)
       integer i,j, k
       character*(*) file
       print*, ' pgplot not installed'
       return
       end
c
       subroutine pgqinf(type, arg, i)
       integer i
       character*(*) type, arg
       i = 0
       return
       end
c
       subroutine pgpage
       return
       end
c
       subroutine  pgbbuf 
       return
       end
c
       subroutine pgask(flag)
       logical flag
       return
       end
c
       subroutine pgeras
       return
       end
c
       subroutine pgsls(i)
       integer i
       return
       end
c
       subroutine pgsch(x)
       real x
       return
       end
c
       subroutine pgscf(i)
       integer i
       return
       end
c
       subroutine pgslw(i)
       integer i
       return
       end
c
       subroutine pgvstd
       return
       end
c
       subroutine pgpt1(x1,x2,i)
       real x1,x2
       integer i
       return
       end
c
       subroutine pgrnge(x1,x2,x3,x4)
       real x1,x2,x3,x4
       return
       end
c
       subroutine pgsci(i)
       integer i
       return
       end
c
       subroutine pgswin(x1,x2,x3,x4)
       real x1,x2,x3,x4
       return
       end
c
       subroutine pgbox(s1,x1,i1,s2,x2,i2)
       integer i1, i2
       character*(*) s1, s2
       real x1, x2
       return
       end
c
       subroutine pgmtxt(s1, x1, x2, x3, s2)
       character*(*) s1, s2
       real x1, x2, x3
       return
       end
c
       subroutine pgline(i1,x1,x2)
       integer i1
       real x1(*), x2(*)
       return
       end
c
       subroutine pgpt(i1,x1,x2,i2)
       integer i1, i2
       real x1(*), x2(*)
       return
       end
c
       subroutine pgtext(x1, x2, s1)
       character*(*) s1
       real x1, x2
       return
       end
c
       subroutine pgebuf
       return
       end
c
       subroutine pgscrn(i1,s1,i2)
       character*(*) s1
       integer i1, i2
       return
       end
c
       subroutine pgscr(i,r,g,b)
       integer i
       real r, g, b
       return
       end
c
       integer function pgcurs(x,y,c)
       real x,y
       character*(*) c
       pgcurs = 1
       x = 0
       y = 0
       c = 'a'
       return
       end
c      
       subroutine  pgsah(i,x,y)
       real x,y
       integer i
       return
       end
       subroutine  pgarro(x,y,u,v)
       real x,y,u,v
       return
       end

       integer function pgband(m,n,x1,y1,x,y,c)
       real x1,y1,x,y
       character*(*) c
       integer m,n
       pgband = 1
       x = x1
       y = y1
       c = 'a'
       m = 0
       return
       end
       
       subroutine pgqndt(i)
       integer i
       return
       end

       subroutine pgqdt(i,s1,i2,s2,i3,i4)
       integer i, i2, i3, i4
       character s1*(*), s2*(*)
       return
       end

       subroutine pgerry(n,x,y1,y2,t)
       integer i
       real x(*), y1(*), y2(*), t
       return
       end
       subroutine pgerrx(n,x,y1,y2,t)
       integer i
       real x(*), y1(*), y2(*), t
       return
       end

        subroutine  readmm
	
	real r,drhalo,dr,fixedpot,radhalo(10000),rhohalo(10000),
     &	 xmhalo(10000),upothalo(10000),f2halo(10000),fhalo(10000),masshalo
        integer i,in,in1,nhalo
	
	character*16 halofile
	logical firstcall
	
	common/fixed/nhalo,masshalo,drhalo,radhalo,rhohalo,xmhalo,
     &   upothalo,fhalo,f2halo
	
		 halofile='MODEL.MASS'
	 OPEN(19,FILE=halofile,
     &	    STATUS='OLD',iostat=ioerror)
	 IF(ioerror.NE.0) THEN
	  print*,' stop -- error reading halofile:',halofile
	  stop
	 ENDIF 
	 READ(19,*) nhalo
	 
	 IF(nhalo.GT.10000) THEN
	  print*,' nhalo overflow'
	  stop
	 ENDIF

         DO i=1,nhalo
          READ(19,*) radhalo(i),rhohalo(i),xmhalo(i),upothalo(i),fhalo(i),
     &	  f2halo(i)
	 ENDDO
	 
         CLOSE(19)
	 
	 masshalo=xmhalo(nhalo)
         drhalo=radhalo(5)-radhalo(4)
		
	end
	
	function fixedpot(r)
	
	real r,drhalo,dr,fixedpot,radhalo(10000),rhohalo(10000),
     &	 xmhalo(10000),upothalo(10000),f2halo(10000),fhalo(10000),masshalo
        integer i,in,in1,nhalo
	
	character*16 halofile
	logical firstcall
	
	common/fixed/nhalo,masshalo,drhalo,radhalo,rhohalo,xmhalo,
     &   upothalo,fhalo,f2halo
	common/firstt/ firstcall
	data firstcall/.TRUE./
	
	
	if(firstcall) then
	 firstcall = .FALSE.
         call readmm	
	endif


       if(r.GE.radhalo(1)) then
        if(r.LE.radhalo(nhalo)) then
         in=(r-radhalo(1))/drhalo
         in1=in+1
         dr=(r-radhalo(1))/drhalo-in
         fixedpot=(1-dr)*upothalo(in1)+dr*upothalo(in1+1)
        else
         fixedpot=upothalo(nhalo)
        endif
       else
        fixedpot=upothalo(1)
       endif
       
       end

        function halofixeddens(r,z) result(x)
         real r,z,x
         x=fixeddens(sqrt(r*r+z*z))
        end function

        function fixeddens(r)

	real r,drhalo,dr,fixeddens,radhalo(10000),rhohalo(10000),
     &	 xmhalo(10000),upothalo(10000),f2halo(10000),fhalo(10000),masshalo
        integer i,in,in1,nhalo
	
	character*16 halofile
	logical firstcall
	
	common/fixed/nhalo,masshalo,drhalo,radhalo,rhohalo,xmhalo,
     &   upothalo,fhalo,f2halo
	common/firstt/ firstcall
			
	if(firstcall) then
	 firstcall = .FALSE.
         call readmm		
	endif


       if(r.GE.radhalo(1)) then
        if(r.LE.radhalo(nhalo)) then
         in=(r-radhalo(1))/drhalo
         in1=in+1
         dr=(r-radhalo(1))/drhalo-in
         fixeddens=(1-dr)*rhohalo(in1)+dr*rhohalo(in1+1)
        else
         fixeddens=rhohalo(nhalo)
        endif
       else
        fixeddens=rhohalo(1)
       endif
       
       end

        function fixedforce(r)

	real r,drhalo,dr,fixedforce,radhalo(10000),rhohalo(10000),
     &	 xmhalo(10000),upothalo(10000),f2halo(10000),fhalo(10000),masshalo
        integer i,in,in1,nhalo
	
	character*16 halofile
	logical firstcall
	
	common/fixed/nhalo,masshalo,drhalo,radhalo,rhohalo,xmhalo,
     &   upothalo,fhalo,f2halo
	common/firstt/ firstcall
		
	if(firstcall) then
	 firstcall = .FALSE.
         call readmm	
	endif

       if(r.GE.radhalo(1)) then
        if(r.LE.radhalo(nhalo)) then
         in=(r-radhalo(1))/drhalo
         in1=in+1
         dr=(r-radhalo(1))/drhalo-in
         fixedforce=(1-dr)*fhalo(in1)+dr*fhalo(in1+1)
        else
         fixedforce=fhalo(nhalo)
        endif
       else
        fixedforce=fhalo(1)
       endif
       
       end

        function fixedf2(r)

	real r,drhalo,dr,fixedf2,radhalo(10000),rhohalo(10000),
     &	 xmhalo(10000),upothalo(10000),f2halo(10000),fhalo(10000),masshalo
        integer i,in,in1,nhalo
	
	character*16 halofile
	logical firstcall
	
	common/fixed/nhalo,masshalo,drhalo,radhalo,rhohalo,xmhalo,
     &   upothalo,fhalo,f2halo
	common/firstt/ firstcall
			
	if(firstcall) then
	 firstcall = .FALSE.
         call readmm		
	endif


       if(r.GE.radhalo(1)) then
        if(r.LE.radhalo(nhalo)) then
         in=(r-radhalo(1))/drhalo
         in1=in+1
         dr=(r-radhalo(1))/drhalo-in
         fixedf2=(1-dr)*f2halo(in1)+dr*f2halo(in1+1)
        else
         fixedf2=f2halo(nhalo)
        endif
       else
        fixedf2=f2halo(1)
       endif
       
       end


       
!       program test
!       real r,p1,p2,p3,p4
!       integer i
!10     read*,r
!       if(r.EQ.0) stop
!       p2=fixeddens(r)
!       p1=fixedpot(r)
!       p3=fixedforce(r)
!       p4=fixedf2(r)
!       print*,r,p1,p2,p3,p4
!       goto 10
!        do i=0,1000
!	 r=.01*i
!	 p1=fixedf2(r)
!	 print*,r,p1
!	enddo 
!       end
              

c to fix: interpolation in rcirc does not seem to work well. after 
c that, hope that things come together!

      subroutine readdiskdf(filename1,ibuf)
      parameter(nrmax=1000)
      parameter (pi=3.1415926535)
      integer*4 ibuf(15)
      character*60 filename, filename1

      common /fileroot/ filename
      common /potconstants/ apot(20,0:20000), frad(20,0:20000), 
     +     dr, nr, lmax, potcor
      common /legendre/ plcon(0:40)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      common /diskpars/ sigr0, disksr, nrdisk
      common /splines/ rr(0:nrmax), fdrat(0:nrmax), drat2(0:nrmax), 
     +                 fszrat(0:nrmax), szrat2(0:nrmax), nrspl

      call readharmfile(filename1,ibuf)
      filename = filename1
c Read in the correction functions
c
      write(0,*) 'Reading disk DF correction functions from cor'//filename

      open(17,file='cor'//filename,status='old')
      read(17,'(2x, 2g17.7,x,i4)') sigr0,disksr,nrspl
      do i=0,nrspl
         read(17,*) rr(i),fdrat(i),fszrat(i)
c         write(0,*) rr(i),fdrat(i),fszrat(i)
      enddo
      close(17)
      call splined(rr(0),fdrat(0),nrspl+1,1.e32,1.e32,drat2(0))
      call splined(rr(0),fszrat(0),nrspl+1,1.e32,1.e32,szrat2(0))

      rfid = 2.5*rdisk
      call omekap(rfid,fom,fka)
      sigr = sqrt(sigr2(rfid))
      sigden = diskdensf(rfid,0.0)*2.0*zdisk

c
c a close estimate of the disk surface density
c
      sigrcrit = 3.36*sigden/fka
      qtoomre = sigr/sigrcrit
      write(0,*) 'Toomre Q = ',qtoomre, ' at R = 2.5 R_d'

      open(12,file='toomre.dat',status='unknown')
      do i=0, nrspl
          call omekap(rr(i),fom,fka)
          sigr = sqrt(sigr2(rr(i)))
          sigden = diskdens(rr(i),0.0)*2.0*zdisk
          sigrcrit = 3.36*sigden/fka
          qtoomre = sigr/sigrcrit
          write(12,*) rr(i), qtoomre
      enddo
      close(12)

      return

      end

      subroutine effectivescalelength(aeff)

      include 'commonblocks'
      
      
      sig2 = -psi0
      vb2 = v0bulge*v0bulge
      v02 = v0*v0
      if(v0bulge.ne.0.) then
         coef1 = 4./v0bulge/abulge/abulge*((vb2/sig2)**2.5)
      else
         coef1 = 0.
      endif
      coef2 = 1./v0/a/a*(((v02+2.*vb2)/sig2)**2.5)	  
      coef3 = sig2**1.5
      aeff = sqrt(4.*sig2/coef3/(coef1+coef2));
      return
      end

      subroutine dfcorrectionhalo(e,fac)

      include 'commonblocks'
      
      sig2 = -psi0
      call effectivescalelength(aeff)
c      fac = 1 + 3.*pi/4.*
c     +     ((bhmass/aeff/sig2)**1.5)/((1-e/sig2)**3.)

      del = 0.1/aeff
      den = sqrt((1-e/sig2)**2. + del**2.)
      fac = 1 + 3.*pi/4.*
     +     ((bhmass/aeff/sig2)**1.5)/(den**3.)
      return
      end

      subroutine dfcorrectionbulge(e,fac)

      include 'commonblocks'

      sig2 = -psi0
      call effectivescalelength(aeff)
      fac = 1 + 3.*pi/4.*
     +     ((bhmass/aeff/sig2)**1.5)/((1-e/sig2)**3.)
      return
      end

      function potbh(R,z)

      include 'commonblocks'

      potbh = - bhmass/sqrt(R*R + z*z)

      return
      end

      

      FUNCTION PLGNDR1(L,X)
      PMM=1.
      IF(L.EQ.0) THEN
        PLGNDR1=PMM
      ELSE
        PMMP1=X*PMM
        IF(L.EQ.1) THEN
          PLGNDR1=PMMP1
        ELSE
          DO 12 LL=2,L
            PLL=(X*(2*LL-1)*PMMP1-(LL-1)*PMM)/(LL)
            PMM=PMMP1
            PMMP1=PLL
12        CONTINUE
          PLGNDR1=PLL
        ENDIF
      ENDIF
      RETURN
      END

c this file contains the following subroutines:
c
c readharmfile: reads a file with the harmonic expansion of the potential and density.
c all the relevant stuff ends up in a common block that only needs to be seen by
c the routines in this file (I think!). This routine must be called first.
c
c dens(r,z): density at point (r,z)
c
c densrpsi(r,psi): density as a function of r and potential psi.
c
c pot(r,z): potential at point (r,z)
c
c force(r,z,fr,fz): radial and z  force at (r,z)
c all the rest is (slightly nobbled in places) numerical recipes routines.
c


c
c calculate the force by interpolating the derived radial functions
c
c      subroutine force(lm,s,z,fs,fz,fs1,fz1)
      subroutine force(s,z,fs,fz,pot)
      parameter (pi=3.1415926535)
      parameter (pc0=0.282094792, pc2=0.630783131, pc4=0.846284375)
c constants cn are sqrt((2*l+1)/(4*pi))
      parameter (pc6=1.017107236, pc8=1.163106623)

      dimension pc(20), p(20), dp(20)
      common /potconstants/ apot(20,0:20000), frad(20,0:20000), 
     +     dr, nr, lmax, potcor
      common /legendre/ plcon(0:40)
      common /gparameters/ a,b,c,v0,q,psi00, 
     +                      psiouta, rho1a, sigbulge, 
     +                      grmdisk, grdisk, gzdisk, goutdisk, gdrtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      common /diskpars/ sigr0, disksr, nrdisk

      common /flags/ idiskflag, ibulgeflag, ihaloflag

c      write(*,*) 'Force entered with s,z=',s,z
c      write(*,*) 'lmax =',lmax
c      write(*,*) 'apot starts as:'
c      do ll=1,3
c         write(*,*) (apot(ll,i),i=1,10)
c      enddo
      r=sqrt(s*s+z*z)
      ihi=int(r/dr)+1
      if (ihi.lt.1) ihi=1
      if (ihi.gt.nr) ihi=nr
      r1=dr*(ihi-1)
      r2=dr*ihi
      redge = nr*dr
      t=(r-r1)/(r2-r1)
      ihim1 = ihi - 1
      tm1 = 1.0 - t
      if (r.eq.0.) then
         fs = 0.0
         fz = 0.0
      else
         costheta=z/r
         ct2 = costheta*costheta
         sintheta=s/r
         
         do l=0,lmax,2
            pc(l/2+1) = sqrt((2.0*l + 1)/(4.0*pi))
            p(l/2+1) = plgndr1(l,costheta) 
			if( costheta .eq. 1.0 ) then
               dp(l/2+1) = 0.0
            else
               st2 = 1.0 - costheta*costheta
               dp(l/2+1) = l*(plgndr1(l-1, costheta) - costheta*p(l/2+1))/st2
            endif
         enddo
         do i=1,lmax/2+1
            p(i) = p(i)*pc(i)
            dp(i) = dp(i)*pc(i)
         enddo

         if( r .le. redge ) then
             fr = 0.0
             do i=1,lmax/2+1
                fr = fr + p(i)*(t*frad(i,ihi) + tm1*frad(i,ihim1))
             enddo
             fth = 0.0
             do i=2,lmax/2+1
                fth = fth - sintheta*dp(i)*(t*apot(i,ihi) + tm1*apot(i,ihim1))
             enddo
             pot = 0.0
             do i=1,lmax/2+1
                pot = pot + p(i)*(t*apot(i,ihi) + tm1*apot(i,ihim1))
             enddo
         else
! expressions below for fr and pot not correct if apot shifted!!
             fr = 0.0
             do i=1,lmax/2+1
                 l = 2*(i-1)
                 fr = fr - (l+1)*p(i)*apot(i,nr)/redge*(redge/r)**(l+2)
             enddo
             fth = 0.0
             do i=2,lmax/2+1
                 l = 2*(i-1)
                 fth = fth - sintheta*dp(i)*apot(i,nr)*(redge/r)**(l+1)
	     enddo
             pot = 0.0
             do i=1,lmax/2+1
                l = 2*(i-1)
                pot = pot + p(i)*apot(i,nr)*(redge/r)**(l+1)
             enddo
         endif
         if( idiskflag .eq. 1.OR.idiskflag.EQ.3 ) then
             pot = pot + appdiskpot(s,z)
         endif
 
      if( idiskflag .eq. 2 .or. idiskflag .eq. 3) then
       pot= pot + thickdiskpot(s,z)      
!       fr=fr+thickdiskforce(r)
! fth (or rather fs and fz directly) tbd, see below
      endif

      if(ihaloflag.eq.2) then
       pot= pot + fixedpot(r)
       fr=fr-fixedforce(r)
! fixed force negative, fr positive       
! fixed halo is spherical so no fth       
      endif 

         fs = -(sintheta*fr + costheta/r*fth)
         fz = -(costheta*fr - sintheta/r*fth)
 
!         write(*,*) 'Force before disk correction ',fr,fth
         if( idiskflag .eq. 1 .OR. idiskflag.EQ.3) then
            call appdiskforce(s,z,fsad,fzad)
c            write(*,*) 'Force of disk correction ',fsad,fzad
            fs = fs + fsad
            fz = fz + fzad
         endif

         if( idiskflag .eq. 2 .OR. idiskflag.EQ.3) then
!            print*,fs,fz,thickdiskrforce(s,z)
            fs = fs + thickdiskrforce(s,z)
            fz = fz + thickdiskzforce(s,z)
         endif
      endif
      return
      end

      function polardens(r,ctheta,l)
      parameter(pi=3.1415926535)
c returns density at r,theta, multiplied by the lth harmonic
c (must integrate this over theta to get the harmonic coeff)
      common/legendre/ plcon(0:40)
      real psi

      z=r*ctheta
      s=r*sqrt(1.0 - ctheta*ctheta)
      polardens=dens(s,z)*plcon(l)*plgndr1(l,ctheta)

      return
      end

! tbd: ftheta
      subroutine halopotential(halomass, haloedge) 

      common /potconstants/ apot(20,0:20000), fr(20,0:20000), 
     +     dr, nr, lmax, potcor
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      common /flags/ idiskflag, ibulgeflag, ihaloflag

      real halopot(20,0:20000), halofr(20,0:20000)

      parameter(pi=3.1415926535)
      real adens(20,0:20000),s1(0:20000),s2(0:20000)

!      idiskflag = 0
!      ibulgeflag = 0
!      ihaloflag = 1
c Now get the harmonics of the density in this potential --> adens
      ntheta=lmax*4+2
      adens(1,0)=halodens(0.,0.)*sqrt(4.*pi)
      do l=2,lmax,2
         adens(l/2+1,0)=0
         enddo
      do ir=1,nr
         adens(1,ir)=0
         enddo
c nrmax will mark the outermost radial bin with non-zero density.
      nrmax=nr
      do l=0,lmax,2
c integrate density * spherical harmonic function over quadrant
         do ir=1,nrmax
            r=ir*dr
            s=0
            dctheta=1.0/ntheta
            s=s+polarhalodens(r,1.0,l)+polarhalodens(r,0.0,l)
            do is=1,ntheta-1,2
               ctheta=is*dctheta
               s=s+4*polarhalodens(r,ctheta,l)
            enddo
            do is=2,ntheta-2,2
               ctheta=is*dctheta
               s=s+2*polarhalodens(r,ctheta,l)
            enddo
            s=s*dctheta/3.
            s=s*4*pi
            adens(l/2+1,ir)=s
c            if (l.eq.0 .and. s.eq.0.) then
c               nrmax=nr
c               nrmax=nrmax+mod(nrmax,2)
c               goto 77
c               endif
c      write(*,*) 'a(',l,') =',s,'at r=',r
            enddo
 77      enddo
c now get the potential harmonics of this new density. Simpson's rule integration. (BT 2-208)
      do l=0,lmax,2
         s1(0)=0
         do ir=2,nr,2
            r=ir*dr
            s1(ir)=s1(ir-2)+(dr/3.)*
     +           (adens(l/2+1,ir-2)*(r-2*dr)**(l+2)+4*adens(l/2+1,ir-1)*(r-dr)**(l+2)+
     +           adens(l/2+1,ir)*r**(l+2))
            enddo
         s2(nr)=0
         do ir=nr-2,2,-2
            r=ir*dr
            s2(ir)=s2(ir+2)+(dr/3.)*
     +           (adens(l/2+1,ir+2)*(r+2*dr)**(1-l)+4*adens(l/2+1,ir+1)*(r+dr)**(1-l)+
     +           adens(l/2+1,ir)*r**(1-l))
            enddo
         do ir=2,nr,2
            halopot(l/2+1,ir)=-4*pi/(2.*l+1.)*
     +              (s1(ir)/(ir*dr)**(l+1)+s2(ir)*(ir*dr)**l)
            enddo
c
c  Calculate the radial gradients
c
         do ir=2,nr,2
            halofr(l/2+1,ir)=-4*pi/(2.*l+1.)*
     +              (-(l+1)*s1(ir)/(ir*dr)**(l+2)+ l*s2(ir)*(ir*dr)**(l-1))
            enddo
         enddo
c now interpolate the gaps 
c first quadratically interpolate the monopole back to the origin.
c the remaining multipoles are zero there.
      halopot(1,0)=(4*halopot(1,2)-halopot(1,4))/3.
      fr(1,0)=0.0
      do l=2,lmax,2
         halopot(l/2+1,0)=0
         halofr(l/2+1,0)=0
         enddo
      do ir=1,nr-1,2
         do l=0,lmax,2
            halopot(l/2+1,ir)=(halopot(l/2+1,ir-1)+halopot(l/2+1,ir+1))/2.
            halofr(l/2+1,ir)=(halofr(l/2+1,ir-1)+halofr(l/2+1,ir+1))/2.
            enddo
         enddo
c finally reset the potential at the origin to psi00
c      write(*,*) 'Central monopole:',apot(1,0),apot(1,1),apot(1,2),apot(1,3)
      a00=halopot(1,0)
      do ir=0,nr
         halopot(1,ir)=halopot(1,ir)-a00
         enddo
c write halo final potential.
c
c Reset the potentials so that phi is 0 at infinity
c
      redge = nr*dr
      do l=0,lmax,2
          c0 = halopot(l/2+1,nr) + halofr(l/2+1,nr)*redge/(l+1)
          do i=0,nr
              halopot(l/2+1,i) = halopot(l/2+1,i) - c0
          enddo
      enddo

      open(11,file='h.dat',status='unknown')

      write(11,'('' # psi00,v0,q,a,b,c,dr,nr,lmax='')')
      write(11,'('' #'',7g15.5,i6,i4)') psi00,v0,q,a,b,c,dr,nr,lmax
      write(11,'('' # bulge psiout, rho1, sig:'')')
      write(11,'('' #'',3g15.5)') psiout,rho1,sqrt(sigbulge2)
      write(11,'('' # Mdisk, rdisk, zdisk, outdisk, drtrunc'')')
      write(11,'('' #'',5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
!      write(11,'('' #'',3i5)') idiskflag, ibulgeflag, ihaloflag
      write(11,'('' #'',3i5)') 0, 0, ihaloflag
      write(11,'('' #  OUTPUT FROM DBH8. HALO POTENTIAL ONLY.'')')
      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(adens(l/2+1,ir),l=0,lmax,2)
         enddo
      write(11,*)
      write(11,*)
      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(halopot(l/2+1,ir),l=0,lmax,2)
         enddo
      write(11,*)
      write(11,*)
      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(halofr(l/2+1,ir),l=0,lmax,2)
         enddo
      close(11)
      halomass = halofr(1,nr)/sqrt(4*pi)*(nr*dr)**2
      do ir=0, nr
          if( adens(1,ir) .eq. 0.0 ) then
              haloedge = ir*dr
              goto 999
          endif
      enddo
      haloedge = nr*dr
999   write(*,*) 'Halo mass =', halomass
      write(*,*) 'Halo edge radius =', haloedge
      write(*,*) 'Halo harmonics written to file ''h.dat''.'
      return
      end

      real function pot(s,z)

      include 'commonblocks'

      real p

      r=sqrt(s*s+z*z)

      if(r.eq.0.) then
         pot = apot(1,0)/sqrt(4.*pi)
         return
      endif
      ihi=int(r/dr)+1
      if(ihi.lt.1) ihi=1
      if (ihi.gt.nr) ihi=nr
      r1=dr*(ihi-1)
      r2=dr*ihi
      t=(r-r1)/(r2-r1)
      tm1 = 1.0 - t
      if (r.eq.0.) then
         lmaxx=0
         costheta=0
      else
         costheta=z/r
         lmaxx=lmax
      endif
      p=0
      do l=lmaxx,0,-2
         p=p+plgndr1(l,costheta)*plcon(l)*
     +        (t*apot(l/2+1,ihi)+ tm1*apot(l/2+1,ihi-1))
      enddo
      if( idiskflag .eq. 1 ) then
         p = p + appdiskpot(s,z)
      endif
      pot=p

      return
      end

      SUBROUTINE polint(xa,ya,n,x,y,dy)
      INTEGER n,NMAX
      REAL dy,x,y,xa(n),ya(n)
      PARAMETER (NMAX=10)
      INTEGER i,m,ns
      REAL den,dif,dift,ho,hp,w,c(NMAX),d(NMAX)
      ns=1
      dif=abs(x-xa(1))
      do 11 i=1,n
        dift=abs(x-xa(i))
        if (dift.lt.dif) then
          ns=i
          dif=dift
        endif
        c(i)=ya(i)
        d(i)=ya(i)
11    continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
        do 12 i=1,n-m
          ho=xa(i)-x
          hp=xa(i+m)-x
          w=c(i+1)-d(i)
          den=ho-hp
          if(den.eq.0.)pause 'failure in polint'
          den=w/den
          d(i)=hp*den
          c(i)=ho*den
12      continue
        if (2*ns.lt.n-m)then
          dy=c(ns+1)
        else
          dy=d(ns)
          ns=ns-1
        endif
        y=y+dy
13    continue
      return
      END

module sphericaldfMod

 private
 public :: initdf,maxE,distf,gasRfromq,rho,rhofromfi, &
  &         fifromr,totalmass,rmax,rmin,setparameters
 
 integer,parameter :: ngrid=6000
 real, parameter :: pi=3.1415926535897932385
 real :: r(0:ngrid),dens(0:ngrid),ddensdr(0:ngrid)
 real :: cmass(0:ngrid),fi(0:ngrid),df(0:ngrid) 
 real :: ddrhodfi2(0:ngrid)
 real :: extdens(0:ngrid),extmass(0:ngrid),tmass(0:ngrid)
 
 real, parameter :: F_ZERO_R_LIMIT=0.

 integer, parameter :: ntheta=50
 
! density parameters 
 real :: rs, rvir,rhos 
 real :: rcut,cnorm,rmax,rmin
   
 contains
 
 real function rho(r)
  real :: r
  if(r.LE.rvir) then
   rho=rhos*rs**3/r/(rs+r)**2
  else
   rho=rhos*cnorm*rs**2/(rs+r)**2*exp(-r**2/rcut**2)
  endif 
 end function
 
 real function drhodr(r)
  real :: r
  if(r.LE.rvir) then
   drhodr=-rho(r)*(1/r+2/(rs+r))
  else
   drhodr=-rho(r)*(2*r/rcut**2+2/(rs+r))
  endif 
 end function

 real function ddrhodr2(r)
  real :: r
  if(r.LE.rvir) then
   ddrhodr2=-drhodr(r)*(1/r+2/(rs+r))+rho(r)*(1/r**2+2/(rs+r)**2)
  else
   ddrhodr2=-drhodr(r)*(2*r/rcut**2+2/(rs+r))+rho(r)*(2/(rs+r)**2-2/rcut**2)
  endif 
 end function

 function maxE()
  real maxE
  maxE=fi(0)
 end function 

 function totalmass()
  real totalmass
  totalmass=tmass(ngrid)
 end function
 
 function totalcmass()
  real totalcmass
  totalcmass=cmass(ngrid)
 end function

 
 function distf(e) result(f)
  real :: f,e
  f=invertcumul(ngrid+1,df,fi,e)
 end function
  
 function gasRfromq(q) result(gasr)
  real :: gasr,q,cm 
  cm=q*cmass(ngrid)
  gasr=invertcumul(ngrid+1,r,cmass,cm)
 end function 
 
 function fifromr(rad) result (lfi)
  real :: rad,lfi
  lfi=invertcumul(ngrid+1,fi,r,rad)  
 end function
 
 function rhofromfi(rad) result (lrho)
  real :: rad,lrho
  lrho=invertcumul(ngrid+1,dens,fi,rad)  
 end function

 function int_theta(densfunc,r) result(s)
 real,external :: densfunc
 real :: dctheta,s,r
 integer :: is
  s=0
  dctheta=1.0/ntheta
  s=s+densfunc(0.,r)+densfunc(r,0.)
  do is=1,ntheta-1,2
    ctheta=is*dctheta
    s=s+4*densfunc(r*sqrt(1-ctheta**2),r*ctheta)
  enddo
  do is=2,ntheta-2,2
    ctheta=is*dctheta
    s=s+2*densfunc(r*sqrt(1-ctheta**2),r*ctheta)
  enddo
  s=s*dctheta/3.
  s=s
 end function

 subroutine setparameters(rscale,virR,rho0)
  real, optional :: rscale,virR,rho0
  
  if(present(rscale)) then
   rs=rscale
  else
   print*,'NFW scale length?'
   read*,rs
  endif 
   
  if(present(virR)) then
   rvir=virR
  else
   print*,'NFW virial radius?'
   read*,rvir
  endif 

  if(present(rho0)) then
   rhos=rho0
  else
   print*,'NFW density constant?'
   read*,rhos
  endif 
    
  rcut=SQRT(2.)*rvir
  cnorm=exp(rvir**2/rcut**2)/(rvir/rs)
  rmin=1.e-4*rcut
  rmax=6*rcut
   
 end subroutine

      
 subroutine initdf(densfunc)
  integer :: i,j
  real :: fac,int
  real, external :: densfunc
    
  fac=exp(log(rmax/rmin)/(1.*(ngrid-1)))  
!  fac=(rmax-rmin)/(ngrid-1.)

  r(1)=rmin
  dens(1)=rho(rmin)
  ddensdr(1)=drhodr(rmin)
  do i=2,ngrid-1
   r(i)=r(i-1)*fac
!   r(i)=r(i-1)+fac
   dens(i)=rho(r(i))
   ddensdr(i)=drhodr(r(i))
  enddo
  r(ngrid)=rmax  
  dens(ngrid)=rho(rmax)
  ddensdr(ngrid)=drhodr(rmax)
  r(0)=0.
  dens(0)=dens(1) ! assumption !
  ddensdr(0)=0.
!  dens(0)=(4*dens(1)-dens(2))/3.
!  ddensdr(0)=(dens(1)-dens(0))/r(1)

! external density  averaged over theta
  extdens(0)=1/3.*densfunc(0.,rmin)+2./3.*densfunc(rmin,0.)
  do i=1,ngrid
   extdens(i)=int_theta(densfunc,r(i))
  enddo

  cmass(0)=0.
  cmass(1)=4/3.*Pi*r(1)**3*dens(0)
  do i=2,ngrid
   cmass(i)=cmass(i-1)+4*Pi*(r(i)-r(i-1))*(r(i)**2*dens(i)+r(i-1)**2*dens(i-1))/2.
  enddo

  extmass(0)=0.
  extmass(1)=4/3.*Pi*r(1)**3*extdens(0)
  do i=2,ngrid
   extmass(i)=extmass(i-1)+4*Pi*(r(i)-r(i-1))*(r(i)**2*extdens(i)+r(i-1)**2*extdens(i-1))/2.
  enddo

  write(0,*) 'halo reports a mass of:', cmass(ngrid)
  write(0,*) 'and an external mass of:', extmass(ngrid)
  
  tmass=cmass+extmass
  
  fi(ngrid)=0 
  do i=ngrid-1,1,-1
   fi(i)=fi(i+1)+(r(i+1)-r(i))*(tmass(i)/r(i)**2+tmass(i+1)/r(i+1)**2)/2.
  enddo
  fi(0)=fi(1)+r(1)*(F_ZERO_R_LIMIT+tmass(1)/r(1)**2)/2.
 
  do i=1,ngrid
   ddrhodfi2(i)=(r(i)**2/tmass(i))**2* &
    ((2/r(i)-4*Pi*r(i)**2*(dens(i)+extdens(i))/tmass(i))*ddensdr(i)+ddrhodr2(r(i)))
  enddo
  ddrhodfi2(0)=ddrhodfi2(1)

  df(ngrid)=0.
  do i=ngrid-1,1,-1
   int=0
   do j=ngrid-1,i+1,-1
   int=int+(fi(j)-fi(j+1))* &
       (ddrhodfi2(j)/sqrt(fi(i)-fi(j))+ddrhodfi2(j+1)/sqrt(fi(i)-fi(j+1)))/2.
   enddo
   int=int+2./3.*Sqrt((fi(i)-fi(i+1)))*(2*ddrhodfi2(i)+ddrhodfi2(i+1))
   df(i)=1/sqrt(8.)/pi**2*(int-1/sqrt(fi(i))*ddensdr(ngrid)*r(ngrid)**2/cmass(ngrid))
  enddo
  df(0)=df(1)

  open(unit=1,file='halo.df',status='UNKNOWN')
  do i=1,ngrid
  write(1,*) fi(i),df(i)
  enddo
  close(1)
  
! print*,'rmax,fi0,cmass:', rmax,fi(0),cmass(ngrid)
 
 end subroutine
 
  function invertcumul(n,xlist,ylist,y) result(x)
  integer :: n,bin,up,low
  real :: xlist(n),ylist(n),x,y,u,s
  
  if(ylist(1).LT.ylist(n)) then
   s=1
  else
   s=-1
  endif  
  
  if(s*y.LE.s*ylist(1)) then
   x=xlist(1)
   return
  endif
  if(s*y.GE.s*ylist(n)) then
   x=xlist(n)
   return
  endif
  up=n
  low=1
  do while((up-low).GT.1)
   bin=(low+up)/2
   if(s*y.LT.s*ylist(bin)) then
    up=bin
   else
    low=bin
   endif   
  enddo 
  bin=up
  u=(y-ylist(bin-1))/(ylist(bin)-ylist(bin-1))
  x=(1-u)*xlist(bin-1)+u*xlist(bin)  
  return
  end function
 
end module sphericaldfMod

 real function zerofunc(r,z)
  zerofunc=0.
 end function

subroutine sethalodf(rscl,rv,rhs)
 use sphericaldfMod
 real rscl,rv,rhs
 call setparameters(rscl,rv,rhs)
end subroutine

subroutine inithalodf(densfunc)
 use sphericaldfMod
 real, external :: zerofunc
 real, external, optional :: densfunc
 if(present(densfunc)) then
  call initdf(densfunc)
 else
  call initdf(zerofunc)
 endif
end subroutine

function halodfpsi00()
 use sphericaldfMod
 real halodfpsi00
 halodfpsi00=-maxE() 
end function

function halodffi(r)
 use sphericaldfMod
 real halodffi,r
! r>rmax??
 if(r.LT.rmax) then
  halodffi=-fifromr(r)
 else
  halodffi=totalmass()*(1/rmax-1/r)
 endif
end function

function Fhalo3(E)
 use sphericaldfMod
 real Fhalo3,E,nE
 Fhalo3=0
 if(E.LT.-maxE()) then
  write(0,*)  'E error'
  write(0,*)  E, -maxE()
  stop
 endif 
 nE=-E ! note: E is expected always to be > psi0!!
 if(nE.LE.0) return
 Fhalo3=distf(nE)
end function 

function halodfdenspsi(psi,psi0)
 use sphericaldfMod
  real halodfdenspsi,psi,psi0,npsi
 halodfdenspsi=0
 npsi=-(psi-psi0+halodfpsi00())
 if(npsi.LE.0) return
 halodfdenspsi=rhofromfi(npsi)
end function

function halodfdens(r,z) result(x)
 use sphericaldfMod
  real r,z,x
  x=rho(sqrt(r*r+z*z))
end function 

function halormax()
 use sphericaldfMod
 real halormax
 halormax=rmax
end function 

function halormin()
 use sphericaldfMod
 real halormin
 halormin=rmin
end function 


 function sdens(r,z) 
  real r,z,sdens  
  real rmdisk,zdisk,outdisk,drtrunc,erfarg,truncfac,con,diskconst,rdisk
  zdisk=0.5
  rdisk=3
  rmdisk=50.
  diskconst=rmdisk/(4.0*3.1415*rdisk**2*zdisk)
  outdisk=12
  drtrunc=.5
  sdens = 0
  if( abs(z/zdisk) .gt. 30.) return
   erfarg=(r-outdisk)/1.4142136/drtrunc
  if (erfarg.gt.4.) return
  if (erfarg.lt.-4) then
   trunfac=1
  else
   trunfac=0.5*erfc(erfarg)
  endif
  if (z.eq.0.) then
   con=1
  else
   con = exp(-abs(z/zdisk))
   con = (2.0*con/(1.0 + con*con))**2
  endif
  sdens = diskconst*exp(-r/rdisk)*con*trunfac 
  end function

! program test
!  use sphericaldfMod
!  implicit none
!    integer i,j,np,count
!    real, external ::sdens,zerofunc
!  
!  call initdf(sdens,6.,72.,0.04)
!
!  do i=0,ngrid-1
!   print*,r(i),dens(i),ddensdr(i)
!   print*,r(i),extdens(i),extmass(i)
!   print*,r(i),fi(i),df(i)
!  enddo  
! end program

      function fnamidden(r)
      parameter(nrmax=1000)
      
      common /splines/ rr(0:nrmax),fdrat(0:nrmax),drat2(0:nrmax),
     +     fszrat(0:nrmax), szrat2(0:nrmax), nrspl
      
      call splintd(rr(0),fdrat(0),drat2(0),nrspl+1,r,fcor)
      fnamidden=diskdensf(r,0.0)*fcor

      return
      end

      function appdiskpot(s,z)
      parameter (pi=3.1415926535)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea

c  The potential is obtained by integrating the density of a sech**2
c  disk up vertically, ignoring radial potential gradients.
c  In the resulting expression the cylindrical r is then replaced with
c  spherical radius, to make the potential zero at infinity 
c  (otherwise the harmonics series do not have a simple asymptotic 
c  form at infinity).
c      appdiskpot = 0
c      return
      r=sqrt(s*s+z*z)
c  erfc radial truncation factor
      t=sqrt(0.5d0)*(r-outdisk)/drtrunc
      if (t.lt.-4.0) then
        eerfc=1.
      elseif(t.gt.4.0) then
        appdiskpot=0.
        return
      else
        eerfc=0.5*erfc(t)
        endif

      f=diskconst*exp(-r/rdisk)
      zz=abs(z/zdisk)
      appdiskpot=4*pi*f*zdisk**2*(zz+log(0.5*(1+exp(-2*zz))))*eerfc
      return
      end       

      function rcirc(am)
      parameter(pi=3.1415926535)
      parameter(nrmax=1000)
      common /potconstants/ apot(20,0:20000), frad(20,0:20000), 
     +     dr, nr, lmax, potcor
      common /legendre/ plcon(0:40)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      common /diskpars/ sigr0, disksr, nrdisk

      dimension rtab(20000),amtab(20000),rtab2(20000)
      data ifirst /0/

      save ifirst,rtab,amtab,rtab2

c make a spline fit to [Rcirc/sqrt(Lcirc)] vs. Lcirc.
c this is ~ constant at the origin, and goes like Lcirc**1.5 
c at large radii (where the potential is Kepler).
      if (ifirst.eq.0) then
        
        do i=1,nr
           r=(i-1)*dr
           call omekap(r,om,t)
           amtab(i)=om*r*r
           rtab(i)=1./sqrt(om)
        enddo
        slopeinf=1.5*rtab(nrdisk)/amtab(nr)
        call splined(amtab,rtab,nr,1.e32,slopeinf,rtab2)
        ifirst=1
      endif

      aam=abs(am)
      if (aam.gt.amtab(nr)) then
        rcirc=rtab(nr)*(aam/amtab(nr))**2
      else
        call splintd(amtab,rtab,rtab2,nr,aam,rc)
        rcirc=rc*sqrt(aam)
      endif
      return
      end

c-------------------------------
      function diskdf5intez(vt,r,z)
      parameter (pi=3.1415926535)
      parameter(nrmax=1000)

      psir0=pot(r,0.0)
      if (z.eq.0.) then 
         psirz=psir0
      else
         psirz=pot(r,z)
         endif
      ep=0.5*(vt*vt)+psir0
      am=r*vt
      ez=psirz-psir0
      diskdf5intez=diskdf3intez(ep,am,ez)
      return
      end            

      function erfcen(x)
c      write(*,*) 'erfcen: x=',x
      if (x.gt.5.) then 
         erfcen=2.5066283
      elseif (x.lt.-5.) then
         erfcen=-2.5066283
      else
         erfcen=erf(x/1.4142136)*2.5066283
         endif
      return
      end

      function getdiskpsi(r)

      include 'commonblocks'
      common /diskestimate/ ddens(0:nmax),dpot(0:nmax),dfr(0:nmax)

      ihi=int(r/dr)+1
      if (ihi.lt.1) ihi=1
      if (ihi.gt.nr) ihi=nr
      r1=dr*(ihi-1)
      r2=dr*ihi
      t=(r-r1)/(r2-r1)
      tm1 = 1.0 - t
      if (r.eq.0.) then
         lmaxx=0
         costheta=0
      else
         costheta=z/r
         lmaxx=lmax
      endif
      getdiskpsi = (t*dpot(ihi)+ tm1*dpot(ihi-1))

      return
      end

      function gettotalpsi(rad)

      include 'commonblocks'

      gettotalpsi = 0.
      if(idiskflag.eq.1) then
         gettotalpsi = gettotalpsi + getdiskpsi(rad)
      endif
      if(ibulgeflag.eq.1) then
         gettotalpsi = gettotalpsi + sersicpot(rad)
      endif
      if(ihaloflag.eq.1) then
         gettotalpsi = gettotalpsi + gethalopsi(rad)
      endif
      return
      end

      function gethalopsi(r)

      include 'commonblocks'
      common /haloestimate/ hdens(0:nmax),hpot(0:nmax),hfr(0:nmax)

      ihi=int(r/dr)+1
      if (ihi.lt.1) ihi=1
      if (ihi.gt.nr) ihi=nr
      r1=dr*(ihi-1)
      r2=dr*ihi
      t=(r-r1)/(r2-r1)
      tm1 = 1.0 - t
      if (r.eq.0.) then
         lmaxx=0
         costheta=0
      else
         costheta=z/r
         lmaxx=lmax
      endif
      gethalopsi = (t*hpot(ihi)+ tm1*hpot(ihi-1))

      return
      end

      function pot(s,z)
      parameter (pi=3.1415926535)
      common /potconstants/ apot(20,0:20000), frad(20,0:20000), 
     +     dr, nr, lmax, potcor
      common /legendre/ plcon(0:40)
      common /flags/ idiskflag, ibulgeflag, ihaloflag
c     Returns the potential, being the sum of the spherical harmonics
c     with coefficients in apot, and the potential appdiskpot which
c     approximates the high-frequency components of the disk.
c     + external potentials      
      p=0
      
      r=sqrt(s*s+z*z)
      ihi=int(r/dr)+1
      if (ihi.lt.1) ihi=1
      if (ihi.gt.nr) ihi=nr
      r1=dr*(ihi-1)
      r2=dr*ihi
      t=(r-r1)/(r2-r1)
      tm1 = 1.0 - t
      if (r.eq.0.) then
         lmaxx=0
         costheta=0
      else
         costheta=z/r
         lmaxx=lmax
      endif
      
      do l=lmaxx,0,-2
         p=p+plgndr1(l,costheta)*plcon(l)*
     +        (t*apot(l/2+1,ihi)+ tm1*apot(l/2+1,ihi-1))
      enddo
      if( idiskflag .eq. 1 .or. idiskflag .eq. 3)
     & p = p + appdiskpot(s,z)
      
      if( idiskflag .eq. 2 .or. idiskflag .eq. 3)
     & p= p + thickdiskpot(s,z)      

      if(ihaloflag.eq.2)
     & p= p + fixedpot(r)
      
      pot=p
      return
      end

      function extpot(s,z)
      parameter (pi=3.1415926535)
      common /flags/ idiskflag, ibulgeflag, ihaloflag
c     external potentials      
      p=0
      r=sqrt(s*s+z*z) 
           
      if( idiskflag .eq. 1 .or. idiskflag .eq. 3)
     & p = p + appdiskpot(s,z)

      if( idiskflag .eq. 2 .or. idiskflag .eq. 3)
     & p= p + thickdiskpot(s,z)      

      if(ihaloflag.eq.2)
     & p= p + fixedpot(r)
      
      extpot=p
      return
      end



      function cfharm(s,z,ff)
      parameter (pi=3.1415926535)
      common /potconstants/ apot(20,0:20000), frad(20,0:20000), 
     +     dr, nr, lmax, potcor
      common /legendre/ plcon(0:40)
      common /flags/ idiskflag, ibulgeflag, ihaloflag
c     Returns the potential, being the sum of the spherical harmonics
c     with coefficients in apot, and the potential appdiskpot which
c     approximates the high-frequency components of the disk.
c     + external potentials
      real ff(20,0:20000)      
      p=0
      r=sqrt(s*s+z*z)
      ihi=int(r/dr)+1
      if (ihi.lt.1) ihi=1
      if (ihi.gt.nr) ihi=nr
      r1=dr*(ihi-1)
      r2=dr*ihi
      t=(r-r1)/(r2-r1)
      tm1 = 1.0 - t
      if (r.eq.0.) then
         lmaxx=0
         costheta=0
      else
         costheta=z/r
         lmaxx=lmax
      endif
      
      do l=lmaxx,0,-2
         p=p+plgndr1(l,costheta)*plcon(l)*
     +        (t*ff(l/2+1,ihi)+ tm1*ff(l/2+1,ihi-1))
      enddo
            
      cfharm=p
      return
      end

      subroutine gendenspsihalo

      include 'commonblocks'

      real psi

      open(file='denspsihalo.dat',unit=50,status='replace')

c      fcut_halo = dfhalo(psic)
      fcut_halo = 0.

      do i=1,npsi
         psi = tableE(i)
         call gethalodens(psi,denspsihalo(i))
         if(i.eq.npsi) denspsihalo(i) = 0.
         write(50,*) tableE(i),denspsihalo(i)
      enddo
      
      close(50)
      return
      
      end

      subroutine gethalodens(psi,rho)

      include 'commonblocks'

      real psi

      m = 200
      vmin = -10.
      vmax = log(sqrt(2.*(psi-psic)))
      dlogv = (vmax - vmin)/float(m-1)
      rho = 0.
      do j=1,4
         vlog = vmin + dlogv*float(j-1)
         v = exp(vlog)
         e = psi - v*v/2.
         df_lowered = dfhalo(e)-fcut_halo
         if(df_lowered.gt.0.) 
     +         rho = rho + 4.*pi*dlogv*v*v*v*coef(j)*df_lowered
      enddo
      do j=5,m-4
         vlog = vmin + dlogv*float(j-1)
         v = exp(vlog)
         e = psi - v*v/2.
         df_lowered = dfhalo(e)-fcut_halo
         if(df_lowered.gt.0.) 
     +         rho = rho + 4.*pi*dlogv*v*v*v*df_lowered
      enddo
      do jj=4,2,-1
         j = m-jj+1
         vlog = vmin + dlogv*float(j-1)
         v = exp(vlog)
         e = psi - v*v/2.
         df_lowered = dfhalo(e)-fcut_halo
         if(df_lowered.gt.0.) 
     +         rho = rho + 4.*pi*dlogv*v*v*v*coef(jj)*df_lowered
      enddo
      return
      end

      function coef(j)
      
      if(j.eq.1) coef=17./48.
      if(j.eq.2) coef=59./48.
      if(j.eq.3) coef=43./48.
      if(j.eq.4) coef=49./48.

      return
      end

      subroutine velocityfactors(R,z,vfacr,vfacz)

      common /blackhole/ bhmass
      real pot

      rsph = sqrt(R*R+z*z)
      call force(R,z,fr,fz,pot)
      frbh = -bhmass*R/(rsph**3.)
      fzbh = -bhmass*z/(rsph**3.)
      vfacr = sqrt(abs((fr+frbh)/fr))
      vfacz = sqrt(abs((fz+fzbh)/fz))
      if(vfacr.lt.1.or.vfacz.lt.1) then
         write(0,*) vfacr,vfacz,fr,fz
         stop
      endif
      return
      end
      

      function appdiskdens(s,z)

      include 'commonblocks'

c  This is the density corresponding to the first-guess disk potential
c  f(r)*erfc((r-outdisk)/sqrt(2)drtrunc)/2 * 4 pi G zdisk**2 log(z/zdisk)
c  where r is spherical radius. f(r) is here taken as an exponential.
c
c  The corresponding density is:
c  f(r)*erfc*sech(z/zdisk)**2 + radial gradient terms.
c  For radii below one scale radius, we have replaced the radial exponential 
c  (which gives rise to a singular laplacian) with a quartic that joins on 
c  smoothly.
c
      r=sqrt(s*s+z*z)
c     radial truncation factors
      t=sqrt(0.5d0)*(r-outdisk)/drtrunc
      t2=t*t
      if (t.lt.-4.0) then
         eexp=0.
         eerfc=1.
      elseif (t.lt.4.0) then
         eexp=exp(-t2)/sqrt(2*pi)/drtrunc
         eerfc=0.5*erfc(t)
      else
         eexp=0
         eerfc=0
      endif
c     radial density 
c     f is radial density, f1r is f'/r, f2 is f".
      if (r.gt.0.) then
         fac1=diskconst*zdisk**2*exp(-r/rdisk)
         f=fac1*eerfc
         f1r=-fac1*(eerfc/rdisk+eexp)/r
         f2=fac1*(eerfc/rdisk2+eexp*(2/rdisk+(r-outdisk)/drtrunc**2))
      else
         fac1=diskconst*zdisk**2
         f=fac1*eerfc
         f1r=0
         f2=0
      endif
c     vertical factors
      zz=abs(z/zdisk)
      ezz=exp(-zz)
      e2zz=ezz*ezz
      tlncosh=zz+log(0.5*(1+e2zz))
      tztanh=zz*(1-e2zz)/(1+e2zz)
      tsech2=(2*ezz/(1+e2zz))**2
      appdiskdens=f2*tlncosh+2*f1r*(tztanh+tlncosh)+f*tsech2/zdisk**2

      return
      end

      program dbh

      integer nrmaxsize,nr,lmax,nrmax
      
      real apot,fr,dr,potcor,plcon
      real psi0,psi2,psi4,dpsi,ds1s2,dapot
      real a,b,c,v0,q,psi00,psiout,rho1,sigbulge2,rmdisk,rdisk,
     & zdisk,outdisk,drtrunc,potcor1,v02,v03,rdisk2,diskconst,bulgea
      integer idiskflag,ibulgeflag,ihaloflag
            
      parameter(nrsize=20000)

      common /potconstants/ apot(20,0:nrsize), fr(20,0:nrsize), 
     +     dr, nr, lmax, potcor
      common /legendre/ plcon(0:40)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      common /flags/ idiskflag, ibulgeflag, ihaloflag

      real densnew,densold
      real gasm,gasr,gastr,gasdt,csnd,gamma,gassig
      integer gasnr
      common /gasstuf/ gasm,gasr,gastr,gasdt,csnd,gamma,gasnr,gassig,gasz

      parameter(pi=3.1415926535)
      real adens(20,0:nrsize),s1(0:nrsize),s2(0:nrsize)
      real rref(10),zref(10),pref(10),oldpref(10)
      real fr2(20,0:nrsize)
      real rscl,rv,rhs
      real bulgerscl,bulgerv,bulgerhs      
      external alldensnohalo,alldensnobulge,zerofunc
      
c  constants for legendre polynomials
      do l=0,40
         plcon(l) = sqrt((2*l+1)/(4.0*pi))
      enddo
c  set flags
      idiskflag = 0;ibulgeflag = 0;ihaloflag  = 0
c set default parameters
c disk: 
      rmdisk = 0.0;rdisk  = 1.0;zdisk  = .15
      outdisk = 5.0;drtrunc = .3
c bulge:
      rho1 = 0.;psiout = -2.0;sigbulge = .4
c halo:
      psi00 = 0.;q = 1.0
      v0 = 1.0;rking = 1

c Enter halo parameters
      write(*,*) 'Include halo? (0=no,1=dynamic,2=fixed,3=spherical df)'
      read(*,*) ihaloflag

      if( ihaloflag.eq.2) then
       print*, 'using MODEL.MASS file'
       q=1
      endif

      if( ihaloflag.eq.1) then
         write(*,*) 'central potential, v0, q, coreparam (=Rc/rK)^2, halo Ra?'
         read(*,*) psi00,v0,q,coreparam,ra
         v02 = v0**2
         v03 = v0**3
         rhochalo=3*v02/(4*pi*ra**2)
         write(*,*) 'rhochalo = ', rhochalo
         r1=v0/sqrt(4*pi*rhochalo)*exp(-psi00/v02)
c  fix Evans's B constant such that the core radius R_c is prop. to the King radius of the model.
         a=(2/pi)**2.5*(1-q**2)/q**2/v03/r1**4
         b=0
         c=(2*q**2-1)/(4*pi**2.5*q**2*v0)/r1**2
      endif
      
      if (ihaloflag.eq.3) then
        print*, 'halo parameters? (rs,rvir,rhos)'
        read*, rscl,rv,rhs	
	call sethalodf(rscl,rv,rhs)
      endif
            
c Enter disk parameters
      write(*,*) 'Include disk? (0=no,1=dynamic,2=fixed,3=fixed+dynamic)'
      read(*,*) idiskflag
      if( idiskflag.eq.1.OR.idiskflag.EQ.3) then
         write(*,*) 'Disk mass, scale length, radius, scale height and trunc. width?'
         read(*,*) rmdisk, rdisk, outdisk, zdisk, drtrunc
         rdisk2 = rdisk*rdisk
         diskconst = rmdisk/(4.0*pi*rdisk2*zdisk)
         do iref=1,4
           rref(iref)=iref*rdisk*2
           zref(iref)=0
           enddo
         do iref=5,7
           rref(iref)=(iref-5)*rdisk*4
           zref(iref)=zdisk/2.
           enddo
         do iref=8,10
           rref(iref)=rref(iref-3)
           zref(iref)=zdisk*2.
           enddo
         open(18,file='refpoints.dat',status='unknown')
      endif
      if( idiskflag.EQ.2.OR.idiskflag.EQ.3) then
        write(*,*) 'gasdisk mass, scale length, radius and trunc with?'
	read(*,*) gasm,gasr,gastr,gasdt
        write(*,*) 'csound,gamma, gas nr,maxz?'
	read(*,*) csnd,gamma,gasnr,gasz
      endif
            
c Enter bulge parameters
      write(*,*) 'Include bulge? (0=no,3=sphericaldf)'
      read(*,*) ibulgeflag
      if( ibulgeflag .eq. 1) then
         print*,'check bulge=1'
         write(*,*) 'Bulge central density (ish), cutoff potential, velocity dispersion?'
         read(*,*) rho1,psiout,sigbulge
         sigbulge2=sigbulge**2
         bulgea=rho1*exp((psi00-psiout)/sigbulge2)
      endif

      if (ibulgeflag.eq.3) then
        print*, 'bulge parameters? (rs,rvir,rhos)'
        read*, bulgerscl,bulgerv,bulgerhs
	call setbulgedf(bulgerscl,bulgerv,bulgerhs,halormin(),halormax())	
      endif

      write(*,*) 'radial step size, no. of bins?'
      read(*,*) dr,nr
      write(*,*) 'max. azimuthal harmonic l?'
      read(*,*) lmaxx

      if( ihaloflag .eq. 1 ) then
         print*,'warning: check!' 
         apot(1,0)=psi00*sqrt(4.*pi)
         dens00=totdens(0.,0.)
         rking=sqrt(9*v0**2/(8*pi*dens00))
c  find Rc which gives desired Rc/RK by bisection
         if (coreparam.le.0.) then
            b=0
         else
            rclo=0
            rchi=rking*sqrt(coreparam)
            rcmid=rchi/2.
            do while (rchi-rclo.gt.1.e-5*rcmid)
               b=sqrt(2/pi**5)*rcmid**2/q**2/v0/r1**4
               dens00=totdens(0.,0.)
               rcnew=sqrt(coreparam)*sqrt(9*v02/(8*pi*dens00))
               if (rcnew.gt.rcmid) then
                  rclo=rcmid
               else
                  rchi=rcmid
               endif
               rcmid=(rclo+rchi)/2.
            enddo
            b=sqrt(2/pi**5)*rcmid**2/q**2/v0/r1**4
            dens00=totdens(0.,0.)
            rking=sqrt(9*v02/(8*pi*dens00))
         endif
c  report final King radius and central density         
         write(*,*) 'central density=',dens00
         write(*,*) 'King radius=',rking
      endif


      call pgbegin(0,'/XWINDOW',5,4)
      call pgask(.false.)
      call pgsch(2.)
      write(*,*)

! init gas disk
      if( idiskflag.EQ.2.OR.idiskflag.EQ.3) then
        call setgasdisk()
! calculate 
! set plausible starting density for gas disk:
! (constant? stellar z-height? zero thickness?)
        call firstgasdens(zdisk)        
        densold=thickdiskdens(gasr,0.)
      endif

! calculate first guess potential:
      if(ihaloflag.eq.3) then
        call inithalodf(alldensnohalo)
!       psi00=0
       psi00=halodfpsi00()
      endif

c  cold start
c  initial potential, a good initial guess is important!
      if( ihaloflag .eq. 0 ) then
         q = 1
         psi00 = 0.0
         rcmid = 1.0 
         v02 = 1.0
      endif
      z = 0.0
      do ir=0,nr
         r=ir*dr
         if(ihaloflag.EQ.1) 
     &	 apot(1,ir)=psi00*sqrt(4.*pi)*exp(-100*(r*r+z*z)/(nr*dr)**2)
         if(ihaloflag.EQ.3)
     &	 apot(1,ir)=halodffi(r)*sqrt(4.*pi)-
     &   (rmdisk/sqrt(rdisk**2+r**2)-rmdisk/rdisk)*sqrt(4.*pi)
! fixed external potentials are added in pot function !!
!         print*,r,halodffi(r)
	 if(ihaloflag.EQ.2) apot(1,ir)=0.                  
	 do l=2,lmaxx,2
            apot(l/2+1,ir)=0
         enddo
      enddo

      lmaxstep=2
      lmax=0
      lmaxold=-2
      iter=0

! -------------------begin gas loop

!        print*,thickdiskdens(gasr,0.)
1      if( idiskflag.EQ.2.OR.idiskflag.EQ.3) then
!  begin with guess gas disk density:
         call solveZ    
!        print*,thickdiskdens(gasr,0.) 
! then potential:
         call solvepot
! repeat (because gas disk is probably subdominant):
         call solveZ        
!	 print*,thickdiskdens(gasr,0.)
         call solvepot
       endif

! need to redo:
      if(ihaloflag.eq.3) then
        call inithalodf(alldensnohalo)
        psi00=halodfpsi00()
      endif
! halo bigger than bulge assumed!     
      print*,'psi00:',psi00

      if(ibulgeflag.eq.3) then
        call initbulgedf(alldensnobulge)
        print*,bulgedfpsi00()
!       psi00=sdfpsi00()
      endif
      
! reset apot to psi00 at center:
	 a00=apot(1,0)
	 epot=extpot(0.,0.)
         print*,'reset central potential'
	 print*,'     psi00,pot,expot:',psi00,a00/sqrt(4.*pi),epot
         if(ihaloflag.EQ.1.OR.ihaloflag.EQ.3.OR.ibulgeflag.EQ.3) then
         do ir=0,nr
            apot(1,ir)=apot(1,ir)+(psi00-epot)*sqrt(4.*pi)-a00
         enddo
	 else
!         do ir=0,nr
!            apot(1,ir)=apot(1,ir)+fixedpot(0.)*sqrt(4.*pi)-a00
!         enddo	    
	 endif

      ntheta=(lmax)*4+2
      ntheta=max(10,ntheta)

c  now iterate. number of iterations and change in lmax depends on initial conditions.
c  iterate on first cycle until tidal radius is stable, then once for every harmonic added,
c  and until convergence once l has reached the desired maximum lmax.
      
c  if only a disk potential
      if( ihaloflag .eq. 2 .and. ibulgeflag .eq. 0 ) lmax = lmaxx-2
      drtidal = 1.
      rtidalold = 1e10
      iteroutside = 0

! get gas potential: will be added as external potential! 

      do while(iter.LE.299)
         iter=iter+1
c  determine number of harmonics, and number of azimuthal bins, to use this iteration
         if( lmax .eq. 0 .or. lmax .eq. lmaxx ) then
            if( drtidal .lt. 0.0005) then
               lmax=lmax+lmaxstep
               ntheta=lmax*4+4
            endif
         else
            lmax=lmax+lmaxstep
            ntheta=lmax*4+4
         endif
         if( lmax .eq. lmaxx+lmaxstep ) then
	  lmax=lmaxx
	  goto 199
         endif
c  Now get the harmonics of the density in this potential --> adens
c  NB that dens only gives the density without an approximate sech**2
c  component --- that part of the potential is not represented by the 
c  harmonics.
c  The function dens(r,z) returns the density - high-frequency cpt
c  The full density is returned by totdens
         adens(1,0)=dens(0.,0.)*sqrt(4.*pi)
         do l=2,lmax,2
            adens(l/2+1,0)=0
         enddo
         do ir=1,nr
            adens(1,ir)=0
         enddo
c  nrmax will mark the outermost radial bin with non-zero density.
         nrmax=nr
         do l=0,lmax,2
c  integrate density * spherical harmonic function over quadrant
c  use cos(theta) as independent variable.
            do ir=1,nrmax
               r=ir*dr
               s=0
               dctheta=1.0/ntheta
               s=s+polardens(r,1.0,l)+polardens(r,0.0,l)
               do is=1,ntheta-1,2
                  ctheta=is*dctheta
                  s=s+4*polardens(r,ctheta,l)
               enddo
               do is=2,ntheta-2,2
                  ctheta=is*dctheta
                  s=s+2*polardens(r,ctheta,l)
               enddo
               s=s*dctheta/3.
               s=s*4*pi
	       adens(l/2+1,ir)=s
c  mark the first even radial bin on which the density has fallen to zero.
	       if (l.eq.0 .and. s.eq.0.) then
                  nrmax=nr
                  nrmax=nrmax+mod(nrmax,2)
                  goto 77
               endif
            enddo	    
 77      enddo
 
c  now get the potential harmonics of this new density. (BT 2-208)
c  Simpson's rule integration. 
         do l=0,lmax,2
            s1(0)=0
            r = 2*dr
            s1(2)=(r*dr/3.)*(4*adens(l/2+1,1)*(1.0-dr/r)**(l+2)+adens(l/2+1,2))
            rold = r 
c  doesn't matter but should be nonzero
c  to avoid round-off error
            do ir=4,nr,2
               r=ir*dr
               s1a = (r*dr/3.)*(adens(l/2+1,ir-2)*(1.0-2*dr/r)**(l+2)+
     &              4*adens(l/2+1,ir-1)*(1.0-dr/r)**(l+2)+adens(l/2+1,ir))
               s1(ir) = s1a + s1(ir-2)*(rold/r)**(l+1)
               rold = r
            enddo
            s2(nr)=0
            rold = nr*dr
            do ir=nr-2,2,-2
               r=ir*dr
               s2a = (r*dr/3.)*(adens(l/2+1,ir+2)*(1.0+2*dr/r)**(1-l)+
     &              4*adens(l/2+1,ir+1)*(1.0+dr/r)**(1-l)+adens(l/2+1,ir))
               s2(ir) = s2a + s2(ir+2)*(r/rold)**l
!	       print*,s2a,s2(ir),adens(l/2+1,ir),ir                  
	       rold = r
            enddo
!	    stop
c  replace the potential harmonics with a mean of the previous iteration (25%) 
c  and the current one (75%). This damps out oscillations that otherwise occur.
c  if this is the first time this harmonic is calculated, use the entire new 
c  value.
            if(l.eq.0) then
             epot=extpot(0.,0.)
!	     print*,apot(1,2)/sqrt(4*pi),apot(1,nr)/sqrt(4*pi)
!	     print*,-(s1(2)+s2(2))*sqrt(4*pi),-(s1(nr)+s2(nr))*sqrt(4*pi)
C do the correction to psi00 here!	  
             psi2=-(s1(2)+s2(2))*sqrt(4*pi)
	     psi4=-(s1(4)+s2(4))*sqrt(4*pi)  
 	     psi0=2*psi2-psi4
	     dpsi=psi00-epot-psi0
	     ds1s2=-dpsi/sqrt(4*pi)
!	     print*,'a',ds1s2,s1(2)+s2(2)
	    else
	     ds1s2=0. 
	    endif
            do ir=2,nr,2
               if (l.le.lmaxold) then
                  apot(l/2+1,ir)=0.5*apot(l/2+1,ir)-
     &		  0.5*4*pi/(2.*l+1.)*(s1(ir)+s2(ir)+ds1s2)
               else
                  apot(l/2+1,ir)=-4*pi/(2.*l+1.)*
     +                 (s1(ir)+s2(ir)+ds1s2)
               endif
            enddo

c  
c  Calculate the 1st and 2nd-order radial gradients
c  
            do ir=2,nr,2
               r = ir*dr
               fr(l/2+1,ir)=-4*pi/(2.*l+1.)*(-(l+1)*s1(ir) + l*s2(ir))/r
               fr2(l/2+1,ir)=-4*pi/(2.*l+1.)*
     +              ((l+1)*(l+2)*s1(ir)/r**2+ 
     +              l*(l-1)*s2(ir)/r**2 -(2*l+1)*adens(l/2+1,ir))
            enddo
         enddo
c  now interpolate the gaps 
c  first quadratically interpolate the monopole back to the origin.
c  the remaining multipoles are zero there.
!	 apot(1,0)=(4*apot(1,2)-apot(1,4))/3.
	 apot(1,0)=(2*apot(1,2)-apot(1,4))
!         print*,apot(1,0),apot(1,2)
!         apot(1,0)=apot(1,2)
	 fr(1,0)=0.0
         fr2(1,0)=2*fr2(1,2)-fr2(1,4)
         fr2(1,0)=fr2(1,2)
         do l=2,lmax,2
            apot(l/2+1,0)=0
            fr(l/2+1,0)=0
            fr2(l/2+1,0)=0
         enddo
c  then linearly interpolate other bins.
         do ir=1,nr-1,2
            do l=0,lmax,2
               apot(l/2+1,ir)=(apot(l/2+1,ir-1)+apot(l/2+1,ir+1))/2.
               fr(l/2+1,ir)=(fr(l/2+1,ir-1)+fr(l/2+1,ir+1))/2.
               fr2(l/2+1,ir)=(fr2(l/2+1,ir-1)+fr2(l/2+1,ir+1))/2.
            enddo
         enddo
c plot current harmonic functions

c if you are only a disk potential then no need to iterate exit the loop
c
	 if( ihaloflag .eq. 0.and.ibulgeflag.eq.0 ) goto 199
c  finally reset the potential at the origin to psi00-extpot
c  Note that the fake disk potential is zero at the origin.
	 a00=apot(1,0)
	 epot=extpot(0.,0.)
!	 print*,'     psi00,pot,expot:',psi00,a00/sqrt(4.*pi),epot	 
	 if(ihaloflag.EQ.1.OR.ihaloflag.EQ.3.OR.ibulgeflag.EQ.3) then
         dapot=(psi00-epot)*sqrt(4.*pi)-a00
!	 print*,dapot
	 do ir=0,nr
            apot(1,ir)=apot(1,ir)+dapot
         enddo
	 else
!         do ir=0,nr
!            apot(1,ir)=apot(1,ir)+fixedpot(0.)*sqrt(4.*pi)-a00
!         enddo	    
	 endif
!	 print*,'a00:',apot(1,0)/sqrt(4.*pi)

!         if (a00/sqrt(4.*pi).gt.psi00-epot) then
!	    print*,a00/sqrt(4*pi),psi00
!            write(*,'(''Iter'',i4,'': lmax='',i4,
!     +           '', tidal radius is infinite'')') iter,lmax
!            iteroutside = iteroutside + 1
!            if( iteroutside .gt. 20 ) then
!                write(*,'(''nr='',i4,'' is too small'',
!     +           '', try larger number of radial bins  - exiting program'')') nr
!                goto 12345
!            endif
!            drtidal = 2.0*dr
!         else
            potr=apot(1,0)/sqrt(4.*pi)
            if(ihaloflag.eq.2) then
	        rtidal=nr*dr
		drtidal=0.
		goto 9
	    else
	    do ir=1,nr
c  look for new tidal radius of the model
c  defined as the radius at the equator where the potential is zero
               
	       
	       potrm1=potr
               potr=pot(ir*dr,0.)
!	       print*,ir*dr,potr,potrm1
!	       ,apot,dr,nr,lmax)
               if (potrm1*potr.le.0.) then
                  dpot = potr - potrm1
                  if( dpot .eq. 0.0 ) then
                     rtidal = (ir-1)*dr
                  else
                     rtidal=(ir-1-potrm1/dpot)*dr
                  endif
                  write(*,'(''   Iter'',i4,'': lmax='',i4,
     +                 '', tidal radius is '',g15.6)') iter,lmax,rtidal
                  drtidal = abs(rtidal - rtidalold)/rtidal
                  rtidalold = rtidal
                  
		  goto 9
               endif	       
            enddo
!	    endif
            write(*,'(''Iter'',i4,'': lmax='',i4,
     +           '', tidal radius is outside grid'')') iter,lmax
            drtidal = 1.0
 9       endif
c write out the changes in the potential at the reference points 
c at this iteration.
         if( idiskflag .eq. 1.or.idiskflag.eq.3 ) then 
            do iref=1,10
               oldpref(iref)=pref(iref)
               pref(iref)=pot(rref(iref),zref(iref))
!	       ,apot,dr,nr,lmax)
               enddo
            write(18,'(2i3,10g12.4)') iter,lmax,
     +                  (pref(iref)-oldpref(iref),iref=1,10)
          endif
c  now repeat with this new potential!
         lmaxold=lmax
         call dbhplot(adens,0,nr,dr)
         call dbhplot(apot,0,nr,dr)
      enddo
c  end of the main loop
 199  continue
 
 
 ! goto begin gas loop if not happy
      if( idiskflag.EQ.2.OR.idiskflag.EQ.3) then       
       densnew=thickdiskdens(gasr,0.)
       if(abs(densnew-densold)/densnew.GT.0.005) then
!        print*,densnew,densold
        print*,'repeating'
        densold=densnew
	goto 1
       endif 
!        print*,densnew,densold
        print*,' done?'       
       call writegas
      endif	
	      
      call pgend
      if( idiskflag .eq. 1.or.idiskflag.eq.3 ) close(18)
c  write final density, potential and potential gradient harmonics
c
C wrong!
      totalmass = fr(1,nr)/sqrt(4*pi)*(dr*nr)**2
      write(*,*) 'psi00=',psi00,'Rt/RK=',rtidal/rking
      write(*,*) 'Total mass=', totalmass

c  
c  Calculate force and potential for halo only
c  
      lmax = lmaxx
      halomass = 0.0
      bulgemass = 0.0
      haloedge = 0
      bulgeedge = 0
      if( ihaloflag.NE.0) call halopotential(halomass, haloedge)
      
      if( ibulgeflag.NE.0) call bulgepotential(bulgemass, bulgeedge)

      diskmass = totalmass - halomass - bulgemass
      diskedge = outdisk + 2.0*drtrunc

      open(20,file='mr.dat',status='unknown')
      write(20,*) diskmass, diskedge
      write(20,*) bulgemass, bulgeedge
      write(20,*) halomass, haloedge
      close(20)

      open(11,file='dbh.dat',status='unknown')
      write(11,'('' # psi00,v0,q,a,b,c,dr,nr,lmax='')')
      if( ihaloflag.NE.3) then
       write(11,'('' #'',7g15.5,i6,i4)') psi00,v0,q,a,b,c,dr,nr,lmaxx
      else
       write(11,'('' #'',7g15.5,i6,i4)') psi00,rscl,rv,rhs,b,c,dr,nr,lmaxx
      endif
      write(11,'('' # bulge psic, rho1, sig:'')')
      if(ibulgeflag.NE.3) then
       write(11,'('' #'',3g15.5)') psiout,rho1,sigbulge
      else
       write(11,'('' #'',3g15.5)') bulgerscl,bulgerv,bulgerhs      
      endif
      write(11,'('' # Mdisk, rdisk, zdisk, outdisk, drtrunc'')')
      write(11,'('' #'',5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
      write(11,'('' #'',3i5)') idiskflag, ibulgeflag, ihaloflag
      write(11,'('' #  OUTPUT FROM DBH8. TOTAL POTENTIAL.'')')

      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(adens(l/2+1,ir),l=0,lmaxx,2)
      enddo
      write(11,*)
      write(11,*)
      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(apot(l/2+1,ir),l=0,lmaxx,2)
      enddo
      write(11,*)
      write(11,*)
      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(fr(l/2+1,ir),l=0,lmaxx,2)
      enddo
      write(11,*)
      write(11,*)
      do ir=0,nr
         write(11,'(8g16.8)') ir*dr,(fr2(l/2+1,ir),l=0,lmaxx,2)
      enddo
      write(11,*)
      do ir=0,nr
         psi=pot(ir*dr,0.)
!	 ,apot,dr,nr,lmax)
         write(11,'(2g16.8)') ir*dr,diskdens(ir*dr,0.0,psi)
      enddo
      close(11)

      write(*,*) 'Final model written to file ''dbh.dat''.'
12345 continue
      
      end

module thickdiskMOD
 private
 public :: initthickdisk,fi,sets,fint,dfidr,dfidz,dfint,ddfint, &
  firstcall,readdisk,writedisk

 real, parameter :: pi=3.141592654
 real, parameter :: dx=.05
 character(*), parameter :: datafile='gaspot.dat'

! fi approximately ok to rmax/dx/2 ..
! dr,dslice not super important 
 real :: rmax,zmax,kmax,dk,dr,dslice,router,totalmass
 integer :: nr,nk,nslices
 real, allocatable :: s(:,:)
 real, allocatable :: slicez(:)

 real, parameter :: fifac=1.2
 integer :: nfi 
 real :: dfi
 real, allocatable :: fitable(:,:),fir(:),dfidrtable(:,:),dfidztable(:,:), &
                       dfitable(:),ddfitable(:)

 logical, save :: firstcall=.true.

 contains

subroutine readdisk
 if (.not. firstcall) return
 firstcall=.false.
 open(unit=1,file=datafile,status='OLD',form='UNFORMATTED')
 read(1) rmax,zmax,kmax,dk,dr,dslice,router,totalmass,dfi
 read(1) nr,nk,nslices,nfi
 allocate(s(0:nslices,0:nk),slicez(0:nslices))
 allocate(fitable(0:nfi,0:nfi),dfidrtable(0:nfi,0:nfi),dfidztable(0:nfi,0:nfi), &
       dfitable(0:nfi),ddfitable(0:nfi),fir(0:nfi)) 
 read(1) s
 read(1) slicez
 read(1) fitable
 read(1) fir
 read(1) dfidrtable
 read(1) dfidztable
 read(1) dfitable
 read(1) ddfitable
 close(1)
 write(0,*) ' thickdisk read:', datafile
end subroutine

subroutine writedisk
 print*,' thickdisk writing:', datafile
 open(unit=1,file=datafile,status='UNKNOWN',form='UNFORMATTED')
 write(1) rmax,zmax,kmax,dk,dr,dslice,router,totalmass,dfi
 write(1) nr,nk,nslices,nfi
 write(1) s
 write(1) slicez
 write(1) fitable
 write(1) fir
 write(1) dfidrtable
 write(1) dfidztable
 write(1) dfitable
 write(1) ddfitable
 close(1)
end subroutine

subroutine initthickdisk(rm,zm,lnr,nz,tmass)
 real, external :: dens
 real, optional :: rm,zm,tmass
 integer, optional :: lnr,nz
 real :: mm
 integer :: iz

 firstcall=.false.
 print*,' init thickdiskmod'

 if(present(rm)) then
  rmax=rm
 else
  print*,'rmax?'
  read*,rmax
 endif  

 if(present(zm)) then
  zmax=zm
 else
  print*,'zmax?'
  read*,zmax
 endif  

 if(present(lnr)) then
  nr=lnr
 else
  print*,'# of radii?'
  read*,nr
 endif  

 if(present(nz)) then
  nslices=nz
 else
  print*,'# of slices?'
  read*,nslices
 endif  

 if(present(tmass)) then
  totalmass=tmass
 else
  print*,'target mass?'
  read*,totalmass
 endif  

 dr=rmax/nr
 dslice=zmax/nslices
 nk=nr/dx
 kmax=1/dr 
 dk=dx/rmax
 router=rmax/dx

 allocate(s(0:nslices,0:nk),slicez(0:nslices))

 s=0
 do iz=0,nslices
  slicez(iz)=dslice*iz
 enddo
 print*,'total mass:',totalmass

 nfi=nr
 allocate(fitable(0:nfi,0:nfi),dfitable(0:nfi),ddfitable(0:nfi),fir(0:nfi)) 
 allocate(dfidrtable(0:nfi,0:nfi),dfidztable(0:nfi,0:nfi)) 
 fir(0)=0
 do i=0,nfi
  fir(i)=router*fifac**(-nfi+i)
 enddo
 print*,'rmin:', fir(1)
 fitable=0
 dfidrtable=0
 dfidztable=0

end subroutine

 function fint(r,z) result(fi)
  real fi,r,z,du,dt,lz
  integer u,t  
  lz=abs(z)
  if(r.ge.router.or.lz.ge.router) then
   fi=totalmass/SQRT(r*r+lz*lz)
   return
  else
  u=log(r/router)/log(fifac)+nfi
  t=log(lz/router)/log(fifac)+nfi
  if(u.lt.0) u=0
  if(t.lt.0) t=0
  du= (r-fir(u))/(fir(u+1)-fir(u))
  dt= (lz-fir(t))/(fir(t+1)-fir(t))
   fi= du*dt*fitable(u+1,t+1)+(1-du)*dt*fitable(u,t+1)+ &
       du*(1-dt)*fitable(u+1,t)+(1-dt)*(1-du)*fitable(u,t)
  endif
 end function

 function dfidr(r,z) result(dfi)
  real dfi,r,z,du,dt,lz
  integer u,t  
  lz=abs(z)
  if(r.ge.router.or.lz.ge.router) then
   dfi=totalmass*r/(r*r+lz*lz)**(1.5)
   return
  else
  u=log(r/router)/log(fifac)+nfi
  t=log(lz/router)/log(fifac)+nfi
  if(u.lt.0) u=0
  if(t.lt.0) t=0
  du= (r-fir(u))/(fir(u+1)-fir(u))
  dt= (lz-fir(t))/(fir(t+1)-fir(t))
   dfi= du*dt*dfidrtable(u+1,t+1)+(1-du)*dt*dfidrtable(u,t+1)+ &
       du*(1-dt)*dfidrtable(u+1,t)+(1-dt)*(1-du)*dfidrtable(u,t)
  endif
 end function

 function dfidz(r,z) result(dfi)
  real dfi,r,z,du,dt,lz,s
  integer u,t  
  s=1; if(z.lt.0) s=-1
  lz=abs(z)
  if(r.ge.router.or.lz.ge.router) then
   dfi=-s*totalmass*lz/(r*r+lz*lz)**(1.5)
   return
  else
  u=log(r/router)/log(fifac)+nfi
  t=log(lz/router)/log(fifac)+nfi
  if(u.lt.0) u=0
  if(t.lt.0) t=0
  du= (r-fir(u))/(fir(u+1)-fir(u))
  dt= (lz-fir(t))/(fir(t+1)-fir(t))
   dfi= du*dt*dfidztable(u+1,t+1)+(1-du)*dt*dfidztable(u,t+1)+ &
       du*(1-dt)*dfidztable(u+1,t)+(1-dt)*(1-du)*dfidztable(u,t)
  endif
  dfi=dfi*s
 end function


 function dfint(r) result(fi)
  real fi,r,du
  integer u  
  if(r.ge.router) then
   fi=totalmass/(r*r)
   return
  else
   u=log(r/router)/log(fifac)+nfi
   if(u.lt.0) u=0
   du= (r-fir(u))/(fir(u+1)-fir(u))
   fi=(1-du)*dfitable(u)+du*dfitable(u+1)
  endif  
 end function

 function ddfint(r) result(fi)
  real fi,r,du
  integer u  
  if(r.ge.router) then
   fi=-2*totalmass/(r*r*r)
   return
  else
  u=log(r/router)/log(fifac)+nfi
  if(u.lt.0) u=0
  du= (r-fir(u))/(fir(u+1)-fir(u))
  fi=(1-du)*ddfitable(u)+du*ddfitable(u+1)
  endif  
 end function
 
 subroutine fillfi
  integer i,j
  
  do i=0,nfi
   do j=0,nfi
    fitable(i,j)=fi(fir(i),fir(j))
   enddo
  enddo

  do j=0,nfi
   dfidrtable(0,j)=0.
   do i=1,nfi
    dfidrtable(i,j)=(fi(1.05*fir(i),fir(j))-fi(0.95*fir(i),fir(j)))/(0.1*fir(i))
   enddo
  enddo
 ! dfidrtable(0,0)=(fi(0.01*fir(1),0.)-fi(0.,0.))/(0.01*fir(1))

  do i=0,nfi
   dfidztable(i,0)=0.
   do j=1,nfi
    dfidztable(i,j)=(fi(fir(i),1.05*fir(j))-fi(fir(i),0.95*fir(j)))/(0.1*fir(j))
   enddo
  enddo
 ! dfidztable(0,0)=(fi(0.,0.01*fir(1))-fi(0.,0.))/(0.01*fir(1))

 dfitable(0)=(fi(0.1*fir(1),0.)-fi(0.,0.))/(0.1*fir(1))
 do i=1,nfi
  dfitable(i)=(fi(1.05*fir(i),0.)-fi(0.95*fir(i),0.))/(0.1*fir(i))
 enddo

 ddfitable(0)=(dfitable(1)-dfitable(0))/(fir(1))
 ddfitable(nfi)=(dfitable(nfi)-dfitable(nfi-1))/(fir(nfi)-fir(nfi-1))
 do i=1,nfi-1
  ddfitable(i)=(dfitable(i+1)-dfitable(i-1))/(fir(nfi+1)-fir(nfi-1))
 enddo

 end subroutine

subroutine sets(dens)
  integer :: i,j,iz
  real :: k,r,mm
  real, external :: dens
 do iz=0,nslices
 do i=0,nk
  k=i*dk
  s(iz,i)=0.5*bessj0(k*rmax)*dslice*dens(rmax,slicez(iz))*rmax
  do j=1,nr-1
   r=j*dr
   s(iz,i)=s(iz,i)+bessj0(r*k)*dslice*dens(r,slicez(iz))*r
  enddo
  s(iz,i)=-2*pi*s(iz,i)*dr
 enddo
 enddo
 mm=-(s(0,0)+s(nslices,0)+2*sum(s(1:nslices-1,0)))
! print*,'mass:', mm
 if(mm.EQ.0) call error('zero mass??')
 s=s/mm*totalmass
 call fillfi
 print*,'filled fi'
end subroutine

function ftilde(k,z) result(f)
  real k,z,f,az,dz
 az=abs(z)
 dz=dslice
 if(k.EQ.0.) then
  f=1.
  return
 endif  
 if(az.GT.dz/2.) then
  f=exp(-k*az)/(dz*k)*(exp(k*dz/2.)-exp(-k*dz/2.))
 else
  f=1/(dz*k)*(2.-exp(-k*dz/2.)*(exp(-k*az)+exp(k*az)))
 endif
end function

function fi(r,z) 
  real :: r,z,fi,k,zs
  integer :: i,j,iz
 fi=0
 do i=-nslices,nslices
  zs=i*dslice
  iz=i
  if(iz.LT.0) iz=-iz
  fi=fi+0.5*(s(iz,0)*ftilde(0.,z-zs)*bessj0(0)+ &
            s(iz,nk)*ftilde(kmax,z-zs)*bessj0(r*kmax))  
  do j=1,nk-1
   k=j*dk
   fi=fi+s(iz,j)*ftilde(k,z-zs)*bessj0(r*k)
  enddo
 enddo
 fi=fi*dk
end function

 subroutine error(string,i)
  character(*) :: string
  integer, optional :: i
  
  print*,'error detected in thickdiskmod'

  if(present(i)) then
   print*,string,i
  else
   print*,string
  endif
  stop
end subroutine

end module

module hydrostaticdiskMod

 private
 public :: initdisk,dens,zEquilibrium,getz,totalmassQ,driftcorfac,radQ, &
                 setsimplez,readgasdisk,writegasdisk,csigtabQ,firstcall, &
		 nrQ,csQ,getrad
		 


 real, parameter :: pi=3.141592654
 character(*), parameter :: datafile='gasdens.dat'
 integer :: nr,nz
 real :: rmax,zmax,dr,dz
 
 real, allocatable :: rad(:),zet(:)
 real, allocatable :: sigtab(:)
 real, allocatable :: csigtab(:)
 real, allocatable :: denstab(:,:)
 real, allocatable :: cdenstab(:,:)
 real, allocatable :: ddenstab(:)
 real :: cs,gamma,totalmass

 logical, save :: firstcall=.true.
 
 contains

function csQ()
 real :: csQ
 csQ=cs
end function



function radQ()
 real :: radQ(0:nr)
 radQ=rad
end function

function nrQ()
 integer :: nrQ
 nrQ=nr
end function

function csigtabQ()
 real :: csigtabQ(0:nr)
 csigtabQ=csigtab
end function

subroutine initDisk(sigma,rextent,zextent,nrad,nzet,csnd,gam,tmass)
 real, external :: sigma
 real, optional :: rextent,zextent,tmass,csnd,gam
 integer, optional :: nrad,nzet
 print*,'init hydrostatic disk'

 firstcall=.false.
 if(present(rextent)) then
  rmax=rextent
 else
  print*,'rmax?'
  read*,rmax
 endif  

 if(present(zextent)) then
  zmax=zextent
 else
  print*,'zmax?'
  read*,zmax
 endif  

 if(present(nrad)) then
  nr=nrad
 else
  print*,'nrad?'
  read*,nr
 endif  

 if(present(nzet)) then
  nz=nzet
 else
  print*,'nz?'
  read*,nz
 endif  

 if(present(csnd)) then
  cs=csnd
 else
  print*,'csound?'
  read*,cs
 endif  

 if(present(gam)) then
  gamma=gam
 else
  print*,'gamma?'
  read*,gamma
 endif  

 dr=rmax/nr;dz=zmax/nz
 allocate(rad(0:nr), sigtab(0:nr),csigtab(0:nr), &
             denstab(0:nr,0:nz),cdenstab(0:nr,0:nz),zet(0:nz)) 
 totalmass=0

 print*,dr,dz,nr,nz
 do i=0,nr
  r=i*dr
  rad(i)=r
  sigtab(i)=sigma(r)
 enddo
 csigtab(0)=0.
 do i=1,nr
  csigtab(i)=csigtab(i-1)+2*Pi*dr*(rad(i)*sigtab(i)+rad(i-1)*sigtab(i-1))/2.
 enddo
 totalmass=csigtab(nr)
 print*,'hydrostaticdisk mass:',totalmass
 if(present(tmass)) then
  print*,' mass corrected to:',tmass
  sigtab=sigtab*tmass/totalmass  
  csigtab=csigtab*tmass/totalmass  
 endif 
 do j=0,nz
  zet(j)=j*dz
 enddo
 denstab=0
 cdenstab=0
 allocate(ddenstab(0:nr))
 call setdd
end subroutine

function totalmassQ()
 real totalmassQ
 totalmassQ=totalmass
end function 

function dens(r,z)
  real dens,r,z,du,dt,lz
  integer u,t  
  lz=abs(z)
  if(r.gt.rmax.or.lz.gt.zmax) then
   dens=0
   return
  else
   u=r/dr
   t=lz/dz
   du=r/dr-u
   dt=lz/dz-t
   dens= du*dt*denstab(u+1,t+1)+(1-du)*dt*denstab(u,t+1)+ &
       du*(1-dt)*denstab(u+1,t)+(1-dt)*(1-du)*denstab(u,t)
  endif  
end function

subroutine zEquilibrium(pot)
 real,external :: pot
 real :: r,z,fi,fi0,signorm
 integer :: i,j
 do i=0,nr
  r=i*dr
  fi0=pot(r,0.)
  do j=0,nz
   z=j*dz
   fi=pot(r,z)
   denstab(i,j)=exp(-gamma*(fi-fi0)/cs**2)   
  enddo   
  signorm=(denstab(i,0)+denstab(i,nz)+2*sum(denstab(i,1:nz-1)))*dz
  denstab(i,0:nz)=denstab(i,0:nz)*sigtab(i)/signorm
  cdenstab(i,0)=0.
  do j=1,nz
   cdenstab(i,j)=cdenstab(i,j-1)+dz*(denstab(i,j)+denstab(i,j-1))/2.
  enddo
 enddo
 call setdd
end subroutine

subroutine setsimplez(zdisk)
 real :: r,z,fi,fi0,signorm,zdisk,con
 integer :: i,j
 do i=0,nr
  r=i*dr
  fi0=pot(r,0.)
  do j=0,nz
   z=j*dz
   con = exp(-abs(z/zdisk))
   con = (2.0*con/(1.0 + con*con))**2
   denstab(i,j)=con   
  enddo   
  signorm=(denstab(i,0)+denstab(i,nz)+2*sum(denstab(i,1:nz-1)))*dz
  denstab(i,0:nz)=denstab(i,0:nz)*sigtab(i)/signorm
  cdenstab(i,0)=0.
  do j=1,nz
   cdenstab(i,j)=cdenstab(i,j-1)+dz*(denstab(i,j)+denstab(i,j-1))/2.
  enddo
 enddo
 call setdd
end subroutine

subroutine setdens(n,m,indens)
 integer :: n,m,i,j
 real :: indens(0:n,0:m),r,signorm
 if(nr.NE.n.OR.nz.NE.m) call error('array mismatch')
 denstab=indens
 do i=0,nr
  r=i*dr
  signorm=(denstab(i,0)+denstab(i,nz)+2*sum(denstab(i,1:nz-1)))*dz
  denstab(i,0:nz)=denstab(i,0:nz)*sigtab(i)/signorm
  cdenstab(i,0)=0.
  do j=1,nz
   cdenstab(i,j)=cdenstab(i,j-1)+dz*(denstab(i,j)+denstab(i,j-1))/2.
  enddo
 enddo
 call setdd
end subroutine

subroutine readgasdisk
 if (.not. firstcall) return
 firstcall=.false.
 open(unit=1,file=datafile,status='old',form='UNFORMATTED')
 read(1) rmax,zmax,nr,nz,cs,gamma,totalmass,dr,dz 
 allocate(rad(0:nr), sigtab(0:nr),csigtab(0:nr), &
             denstab(0:nr,0:nz),cdenstab(0:nr,0:nz),zet(0:nz))  
 read(1) rad,zet
 read(1) sigtab 
 read(1) csigtab
 read(1) denstab
 read(1) cdenstab
 close(1)
 allocate(ddenstab(0:nr))
 call setdd
 write(0,*) ' hydrostaticdisk read:', datafile
end subroutine

subroutine writegasdisk
 print*,' hydrostaticdisk writing:', datafile
 open(unit=1,file=datafile,status='unknown',form='UNFORMATTED')
 write(1) rmax,zmax,nr,nz,cs,gamma,totalmass,dr,dz 
 write(1) rad,zet
 write(1) sigtab 
 write(1) csigtab
 write(1) denstab
 write(1) cdenstab
 close(1)
end subroutine

function driftcorfac(r) result(x)
 real :: x,r,du,d,dd
 integer :: u

  d=dens(r,0.)
  if(r.gt.rmax.OR.d.EQ.0) then
   x=0
   return
  else
   u=r/dr
   du=r/dr-u
   dd=du*ddenstab(u+1)+(1-du)*ddenstab(u)
   x=-r*dd/d
  endif  
end function

subroutine setdd
 ddenstab(0)=(denstab(1,0)-denstab(0,0))/(rad(1)-rad(0))
 ddenstab(nr)=(denstab(nr,0)-denstab(nr-1,0))/(rad(nr)-rad(nr-1))
 do i=1,nr-1
 ddenstab(i)=(denstab(i+1,0)-denstab(i-1,0))/(rad(i+1)-rad(i-1))
 enddo
end subroutine

function getz(r,rnd)
 real getz,rnd,z1,z2,du,y1,y2
 integer :: u
 getz=0
 u=r/dr
 du=r/dr-u
 if(u.GE.nr.OR.u.LT.0) call error('r out of range',u)
 y1=cdenstab(u,nz)*rnd
 y2=cdenstab(u+1,nz)*rnd
 z1=invertcumul(nz,zet(0:nz),cdenstab(u,0:nz),y1)
 z2=invertcumul(nz,zet(0:nz),cdenstab(u+1,0:nz),y2)
 getz=du*z2+(1-du)*z1
end function 

function getrad(rnd)
 real getrad,rnd,y
 integer :: u
 getr=0
 y=csigtab(nr)*rnd
 getrad=invertcumul(nr,rad(0:nr),csigtab(0:nr),y)
end function 

function invertcumul(n,xlist,ylist,y) result(x)
 integer :: n,bin,up,low
 real :: xlist(n),ylist(n),x,y,u,s  
 if(ylist(1).LT.ylist(n)) then
  s=1
 else
  s=-1
 endif   
 if(s*y.LE.s*ylist(1)) then
  x=xlist(1)
  return
 endif
 if(s*y.GE.s*ylist(n)) then
  x=xlist(n)
  return
 endif
 up=n;low=1
 do while((up-low).GT.1)
   bin=(low+up)/2
   if(s*y.LT.s*ylist(bin)) then
    up=bin
   else
    low=bin
   endif   
 enddo 
 bin=up
 u=(y-ylist(bin-1))/(ylist(bin)-ylist(bin-1))
 x=(1-u)*xlist(bin-1)+u*xlist(bin)  
 return
end function

 subroutine error(string,i)
  character(*) :: string
  integer, optional :: i
  
  print*,'error detected in hydrostat'

  if(present(i)) then
   print*,string,i
  else
   print*,string
  endif
  stop
 end subroutine

end module

function sigma(r) result(x)
 real gasm,gasr,gastr,gasdt,csnd,gamma,gassig
 integer gasnr
 common /gasstuf/ gasm,gasr,gastr,gasdt,csnd,gamma,gasnr,gassig,gasz
 real r,x,tr,dtr
  dtr=(r-gastr)/gasdt
  tr=1
  if(dtr.gt.-20) then
   if(dtr.lt.10) then
    tr=1/(1.+exp(dtr))   
   else
    tr=0
  endif
  endif
   x=tr*gassig/(1+r/gasr)  
 end function

function thickdiskdens(r,z) result(ddens)
 use hydrostaticdiskMod
 real ddens,r,z
 if(firstcall) call readgasdisk
 ddens=dens(r,z)
end function

function thickdiskpot(r,z) result(pot)
  use thickdiskMOD
 real pot,r,z
 if(firstcall) call readdisk
 pot=fint(r,z)
end function 

function thickdiskforce(r) result(x) ! -fi'
  use thickdiskMOD
 real x,r,z
 if(firstcall) call readdisk
 x=-dfint(r)
end function 

function thickdiskrforce(r,z) result(x) ! -dfi/dr
  use thickdiskMOD
 real x,r,z
 if(firstcall) call readdisk
 x=-dfidr(r,z)
end function 

function thickdiskzforce(r,z) result(x) ! -dfi/dz
  use thickdiskMOD
 real x,r,z
 if(firstcall) call readdisk
 x=-dfidz(r,z)
end function 


function thickdiskf2(r) result(x) ! fi''
  use thickdiskMOD
 real x,r,z
 if(firstcall) call readdisk
 x=ddfint(r)
end function 

subroutine setgasdisk()
 use hydrostaticdiskMod
 use thickdiskMod
 
 real gasm,gasr,gastr,gasdt,csnd,gamma,gassig
 integer gasnr
 common /gasstuf/ gasm,gasr,gastr,gasdt,csnd,gamma,gasnr,gassig,gasz
 real rextent,zextent
 real,external :: sigma
 integer nr,nz,nslices
 parameter(pi=3.1415926535)

 gassig=gasm/(2*pi*gasr**2*(gastr/gasr-log(1+gastr/gasr)))
 rextent=gastr+10*gasdt
 zextent=gasz
 nr=gasnr
 nz=nr/2
 nslices=nr/5
 print*,'rextent,zextent:',rextent,zextent
 call initDisk(sigma,rextent,zextent,nr,nz,csnd,gamma,gasm)
 print*,'gas sigma0:',sigma(0.)
 call initthickdisk(rextent,zextent,nr,nslices,gasm)
 
end subroutine 

subroutine firstgasdens(zdisk)
 use hydrostaticdiskMod
 real zdisk
 call setsimplez(zdisk)
end subroutine 

subroutine solveZ
 use hydrostaticdiskMod
 real, external :: pot
 call zEquilibrium(pot)
end subroutine

subroutine solvepot
  use thickdiskMOD
 real, external :: thickdiskdens
 call sets(thickdiskdens)
end subroutine

subroutine writegas
 use hydrostaticdiskMod
 use ThickdiskMod
 call writegasdisk
 call writedisk
 print*,' gas dens+pot files written'
end subroutine 

      function polardens(r,ctheta,l)
      parameter(pi=3.1415926535)
c returns density at r,theta, multiplied by the lth harmonic
c (must integrate this over theta to get the harmonic coeff)
      common/legendre/ plcon(0:40)
      z=r*ctheta
      s=r*sqrt(1.0 - ctheta*ctheta)
!      print*,r,s,dens(s,z),plgndr1(l,ctheta),plcon(l)
      polardens=dens(s,z)*plcon(l)*plgndr1(l,ctheta)
      return
      end


      

      function halodenspsi(energy)

      include 'commonblocks'

      if(energy.lt.psic) then
         halodenspsi = 0.
         return
      endif
      if(energy.ge.psi0) then
         halodenspsi = denspsihalo(1)
         return
      endif

      rj = 1. + float(npsi-1)*
     +     log((psi0-energy)/(psi0-psid))/log((psi0-psic)/(psi0-psid))
      j = int(rj)
      if(j.lt.1) j = 1
      if(j.ge.npsi) j = npsi-1

      frac = rj - float(j)
      halodenspsi = denspsihalo(j) + 
     +     frac*(denspsihalo(j+1)-denspsihalo(j))

      return
      
      end

      function diskdf5intez(vt,r,z)
      parameter (pi=3.1415926535)

      real psir0,psirz

      psir0=pot(r,0.0)
      if (z.eq.0.) then 
         psirz=psir0
      else
         psirz=pot(r,z)
         endif
      ep=0.5*(vt*vt)-psir0
      am=r*vt
      ez=-psirz+psir0
      
      diskdf5intez=diskdf3intez(ep,am,ez)
      if(diskdf5intez.lt.0.) diskdf5intez = 0.

      return
      end            

      subroutine halopotentialestimate

      include 'commonblocks'
      common /haloestimate/ hdens(0:nmax),hpot(0:nmax),hfr(0:nmax)

      eps = 0.0001
     
      do ir=0,nr
         r=ir*dr
         if(r.eq.0.) r = eps
         hdens(ir)=halodensity(r)
 77   enddo

c     now get the potential harmonics of this new density. (BT 2-208)
c     Simpson's rule integration.

      s1(0)=0
      r = 2*dr
      s1(2)=(r*dr/3.)*(4*hdens(1)*(1.0-dr/r)**2+hdens(2))
      rold = r 
      do ir=4,nr,2
         r=ir*dr
         s1a = (r*dr/3.)*(hdens(ir-2)*(1.0-2*dr/r)**2+
     +        4*hdens(ir-1)*(1.0-dr/r)**2+hdens(ir))
         s1(ir) = s1a + s1(ir-2)*rold/r
         rold = r
      enddo
      s2(nr)=0
      rold = nr*dr
      do ir=nr-2,2,-2
         r=ir*dr
         s2a = (r*dr/3.)*(hdens(ir+2)*(1.0+2*dr/r)+
     &        4*hdens(ir+1)*(1.0+dr/r)+hdens(ir))
         s2(ir) = s2a + s2(ir+2)
         rold = r
      enddo

      do ir = 2,nr,2
         r = ir*dr
         hpot(ir)=(4.*pi)*(s1(ir)+s2(ir))
         hfr(ir)=-(4.*pi)*s1(ir)/r
      enddo

      hpot(0)=3*(hpot(2)-hpot(4))+hpot(6)
      hfr(0)=0.0
      
c     then linearly interpolate other bins.
      
      do ir=1,nr-1,2
         hpot(ir)=(hpot(ir-1)+hpot(ir+1))/2.
         hfr(ir)=(hfr(ir-1)+hfr(ir+1))/2.
      enddo

      return
      end

      function haloforce(r)

      include 'commonblocks'
      common /haloestimate/ hdens(0:nmax),hpot(0:nmax),hfr(0:nmax)

      ihi=int(r/dr)+1
      if (ihi.lt.1) ihi=1
      if (ihi.gt.nr) ihi=nr
      r1=dr*(ihi-1)
      r2=dr*ihi
      t=(r-r1)/(r2-r1)
      tm1 = 1.0 - t
      if (r.eq.0.) then
         lmaxx=0
         costheta=0
      else
         costheta=z/r
         lmaxx=lmax
      endif
      haloforce = (t*hfr(ihi)+ tm1*hfr(ihi-1))

      return
      end

      subroutine omekap(r,fom,fka)
      parameter (pi=3.1415926535)

      dimension rr(20000),om(20000),om2(20000),psi(20000),
     +                   ak(20000),ak2(20000)
      dimension psirr(20000)
      data ifirst /0/
      save ifirst, a, b
      save rr,om,om2,ak,ak2,nreq
c read omega, potential and potential'' from the frequencies file, 
c spline-fit pot(r), 
c and then use the 2nd derivatives of the potential in the table of 
c kappa. these can then in turn be spline-fitted. should arrange for 
c the boundary condition at r=0 to be even for pot, omega and kappa.
      if (ifirst.eq.0) then
	open(13,file='newfreqdbh.dat',status='old',err=999)
        read(13,*)
        read(13,*)
        read(13,*)
        nreq=0
c read only every other step, since remainder was linearly 
c interpolated anyway
77      read(13,*,end=99) rr(nreq+2),vc,psi(nreq+2),psirr(nreq+2)
        om(nreq+2)=vc/rr(nreq+2)
        nreq=nreq+1
        read(13,*,end=99) 
        goto 77
c extrapolate omega (linearly) and potential (quadratically) to zero
99      close(13)
        om(1)=2*om(2)-om(3)
        psi(1)=(4*psi(2)-psi(3))/3.
        psirr(1)=(4*psirr(2)-psirr(3))/3.
        rr(1)=0.
        call splined(rr,om,nreq,1.e32,1.e32,om2)
c        call splined(rr,psi,nreq,0.,1.e32,psi2)
c calculate epicycle frequencies
        ak(1)=2*om(1)
        do ir=2,nreq
          ak(ir)=sqrt(max(0.,psirr(ir)+3*om(ir)**2))
        enddo
        call splined(rr,ak,nreq,0.,1.e32,ak2)
c a and b are coefficients of potential -a/r -b/r^3 +c 
c which give omeka and kappa as observed
c at the outer radius of the model---these are used to extrapolate if needed.
c in this potential om^2=a/r^3+3b/r^5, kap^2=a/r^3-3b/r^5 
        a=rr(nreq)**3/2.*(om(nreq)**2+ak(nreq)**2)
        b=rr(nreq)**5/6.*(om(nreq)**2-ak(nreq)**2)
        c=a/rr(nreq)**3+b/rr(nreq)**5+psi(nreq)
!!!
        open(11,file='omekap.dat',status='unknown',err=23)
        do ir=1,nreq
          write(11,'(7g16.8)') rr(ir),om(ir),om2(ir),ak(ir),ak2(ir),
     +                          psi(ir),psirr(ir)
          enddo
        do ir=1,10
           rx=rr(nreq)*(1+0.1*ir)
           r3=a/rx**3
           r5=3*b/rx**5
           fom=sqrt(r3+r5)
           fka=sqrt(r3-r5)
           write(11,'(7g16.8)') rx,fom,0.,fka,0.,
     +                          c-(r3+r5/3.)*rx*rx,-2*r3-4*r5
           enddo
        close(11)
        write(0,*) 'wrote a table of frequencies in file omekap.dat.'
 23     continue
        ifirst=1
      endif
      
      if (r.gt.rr(nreq)) then
         r3=a/r**3
         r5=3*b/r**5
         fom=sqrt(r3+r5)
         fka=sqrt(r3-r5)
      else
         call splintd(rr,om,om2,nreq,r,fom)
         call splintd(rr,ak,ak2,nreq,r,fka)
         endif	 
!      do ir=1,nreq
!       print*,rr(ir),om(ir),ak(ir)
!      enddo
!      stop
      return
999   write(0,*) 'no file with frequencies corresponding to the potential!'
      stop
      end

      function diskdenspsi(r,z,psi) 
      parameter (pi=3.1415926535)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
 
c the truncation factor is derived assuming that the azimuthal velocity dist
c is gaussian with dispersion sigma_R * 2 omega/kappa, as per epicycle theory.
      if( abs(z/zdisk) .gt. 10.) goto 99
      erfarg=(r-outdisk)/1.4142136/drtrunc
      if (erfarg.gt.4.) goto 99
      if (erfarg.lt.-4) then
         trunfac=1
      else
         trunfac=0.5*erfc(erfarg)
      endif
      if (z.eq.0.) then
         con=1
      else
        psizh= pot(r,zdisk)
        psi0 = pot(r,0.)
        con = 0.419974**((psi-psi0)/(psizh-psi0))
      endif
      diskdenspsi = diskconst*exp(-r/rdisk)*con*trunfac
      return
 99   diskdenspsi = 0.0
      return
      end

      function totdens(r,z)
      include 'commonblocks'
      real psi

      totdens = 0
      psi=pot(r,z)
      
      if( idiskflag .eq. 1 ) then
         totdens = totdens + diskdens(r,z,psi)
      endif      
      if( ihaloflag .eq. 1 ) then
         totdens = totdens + halodenspsi(psi)
      endif
      if( ibulgeflag .eq. 1 ) then
         totdens = totdens + bulgedenspsi(psi)
      endif

      return
      end

! wat als idiskflag=2 etc?
      function dens(r,z)
      parameter (pi=3.1415926535)
      common /flags/ idiskflag, ibulgeflag, ihaloflag
     
      if( idiskflag .eq. 1 .or. idiskflag.eq.3) then
	 addens = appdiskdens(r,z)
         dens=totdens(r,z)
         dens = dens - addens
!         if(dens.LT.0) dens=0
      else
         dens=totdens(r,z)
      endif
      return
      end

      program getfreqs

      parameter(pi=3.1415926535)
      common /potconstants/ apot(20,0:20000), fr(20,0:20000), 
     +     dr, nr, lmax, potcor
      common/legendre/ plcon(0:40)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /flags/ idiskflag, ibulgeflag, ihaloflag
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      
      real adens(20,0:20000),potmaj(0:20000),
     +     potmajtot(0:20000),potup(0:20000),surden(0:20000),
     +     potmin(0:20000),vcmaj(0:20000),vctot(0:20000),vertfreq(0:20000),vcbulge(0:20000),
     +     vertfreqbulge(0:20000),psi2(0:20000),fr2(20,0:20000)

c  constants for legendre polynomials
      do l=0,40
         plcon(l) = sqrt((2*l+1)/(4.0*pi))
      enddo

      open(14,file='dbh.dat',status='old')
      open(15,file='newfreqdbh.dat',status='unknown')

      read(14,*) 
      read(14,'(2x,7g15.5,i6,i4)') psi00,v0,q,a,b,c,dr,nr,lmax
      read(14,*)
      read(14,'(2x,3g15.5)') psiout,rho1,sigbulge
      read(14,*)
      read(14,'(2x,5g15.5)') rmdisk, rdisk, zdisk, outdisk, drtrunc
      read(14,'(2x,3i5)') idiskflag, ibulgeflag, ihaloflag
      read(14,*)
      write(0,'(x,''Harmonics up to l='',i4)') lmax

      rdisk2 = rdisk*rdisk
      diskconst = rmdisk/(4.0*pi*rdisk2*zdisk)


      do ir=0,nr
         read(14,*) rr,(adens(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)

      do ir=0,nr
         read(14,*) rr,(apot(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)

      do ir=0,nr
         r=ir*dr
         potmajtot(ir)=pot(r,0.)
         potmin(ir)=pot(0.,r)
      enddo

      do ir=0,nr
         read(14,*) rr,(fr(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)
      read(14,*)

      do ir=0,nr
         r=ir*dr
         vctot(ir)=cfharm(r,0.,fr)
      enddo

      do ir=0,nr
         read(14,*) rr,(fr2(l/2+1,ir),l=0,lmax,2)
      enddo
      read(14,*)

      do ir=0,nr
         r=ir*dr
         psi2(ir)=cfharm(r,0.,fr2)
      enddo

      do ir=0,nr
         read(14,'(2g16.8)') rr,surden(ir)
      enddo
      
      close(14)

      print*,'total non-fixed mass:',vctot(nr)*ir*ir*dr*dr

       do ir=0,nr
        r=ir*dr
        if(ihaloflag.eq.2) then
	 vctot(ir)=vctot(ir)-fixedforce(r)
         psi2(ir)=psi2(ir)+fixedf2(r)
        endif
	if(idiskflag.EQ.2.OR.idiskflag.EQ.3) then
         vctot(ir)=vctot(ir)-thickdiskforce(r)
	 psi2(ir)=psi2(ir)+thickdiskf2(r)
	endif     	
	vctot(ir)=sqrt(max(0.,r*vctot(ir)))
       enddo

      
      drsave=dr
      nrsave=nr

      write(15,'(''#'',16(3x,a10,3x))') 'RADIUS','VC_TOT','PSIMAJ_TOT','PSI2'
      write(15,'(''#'')')

      ir=0
      write(15,'(9g16.8)') 0.,vctot(ir),potmajtot(ir),psi2(ir)

      do ir=1,nr  
         r=ir*dr
      write(15,'(9g16.8)') r,vctot(ir),potmajtot(ir),psi2(ir)
      enddo
 99   close(15)
      end

      program haloinfo
     
      character*60 filename
      parameter (pi=3.1415926535)
      common /fileroot/ filename
      common /potconstants/ apot(20,0:20000), frad(20,0:20000), 
     +     dr, nr, lmax, potcor
      common /legendre/ plcon(0:40)
      common /gparameters/  a, b, c, v0, q, psi00, 
     +                      psiout, rho1, sigbulge2, 
     +                      rmdisk, rdisk, zdisk, outdisk, drtrunc,
     +                      potcor1
      common /moreconstants/ v02, v03, rdisk2, diskconst, bulgea
      common /diskpars/ sigr0, disksr, nrdisk
      dimension ibuf(100)
      real r,z

      filename='dbh.dat'
      call readharmfile(filename,ibuf)
      
10    read*,r,z
      if(r.lt.0) stop
      print*,r, halodens(r,z)
      goto 10
      print*,' '
      
      end 

      function bulgedens(r,z)
      common /flags/ idiskflag, ibulgeflag, ihaloflag

      bulgedens=0
      psi = pot(r,z)
      psi0= pot(0.,0.)
      if(ibulgeflag.EQ.1) 
     &       bulgedens = bulgedens+ bulgedenspsi(psi,psi0)
      if(ibulgeflag.EQ.3) 
     &       bulgedens = bulgedens+ bulgedfdenspsi(psi,psi0)  
      return
      end

      function sigz2(r)

      include 'commonblocks'

      psizh=pot(r,zdisk)
      psi00=pot(r,0.0)
cc
      truesigz2=(psizh-psi00)/log(0.419974)
cc
      call splintd(rr(0),fszrat(0),szrat2(0),nrspl+1,r,fcor)
      sigz2=truesigz2*fcor
      if(sigz2.lt.0.) sigz2 = 1.e-10

      return
      end

      subroutine diskpotentialestimate

      include 'commonblocks'
      common /diskestimate/ ddens(0:nmax),dpot(0:nmax),dfr(0:nmax)

      eps = dr/10.
      ntheta = 100
     
      do ir=0,nr
         r=ir*dr
         if(r.eq.0.) r = eps
         cthetamax = min(1.,10.*zdisk/r)
         dctheta=cthetamax/float(ntheta)
         s=s+dpolardiskdens(r,cthetamax)+dpolardiskdens(r,0.0)
         do is=1,ntheta-1,2
            ctheta=is*dctheta
            s=s+4*dpolardiskdens(r,ctheta)
         enddo
         do is=2,ntheta-2,2
            ctheta=is*dctheta
            s=s+2*dpolardiskdens(r,ctheta)
         enddo
         s=s*dctheta/3.
         ddens(ir)=s
 77   enddo

c     now get the potential harmonics of this new density. (BT 2-208)
c     Simpson's rule integration.

      s1(0)=0
      r = 2*dr
      s1(2)=(r*dr/3.)*(4*ddens(1)*(1.0-dr/r)**2+ddens(2))
      rold = r 
      do ir=4,nr,2
         r=ir*dr
         s1a = (r*dr/3.)*(ddens(ir-2)*(1.0-2*dr/r)**2+
     +        4*ddens(ir-1)*(1.0-dr/r)**2+ddens(ir))
         s1(ir) = s1a + s1(ir-2)*rold/r
         rold = r
      enddo
      s2(nr)=0
      rold = nr*dr
      do ir=nr-2,2,-2
         r=ir*dr
         s2a = (r*dr/3.)*(ddens(ir+2)*(1.0+2*dr/r)+
     &        4*ddens(ir+1)*(1.0+dr/r)+ddens(ir))
         s2(ir) = s2a + s2(ir+2)
         rold = r
      enddo

      do ir = 2,nr,2
         r = ir*dr
         dpot(ir)=(4.*pi)*(s1(ir)+s2(ir))
         dfr(ir)=-(4.*pi)*s1(ir)/r
      enddo

      dpot(0)=3*(dpot(2)-dpot(4))+dpot(6)
      dfr(0)=0.0
      
c     then linearly interpolate other bins.
      
      do ir=1,nr-1,2
         dpot(ir)=(dpot(ir-1)+dpot(ir+1))/2.
         dfr(ir)=(dfr(ir-1)+dfr(ir+1))/2.
      enddo

      return
      end

      function diskforce(r)

      include 'commonblocks'
      common /diskestimate/ ddens(0:nmax),dpot(0:nmax),dfr(0:nmax)

      ihi=int(r/dr)+1
      if (ihi.lt.1) ihi=1
      if (ihi.gt.nr) ihi=nr
      r1=dr*(ihi-1)
      r2=dr*ihi
      t=(r-r1)/(r2-r1)
      tm1 = 1.0 - t
      if (r.eq.0.) then
         lmaxx=0
         costheta=0
      else
         costheta=z/r
         lmaxx=lmax
      endif
      diskforce = (t*dfr(ihi)+ tm1*dfr(ihi-1))

      return
      end

      function diskdensity(r)

      include 'commonblocks'
      common /diskestimate/ ddens(0:nmax),dpot(0:nmax),dfr(0:nmax)

      ihi=int(r/dr)+1
      if (ihi.lt.1) ihi=1
      if (ihi.gt.nr) ihi=nr
      r1=dr*(ihi-1)
      r2=dr*ihi
      t=(r-r1)/(r2-r1)
      tm1 = 1.0 - t
      if (r.eq.0.) then
         lmaxx=0
         costheta=0
      else
         costheta=z/r
         lmaxx=lmax
      endif
      diskdensity = (t*ddens(ihi)+ tm1*ddens(ihi-1))

      return
      end

      function polarbulgedens(r,ctheta,l)

      common/legendre/ plcon(0:40)
c returns density at r,theta, multiplied by the lth harmonic
c (must integrate this over theta to get the harmonic coeff)
      z=r*ctheta
      s=r*sqrt(1.0 - ctheta*ctheta)
      polarbulgedens=bulgedenspsi(pot(s,z))*
     &               plcon(l)*plgndr1(l,ctheta)
      return
      end

      
      function diskdf3ez(ep,am,ez)
      parameter (pi=3.1415926535,nrmax=1000)
      
      psi00 = pot(0.0,0.0)
      rc=rcirc(am)
      call omekap(rc,fomega,fkappa)
      vc=rc*fomega
      ec=pot(rc,0.0)+0.5*vc**2
      if (am.lt.0.) ec = 2.0*psi00 - ec
      sr2=sigr2(rc)
      sz2=sigz2(rc)
      if (sz2.gt.0.) then
         fvert=fnamidden(rc)*exp(-ez/sz2)/sqrt(2*pi*sz2)
         diskdf3ez=fomega/(pi*fkappa)/sr2*exp(-(ep - ec)/sr2)*fvert
      else
         diskdf3ez=0
      endif
c      if (.not.(diskdf3ez.gt.0.) .and..not.(diskdf3ez.lt.0.) .and..not.(diskdf3ez.eq.0.)) then
c         write(*,*) 'DISK DF WAS NAN.'
c         write(*,*) 'EP,EZ,AM:',ep,ez,am
c         write(*,*) 'RC,EC,SR2,SZ2:',rc,ec,sr2,sz2
c         write(*,*)
c      endif
      return
      end
      

module sphericaldfMod

 private
 public :: initdf,maxE,halodf,gasRfromq,rhofromfi,fifromr,totalmass,rmax
 
 integer,parameter :: ngrid=3000
 real, parameter :: pi=3.1415926535897932385
 real :: r(0:ngrid),dens(0:ngrid),ddensdr(0:ngrid)
 real :: cmass(0:ngrid),fi(0:ngrid),df(0:ngrid) 
 real :: ddrhodfi2(0:ngrid)
 real :: extdens(0:ngrid),extmass(0:ngrid),tmass(0:ngrid)
 
 real, parameter :: F_ZERO_R_LIMIT=0.

 integer, parameter :: ntheta=50
 
! density parameters 
 real :: rs, rvir,rhos 
 real :: rcut,cnorm,rmax,rmin
   
 contains
 
 real function rho(r)
  real :: r
  if(r.LE.rvir) then
   rho=rhos*rs**3/(rs+r)/(rs**2+r**2)
  else
   rho=rhos*cnorm*rs/(rs+r)*exp(-r**2/rcut**2)
  endif 
 end function
 
 real function drhodr(r)
  real :: r
  if(r.LE.rvir) then
   drhodr=-rho(r)*(1/(rs+r)+2*r/(rs**2+r**2))
  else
   drhodr=-rho(r)*(1/(rs+r)+2*r/rcut**2)
  endif 
 end function

 real function ddrhodr2(r)
  real :: r
  if(r.LE.rvir) then
   ddrhodr2=-drhodr(r)*(1/(rs+r)+2*r/(rs**2+r**2))+rho(r)*(1/(rs+r)**2-2/(rs**2+r**2)+4*r**2/(rs**2+r**2)**2)
  else
   ddrhodr2=rho(r)*((1/(rs+r)+2*r/rcut**2)**2+1/(rs+r)**2-2/rcut**2)
  endif 
 end function

 function maxE()
  real maxE
  maxE=fi(0)
 end function 

 function totalmass()
  real totalmass
  totalmass=cmass(ngrid)
 end function
 
 function halodf(e) result(f)
  real :: f,e
  f=invertcumul(ngrid+1,df,fi,e)
 end function
  
 function gasRfromq(q) result(gasr)
  real :: gasr,q,cm 
  cm=q*cmass(ngrid)
  gasr=invertcumul(ngrid+1,r,cmass,cm)
 end function 
 
 function fifromr(rad) result (lfi)
  real :: rad,lfi
  lfi=invertcumul(ngrid+1,fi,r,rad)  
 end function
 
 function rhofromfi(rad) result (lrho)
  real :: rad,lrho
  lrho=invertcumul(ngrid+1,dens,fi,rad)  
 end function

 function int_theta(densfunc,r) result(s)
 real,external :: densfunc
 real :: dctheta,s,r
 integer :: is
  s=0
  dctheta=1.0/ntheta
  s=s+densfunc(0.,r)+densfunc(r,0.)
  do is=1,ntheta-1,2
    ctheta=is*dctheta
    s=s+4*densfunc(r*sqrt(1-ctheta**2),r*ctheta)
  enddo
  do is=2,ntheta-2,2
    ctheta=is*dctheta
    s=s+2*densfunc(r*sqrt(1-ctheta**2),r*ctheta)
  enddo
  s=s*dctheta/3.
  s=s
 end function
      
 subroutine initdf(densfunc,rscale,virR,rho0)
  integer :: i,j
  real :: fac,int
  real, optional :: rscale,virR,rho0
  real, external :: densfunc
  
  if(present(rscale)) then
   rs=rscale
  else
   print*,'Burkert scale length?'
   read*,rs
  endif 
   
  if(present(virR)) then
   rvir=virR
  else
   print*,'Burkert virial radius?'
   read*,rvir
  endif 

  if(present(rho0)) then
   rhos=rho0
  else
   print*,'Burkert density constant?'
   read*,rhos
  endif 

  rcut=Sqrt(rvir**2+rs**2)
  cnorm=exp(rvir**2/rcut**2)/(1+rvir**2/rs**2)

  rmin=1.e-4*rcut
  rmax=6*rcut
  
  print*,'rcut,rmax:',rcut,rmax
  
  fac=exp(log(rmax/rmin)/(1.*(ngrid-1)))  
!  fac=(rmax-rmin)/(ngrid-1.)

  r(1)=rmin
  dens(1)=rho(rmin)
  ddensdr(1)=drhodr(rmin)
  do i=2,ngrid-1
   r(i)=r(i-1)*fac
!   r(i)=r(i-1)+fac
   dens(i)=rho(r(i))
   ddensdr(i)=drhodr(r(i))
  enddo
  r(ngrid)=rmax  
  dens(ngrid)=rho(rmax)
  ddensdr(ngrid)=drhodr(rmax)
  r(0)=0.
  dens(0)=dens(1) ! assumption !
  ddensdr(0)=0.
!  dens(0)=(4*dens(1)-dens(2))/3.
!  ddensdr(0)=(dens(1)-dens(0))/r(1)

! external density  averaged over theta
  extdens(0)=densfunc(0.,0.)
  
  do i=1,ngrid
   extdens(i)=int_theta(densfunc,r(i))
  enddo

! note: instead of the theta-averaged external density, use the external
! averaged fi??

  cmass(0.)=0.
  cmass(1.)=4/3.*Pi*r(1)**3*dens(0)
  do i=2,ngrid
   cmass(i)=cmass(i-1)+4*Pi*(r(i)-r(i-1))*(r(i)**2*dens(i)+r(i-1)**2*dens(i-1))/2.
  enddo

  extmass(0.)=0.
  extmass(1.)=4/3.*Pi*r(1)**3*extdens(0)
  do i=2,ngrid
   extmass(i)=extmass(i-1)+4*Pi*(r(i)-r(i-1))*(r(i)**2*extdens(i)+r(i-1)**2*extdens(i-1))/2.
  enddo
  print*,'extmass:',extmass(ngrid)
  print*,'cmass:',cmass(ngrid)
  
  tmass=cmass+extmass
  
  fi(ngrid)=0 
  do i=ngrid-1,1,-1
   fi(i)=fi(i+1)+(r(i+1)-r(i))*(tmass(i)/r(i)**2+tmass(i+1)/r(i+1)**2)/2.
  enddo
  fi(0)=fi(1)+r(1)*(F_ZERO_R_LIMIT+tmass(1)/r(1)**2)/2.
 
 
  do i=1,ngrid
   ddrhodfi2(i)=(r(i)**2/tmass(i))**2* &
    ((2/r(i)-4*Pi*r(i)**2*(dens(i)+extdens(i))/tmass(i))*ddensdr(i)+ddrhodr2(r(i)))
  enddo
  ddrhodfi2(0)=ddrhodfi2(1)

  df(ngrid)=0.
  do i=ngrid-1,1,-1
   int=0
   do j=ngrid-1,i+1,-1
   int=int+(fi(j)-fi(j+1))* &
       (ddrhodfi2(j)/sqrt(fi(i)-fi(j))+ddrhodfi2(j+1)/sqrt(fi(i)-fi(j+1)))/2.
   enddo
   int=int+2./3.*Sqrt((fi(i)-fi(i+1)))*(2*ddrhodfi2(i)+ddrhodfi2(i+1))
   df(i)=1/sqrt(8.)/pi**2*(int-1/sqrt(fi(i))*ddensdr(ngrid)*r(ngrid)**2/cmass(ngrid))
  enddo
  df(0)=df(1)
  

! print*,'rmax,fi0,cmass:', rmax,fi(0),cmass(ngrid)
 
 end subroutine
 
  function invertcumul(n,xlist,ylist,y) result(x)
  integer :: n,bin,up,low
  real :: xlist(n),ylist(n),x,y,u,s
  
  if(ylist(1).LT.ylist(n)) then
   s=1
  else
   s=-1
  endif  
  
  if(s*y.LE.s*ylist(1)) then
   x=xlist(1)
   return
  endif
  if(s*y.GE.s*ylist(n)) then
   x=xlist(n)
   return
  endif
  up=n
  low=1
  do while((up-low).GT.1)
   bin=(low+up)/2
   if(s*y.LT.s*ylist(bin)) then
    up=bin
   else
    low=bin
   endif   
  enddo 
  bin=up
  u=(y-ylist(bin-1))/(ylist(bin)-ylist(bin-1))
  x=(1-u)*xlist(bin-1)+u*xlist(bin)  
  return
  end function
 
end module sphericaldfMod

 real function zerofunc(r,z)
  zerofunc=0.
 end function

subroutine initsdf(rscl,rv,rhs,densfunc)
 use sphericaldfMod
 real rscl,rv,rhs
 real, external :: zerofunc
 real, optional,external :: densfunc

 if(present(densfunc)) then
  call initdf(densfunc,rscl,rv,rhs)
 else
  call initdf(zerofunc,rscl,rv,rhs)
 endif

end subroutine

function sdfpsi00()
 use sphericaldfMod
 real sdfpsi00
 sdfpsi00=-maxE() 
end function

function sdffi(r)
 use sphericaldfMod
 real sdffi,r
! r>rmax??
 sdffi=-fifromr(r)
end function

function Fhalo3(E)
 use sphericaldfMod
 real Fhalo3,E
 Fhalo3=0
 if(E.LT.0) return
 Fhalo3=halodf(E)
end function 

function sdfdenspsi(psi,psi0)
 use sphericaldfMod
  real sdfdenspsi,psi,rpsi
 sdfdenspsi=0
 rpsi=sdfpsi00()+psi-psi0
 if(rpsi.ge.0) return
 sdfdenspsi=rhofromfi(-rpsi)
! print*,rpsi,psi,maxE()
! stop
end function

 function sdens(r,z) 
  real r,z,sdens  
  real rmdisk,zdisk,outdisk,drtrunc,erfarg,truncfac,con,diskconst,rdisk
  zdisk=0.5
  rdisk=3
  rmdisk=50.
  diskconst=rmdisk/(4.0*3.1415*rdisk**2*zdisk)
  outdisk=12
  drtrunc=.5
  sdens = 0
  if( abs(z/zdisk) .gt. 30.) return
   erfarg=(r-outdisk)/1.4142136/drtrunc
  if (erfarg.gt.4.) return
  if (erfarg.lt.-4) then
   trunfac=1
  else
   trunfac=0.5*erfc(erfarg)
  endif
  if (z.eq.0.) then
   con=1
  else
   con = exp(-abs(z/zdisk))
   con = (2.0*con/(1.0 + con*con))**2
  endif
  sdens = diskconst*exp(-r/rdisk)*con*trunfac 
  end function

! program test
!  use sphericaldfMod
!  implicit none
!    integer i,j,np,count
!    real, external ::sdens,zerofunc
!  
!  call initdf(sdens,6.,72.,0.04)
!
!  do i=0,ngrid-1
!   print*,r(i),dens(i),ddensdr(i)
!   print*,r(i),extdens(i),extmass(i)
!   print*,r(i),fi(i),df(i)
!  enddo  
! end program
